'
' C source for GNU CHESS
'
' Revision: 1990-09-30
'
' Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
' Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
' Copyright (c) 1988, 1989, 1990  John Stanback
'
' This file is part of CHESS.
'
' CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY.  No author or distributor accepts responsibility to anyone for
' the consequences of using it or for whether it serves any particular
' purpose or works at all, unless he says so in writing.  Refer to the CHESS
' General Public License for full details.
'
' Everyone is granted permission to copy, modify and redistribute CHESS, but
' only under the conditions described in the CHESS General Public License.
' A copy of this license is supposed to have been given to you along with
' CHESS so you can know your rights and responsibilities.  It should be in a
' file named COPYING.  Among other things, the copyright notice and this
' notice must be preserved on all copies.
'

#INCLUDE <sys\types.h>
#INCLUDE <sys\stat.h>

CONST struct_hashval = struct hashval
CONST struct_leaf = struct leaf
CONST struct_GameRec = struct GameRec
CONST struct_hashentry = struct hashentry
CONST struct_flags = struct flags
CONST struct_TimeControlRec = struct TimeControlRec
CONST struct_PIECEBITMAP = struct PIECEBITMAP
CONST struct_BookEntry = struct BookEntry
!#define CEOF EOF

' All units defined in pixels

CONST BRD_HORZFRONT = 48
CONST BRD_HORZBACK = 32
CONST BRD_VERT = 32
CONST BRD_EDGE = 8
CONST BRD_HORZMARGIN = 32
CONST BRD_BACKMARGIN = 5
CONST BRD_FRONTMARGIN = 5

GLOBAL HilitSq  AS INTEGER
GLOBAL pieces[7] AS struct_PIECEBITMAP
GLOBAL hBrushBackGround  AS HBRUSH
GLOBAL Version[] = "BCX Conversion" AS CHAR
GLOBAL ghInst AS HANDLE                                     'current instance
GLOBAL szAppName[] = "Chess" AS CHAR
GLOBAL hBook AS GLOBALHANDLE
GLOBAL coords = 1 AS INTEGER

GLOBAL FirstSq = - 1  AS INTEGER                           'Flag is a square is selected
GLOBAL GotFirst = FALSE  AS INTEGER
GLOBAL EditActive = FALSE  AS INTEGER                      'Edit mode?
GLOBAL User_Move = TRUE  AS INTEGER                        'User or computer's turn

GLOBAL hMainMenu  AS HMENU
GLOBAL Running = TRUE AS BOOL

GLOBAL clrBackGround AS DWORD
GLOBAL clrBlackSquare AS DWORD
GLOBAL clrWhiteSquare AS DWORD
GLOBAL clrBlackPiece AS DWORD
GLOBAL clrWhitePiece AS DWORD
GLOBAL clrText AS DWORD

GLOBAL boarddraw[64] AS INTEGER                    'Display copies of the board
GLOBAL colordraw[64] AS INTEGER                    'Needed because while computer is calculating

#INCLUDE "gnuchess.h"
#INCLUDE "chess.h"
#INCLUDE "saveopen.h"
#INCLUDE "color.h"
#INCLUDE "stats.h"
#INCLUDE "timecnt.h"

$INCLUDE "ABOUT.bas"
$INCLUDE "BOARD.bas"
$INCLUDE "BOOK.bas"
$INCLUDE "color.bas"
$INCLUDE "CREATE.bas"
$INCLUDE "GLOBALS.bas"
$INCLUDE "DSP.bas"
$INCLUDE "EVAL.bas"
$INCLUDE "HITTEST.BAS"
$INCLUDE "INIT.BAS"
$INCLUDE "INITIALI.bas"
$INCLUDE "INITMENU.bas"
$INCLUDE "MSWDSP.bas"
$INCLUDE "NUMDLG.bas"
$INCLUDE "PIECE.bas"
$INCLUDE "PROMOTE.bas"
$INCLUDE "REVIEW.bas"
$INCLUDE "SAVEOPEN.bas"
$INCLUDE "SEARCH.bas"
$INCLUDE "STATS.bas"
$INCLUDE "TIMECNT.bas"


FUNCTION WinMain()
  DIM RAW hWnd AS HWND
  DIM RAW msg AS MSG
  DIM RAW pt AS POINT

  CmdLine++

  IF  NOT  hPrev THEN
    IF  NOT  ChessInit (hInst) THEN
      FUNCTION = (FALSE)
    END IF
  END IF
  ghInst = hInst                                           'Saves the current instance

  QueryBoardSize (&pt)

  ' Create the mailn window.  It will be autosized in WM_CREATE message
  hWnd = CreateWindow (szAppName, szAppName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInst, NULL)

  IF  NOT  hWnd THEN
    FUNCTION = FALSE
  END IF
  ShowWindow (hWnd, CmdShow)                              'Shows the window

  ' Initialize chess
  IF init_main (hWnd) THEN
    SMessageBox (hWnd, IDS_INITERROR, IDS_CHESS)
    FreeChessGlobals()
    FUNCTION = FALSE
  END IF
  UpdateWindow (hWnd)                                     'Sends WM_PAINT message

  player = opponent
  ShowSidetoMove ()

  WHILE GetMessage (&msg, NULL, 0, 0)
    TranslateMessage (&msg)
    DispatchMessage (&msg)
  WEND

  FUNCTION = (INTEGER) msg.wParam                       'Returns the value from PostQuitMessage
END FUNCTION

FUNCTION ChessWndProc (hWnd AS HWND, message AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK
  DIM RAW lpProcAbout AS FARPROC
  DIM RAW hMenu AS HMENU
  DIM RAW ps AS PAINTSTRUCT
  DIM RAW hDC AS HDC
  DIM RAW tm AS TEXTMETRIC
  DIM RAW i AS INTEGER
  DIM RAW point AS POINT
  DIM RAW pof AS OFSTRUCT
  DIM RAW FileName[256] AS char, sstr[80] AS char
  DIM RAW Status AS DWORD
  DIM RAW hFile AS HANDLE

  SELECT CASE message
  CASE WM_CREATE                                       'message: window being created
    DIM RAW xchar AS INTEGER, ychar AS INTEGER

    GetStartupColors (szAppName)

    hBrushBackGround = CreateSolidBrush (clrBackGround)

    i = pawn
    WHILE i<pawn+6
      pieces[i] .piece = LoadBitmap (ghInst, MAKEINTRESOURCE (PAWNBASE + i))
      i++
    WEND
    i = pawn
    WHILE i<pawn+6
      pieces[i] .mask = LoadBitmap (ghInst, MAKEINTRESOURCE (PAWNBASE + 6 + i))
      i++
    WEND
    i = pawn
    WHILE i<pawn+6
      pieces[i] .outline = LoadBitmap (ghInst, MAKEINTRESOURCE (PAWNBASE + 12 + i))
      i++
    WEND


    hDC = GetDC (hWnd)
    GetTextMetrics (hDC, &tm)
    xchar = tm.tmMaxCharWidth
    ychar = tm.tmHeight + tm.tmExternalLeading

    'Autosize main window
    QueryBoardSize (&point)
    SetWindowPos (hWnd, hWnd, 0, 0, point.x + GetSystemMetrics (SM_CXFRAME) *2 + 50, point.y + GetSystemMetrics (SM_CYFRAME) *2 + GetSystemMetrics (SM_CYMENU) + GetSystemMetrics (SM_CYCAPTION) + ychar, SWP_NOMOVE BOR SWP_NOZORDER)

    ReleaseDC (hWnd, hDC)

    InitHitTest ()
    Create_Children (hWnd, ghInst, xchar, ychar)

    '  message: window being destroyed
  CASE WM_DESTROY
    DeleteObject (hBrushBackGround)
    Hittest_Destructor ()
    IF hBook THEN
      FreeBook ()
    END IF
    FreeChessGlobals()
    SaveColors (szAppName)
    Running = FALSE
    PostQuitMessage (0)

  CASE WM_PAINT                                        'Properly repaint hilighted square
    IF FirstSq <> - 1 THEN
      DIM RAW pt AS POINT
      DIM RAW rect AS RECT
      QuerySqOrigin (FirstSq % 8, FirstSq / 8, &pt)
      rect.left = pt.x : rect.right = pt.x + 48
      rect.top = pt.y - 48 : rect.bottom = pt.y
      InvalidateRect (hWnd, &rect, FALSE)
    END IF
    hDC = BeginPaint (hWnd, &ps)
    Draw_Board (hDC, flag.reverse, clrBlackSquare, clrWhiteSquare)
    IF coords THEN
      DrawCoords (hDC, flag.reverse, clrBackGround, clrText)
    END IF
    DrawAllPieces (hDC, flag.reverse, boarddraw, colordraw, clrBlackPiece, clrWhitePiece)
    EndPaint (hWnd, &ps)

    IF FirstSq <> - 1 THEN
      HiliteSquare (hWnd, FirstSq)
    END IF

    ' Enable setting colors for the message controls
  CASE WM_CTLCOLORSTATIC
    DIM RAW point AS POINT

    ' UnrealizeObject ( hBrushBackGround );   ***KENT***
    SetBkColor ((HDC) wParam, clrBackGround)
    SetBkMode ((HDC) wParam, TRANSPARENT)
    SetTextColor ((HDC) wParam, clrText)
    point.x = point.y = 0
    ClientToScreen (hWnd, &point)
    SetBrushOrgEx ((HDC) wParam, point.x, point.y, &point)
    FUNCTION = ((LONG) hBrushBackGround)


  CASE WM_ERASEBKGND
    DIM RAW rect AS RECT
    ' UnrealizeObject ( hBrushBackGround);   ***KENT***
    GetClientRect (hWnd, &rect)
    FillRect ((HDC) wParam, &rect, hBrushBackGround)
    FUNCTION = 1

  CASE WM_INITMENUPOPUP                                'Abort thinklook ahead
    IF User_Move THEN
      flag.timeout = TRUE
      flag.bothsides = FALSE
    END IF
    IF  NOT  EditActive THEN
      Init_Menus (hWnd, wParam, lParam)
    END IF


	' If computer is thinking on human's time stop it at the first
	'	button click.  add test to ensure that "human" can't interupt
	'	the computer from thinking through its turn
  CASE WM_LBUTTONDOWN
    IF User_Move THEN
      flag.timeout = TRUE
      flag.bothsides = FALSE
    END IF
    ' Don't continue unless reason to
    IF  NOT  (EditActive  OR  User_Move) THEN
      EXIT LOOP
    END IF
    point.x = LOWORD (lParam)
    point.y = HIWORD (lParam)
    DIM RAW Hit AS INTEGER

    Hit = HitTest (point.x, point.y)

    IF Hit = - 1 THEN
      IF FirstSq <> - 1 THEN
        UnHiliteSquare (hWnd, FirstSq)
        GotFirst = FALSE
        FirstSq = - 1
      END IF
      EXIT LOOP
    END IF
    IF GotFirst THEN
      UnHiliteSquare (hWnd, FirstSq)
      GotFirst = FALSE

      IF EditActive = TRUE THEN
        PostMessage (hWnd, MSG_EDITBOARD, ((FirstSq < < 8) |Hit), (LONG) NULL)
      ELSEIF User_Move = TRUE THEN
        PostMessage (hWnd, MSG_USER_ENTERED_MOVE, ((FirstSq < < 8) |Hit), (LONG) NULL)
      END IF
      FirstSq = - 1
    ELSE
      GotFirst = TRUE
      FirstSq = Hit
      HiliteSquare (hWnd, Hit)
    END IF

  CASE MSG_EDITBOARD
    DIM RAW Square AS INTEGER, First AS INTEGER

    IF flag.reverse THEN
      First = 63 - ((wParam > > 8) &0xff)
      Square = 63 - (wParam BAND 0xff)
    ELSE
      First = (wParam > > 8) &0xff
      Square = wParam BAND 0xff
    END IF
    board[Square] = board[First]
    cColor[Square] = cColor[First]

    board[First] = no_piece
    cColor[First] = neutral

    UpdateDisplay (hWnd, First, Square, FALSE, FALSE)

  CASE MSG_USER_MOVE
    IF flag.bothsides AND  NOT  flag.mate THEN
      SelectMove (hWnd, opponent, 1)
      IF flag.beep THEN
        MessageBeep (0)
      END IF
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)
    ELSEIF  NOT  flag.mate THEN
      User_Move = TRUE

      ft = 0
      player = opponent
      ShowSidetoMove ()
      ' Set up to allow computer to think while user takes move
      DIM RAW tmp AS INTEGER
      DIM RAW  mv AS UINT
      DIM RAW s[10] AS char
      IF hint > 0  AND   NOT  flag.easy  AND  Book = NULL THEN
        time0 = time (NULL)
        algbr (hint >> 8, hint BAND 0xff, FALSE)
        lstrcpy (s, mvstr[0])
        tmp = epsquare
        IF VerifyMove (hWnd, s, 1, &mv) THEN
          SelectMove (hWnd, computer, 2)
          VerifyMove (hWnd, mvstr[0], 2, &mv)
          IF Sdepth > 0 THEN
            Sdepth--
          END IF
        END IF
        ft = time (NULL) - time0
        epsquare = tmp
      END IF
    END IF

  CASE MSG_USER_ENTERED_MOVE
    DIM RAW temp AS INTEGER
    DIM RAW mv AS UINT
    DIM RAW Square AS INTEGER
    DIM RAW First AS INTEGER
    DIM RAW s[10] AS CHAR
    DIM RAW algbr_flag AS INTEGER
    User_Move = FALSE
    player = opponent

    ' Fix coord's if user "reversed" board
    IF flag.reverse THEN
      First = 63 - ((wParam >> 8) BAND 0xff)
      Square = 63 - (wParam BAND 0xff)
    ELSE
      First = (wParam >> 8) BAND 0xff
      Square = wParam BAND 0xff
    END IF
    ' Logic to allow selection for pawn promotion
    IF (board[First] = pawn)  AND  ((Square < 8)  OR  (Square > 55)) THEN
      algbr_flag = promote + PromoteDialog (hWnd, ghInst)
    ELSE
      algbr_flag = 0
    END IF
    algbr (First, Square, algbr_flag)
		
    strcpy (s, mvstr[0])

    temp = VerifyMove (hWnd, s, 0, &mv)
    IF temp  AND  (mv <> hint) THEN
      Sdepth = 0
      ft = 0
      ElapsedTime (1)
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)
    ELSEIF temp = TRUE THEN
      ElapsedTime (1)
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)
    ELSE
      PostMessage (hWnd, MSG_USER_MOVE, (UINT) NULL, (long) NULL)
    END IF

  CASE MSG_COMPUTER_MOVE
    IF  NOT  (flag.quit  OR  flag.mate  OR  flag.force) THEN
      SelectMove (hWnd, computer, 1)
      IF flag.beep THEN
        MessageBeep (0)
      END IF
    END IF
    PostMessage (hWnd, MSG_USER_MOVE, (UINT) NULL, (long) NULL)

    ' Menu item processing
  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))
    CASE MSG_CHESS_QUIT
      DestroyWindow (hWnd)

    CASE MSG_CHESS_HINT
      GiveHint (hWnd)

    CASE MSG_CHESS_LIST
      IF  NOT  DoFileSaveDlg (ghInst, hWnd, "chess.lst", ".lst", &Status, FileName, &pof) THEN
        EXIT LOOP
      END IF
      IF Status = 1 THEN
        strcpy (sstr, "Replace Existing ")
        strcat (sstr, FileName)
        IF MessageBox (hWnd, sstr, szAppName, MB_YESNO BOR MB_ICONQUESTION BOR MB_APPLMODAL) = IDNO THEN
          EXIT LOOP
        END IF
      ELSE
        OpenFile (FileName, &pof, OF_PARSE)
      END IF
      ListGame (hWnd, pof.szPathName)

    CASE MSG_CHESS_SAVE
      IF  NOT  DoFileSaveDlg (ghInst, hWnd, "chess.chs", ".chs", &Status, FileName, &pof) THEN
        EXIT LOOP
      END IF
      IF Status = 1 THEN
        strcpy (sstr, "Replace Existing ")
        strcat (sstr, FileName)
        IF MessageBox (hWnd, sstr, szAppName, MB_YESNO BOR MB_ICONQUESTION BOR MB_APPLMODAL) = IDNO THEN
          EXIT LOOP
        END IF
      ELSE
        OpenFile (FileName, &pof, OF_PARSE)
      END IF
      SaveGame (hWnd, pof.szPathName)

    CASE MSG_CHESS_GET
      IF  NOT  DoFileOpenDlg (ghInst, hWnd, "*.chs", ".chs", 0x0, FileName, &pof) THEN
        EXIT LOOP
      END IF
      hFile = (HANDLE) ((LONG) OpenFile (FileName , &pof , (WORD) OF_READ BOR OF_REOPEN))
      IF hFile = ((HANDLE) - 1) THEN
        strcpy (sstr, "Cannot open file: ")
        strcat (sstr, FileName)
        MessageBox (hWnd, sstr, szAppName, MB_OK BOR MB_APPLMODAL BOR MB_ICONQUESTION)
        EXIT LOOP
      END IF
      CloseHandle (hFile)
      GetGame (hWnd, pof.szPathName)

    CASE MSG_CHESS_NEW
      NewGame (hWnd)
      IF hBook THEN
        FreeBook ()
      END IF
      GetOpenings (hWnd)

    CASE MSG_CHESS_ABOUT
      lpProcAbout = (FARPROC) MakeProcInstance (About, ghInst)
      DialogBox (ghInst, MAKEINTRESOURCE (AboutBox), hWnd, (DLGPROC) lpProcAbout)
      FreeProcInstance (lpProcAbout)

    CASE MSG_CHESS_EDIT
      EditActive = TRUE
      hMenu = CreateMenu ()
      AppendMenu (hMenu, MF_STRING, MSG_CHESS_EDITDONE, "&Done")
      hMainMenu = GetMenu (hWnd)
      SetMenu (hWnd, hMenu)
      DrawMenuBar (hWnd)

    CASE MSG_CHESS_EDITDONE
      EditActive = FALSE
      hMenu = GetMenu (hWnd)
      SetMenu (hWnd, hMainMenu)
      DrawMenuBar (hWnd)
      DestroyMenu (hMenu)
      GameCnt = 0
      Game50 = 1
      ZeroRPT ()
      Sdepth = 0
      InitializeStats ()
      PostMessage (hWnd, MSG_USER_MOVE, (UINT) NULL, (long) NULL)

    CASE MSG_CHESS_REVIEW
      ReviewDialog (hWnd, ghInst)

    CASE MSG_CHESS_HASH
      flag.hash =  NOT  flag.hash

    CASE MSG_CHESS_BEEP
      flag.beep =  NOT  flag.beep

    CASE MSG_CHESS_COORD
      coords =  NOT  coords
      UpdateDisplay (hWnd, 0, 0, 1, 0)

    CASE MSG_CHESS_BOTH
      flag.bothsides =  NOT  flag.bothsides
      flag.easy = TRUE
      Sdepth = 0
      PostMessage (hWnd, MSG_USER_MOVE, (UINT) NULL, (long) NULL)

    CASE MSG_CHESS_BOOK
      IF Book <> NULL THEN
        FreeBook ()
        Book = NULL
      END IF

    CASE MSG_CHESS_POST
      IF flag.post THEN
        SendMessage (hStats, WM_SYSCOMMAND, SC_CLOSE, 0)
        flag.post = FALSE
      ELSE
        StatDialog (hWnd, ghInst)
        flag.post = TRUE
      END IF

    CASE MSG_CHESS_AWIN
      DIM RAW sstr[40] AS char
      LoadString ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), IDS_SETAWIN, sstr, SIZEOF (sstr)), Awindow = DoGetNumberDlg (ghInst, hWnd, sstr, Awindow)

    CASE MSG_CHESS_BWIN
      DIM RAW sstr[40] AS char
      LoadString ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), IDS_SETBWIN, sstr, SIZEOF (sstr)), Bwindow = DoGetNumberDlg (ghInst, hWnd, sstr, Bwindow)

    CASE MSG_CHESS_CONTEMP
      DIM RAW sstr[40] AS char
      LoadString ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), IDS_SETCONTEMPT, sstr, SIZEOF (sstr))
      contempt = DoGetNumberDlg (ghInst, hWnd, sstr, contempt)

    CASE MSG_CHESS_UNDO
      IF GameCnt > 0 THEN
        Undo (hWnd)
      END IF

    CASE MSG_CHESS_REMOVE
      IF GameCnt > 1 THEN
        Undo (hWnd)
        Undo (hWnd)
      END IF

    CASE MSG_CHESS_FORCE
      computer = opponent
      opponent = otherside[computer]
      ShowPlayers ()
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)

    CASE MSG_CHESS_RANDOM
      IF dither = 0 THEN
        dither = 6
      ELSE
        dither = 0
      END IF

    CASE MSG_CHESS_EASY
      flag.easy =  NOT  flag.easy

    CASE MSG_CHESS_DEPTH
      DIM RAW sstr[40] AS char
      LoadString ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), IDS_MAXSEARCH, sstr, SIZEOF (sstr))
      MaxSearchDepth = DoGetNumberDlg (ghInst, hWnd, sstr, MaxSearchDepth)

    CASE MSG_CHESS_REVERSE
      flag.reverse =  NOT  flag.reverse
      ShowPlayers ()
      UpdateDisplay (hWnd, 0, 0, 1, 0)

    CASE MSG_CHESS_SWITCH
      computer = otherside[computer]
      opponent = otherside[opponent]
      flag.force = FALSE
      Sdepth = 0
      ShowPlayers ()
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)

    CASE MSG_CHESS_BLACK
      computer = black
      opponent = white
      flag.force = FALSE
      Sdepth = 0
      ShowPlayers ()
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)

    CASE MSG_CHESS_WHITE
      computer = white
      opponent = black
      flag.force = FALSE
      Sdepth = 0
      ShowPlayers ()
      PostMessage (hWnd, MSG_COMPUTER_MOVE, (UINT) NULL, (long) NULL)

    CASE MSG_CHESS_ABORT
      flag.timeout = TRUE
      flag.bothsides = FALSE
      EnableMenuItem (GetMenu (hWnd), MENU_ID_ABORT, MF_GRAYED BOR MF_DISABLED BOR MF_BYPOSITION)
      DrawMenuBar (hWnd)

    CASE IDM_BACKGROUND
      IF ColorDialog (hWnd, ghInst, wParam) THEN
        InvalidateRect (hWnd, NULL, TRUE)
        DeleteObject (hBrushBackGround)
        hBrushBackGround = CreateSolidBrush (clrBackGround)

        'Invalidate the text windows so they repaint
        InvalidateRect (hComputerColor, NULL, TRUE)
        InvalidateRect (hComputerMove, NULL, TRUE)
        InvalidateRect (hWhosTurn, NULL, TRUE)
        InvalidateRect (hClockHuman, NULL, TRUE)
        InvalidateRect (hClockComputer, NULL, TRUE)
        InvalidateRect (hMsgComputer, NULL, TRUE)
        InvalidateRect (hMsgHuman, NULL, TRUE)
      END IF

    CASE IDM_BLACKSQUARE
      IF ColorDialog (hWnd, ghInst, wParam) THEN
        InvalidateRect (hWnd, NULL, TRUE)
      END IF

    CASE IDM_WHITESQUARE
      IF ColorDialog (hWnd, ghInst, wParam) THEN
        InvalidateRect (hWnd, NULL, TRUE)
      END IF

    CASE IDM_BLACKPIECE
      IF ColorDialog (hWnd, ghInst, wParam) THEN
        InvalidateRect (hWnd, NULL, TRUE)
      END IF

    CASE IDM_WHITEPIECE
      IF ColorDialog (hWnd, ghInst, wParam) THEN
        InvalidateRect (hWnd, NULL, TRUE)
      END IF

    CASE IDM_TEXT
      IF ColorDialog (hWnd, ghInst, wParam) THEN
        'Invalidate the text windows so they repaint
        InvalidateRect (hWnd, NULL, TRUE)
        InvalidateRect (hComputerColor, NULL, TRUE)
        InvalidateRect (hComputerMove, NULL, TRUE)
        InvalidateRect (hWhosTurn, NULL, TRUE)
        InvalidateRect (hClockHuman, NULL, TRUE)
        InvalidateRect (hClockComputer, NULL, TRUE)
        InvalidateRect (hMsgComputer, NULL, TRUE)
        InvalidateRect (hMsgHuman, NULL, TRUE)
      END IF

    CASE IDM_DEFAULT
      SetStandardColors ()
      InvalidateRect (hWnd, NULL, TRUE)
      DeleteObject (hBrushBackGround)
      hBrushBackGround = CreateSolidBrush (clrBackGround)

      'Invalidate the text windows so they repaint
      InvalidateRect (hComputerColor, NULL, TRUE)
      InvalidateRect (hComputerMove, NULL, TRUE)
      InvalidateRect (hWhosTurn, NULL, TRUE)
      InvalidateRect (hClockHuman, NULL, TRUE)
      InvalidateRect (hClockComputer, NULL, TRUE)
      InvalidateRect (hMsgComputer, NULL, TRUE)
      InvalidateRect (hMsgHuman, NULL, TRUE)

    CASE IDM_TIMECONTROL
      IF TimeControlDialog (hWnd, ghInst, wParam) THEN
        TCflag = (TCmoves > 1)
        IF TCflag THEN
          'Do nothing...
        END IF
        SetTimeControl ()
      END IF
    END SELECT
  END SELECT

  FUNCTION = DefWindowProc (hWnd, message, wParam, lParam)
END FUNCTION

