'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
'Copyright (c) 1988, 1989, 1990  John Stanback
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'

GLOBAL book_used = 0  AS UINT
GLOBAL xBook  AS char PTR

SUB FreeBook ()
  GlobalUnlock (hBook)
  GlobalFree (hBook)
  hBook = 0
  book_used = 0
END SUB

FUNCTION Book_alloc (size AS UINT) AS void PTR
  DIM RAW temp AS char PTR
  IF book_used > 32 *1024 THEN
    FUNCTION = (void *) 0
  END IF
  temp = xBook + book_used
  book_used + = size
  FUNCTION = temp
END SUB

'
'Read in the Opening Book file and parse the algebraic notation for a move
'into an unsigned integer format indicating the from and to square. Create
'a linked list of opening lines of play, with entry->next pointing to the
'next line and entry->move pointing to a chunk of memory containing the
'moves. More Opening lines of up to 256 half moves may be added to
'gnuchess.book.
'
SUB GetOpenings (hWnd AS HWND)
  DIM RAW fd AS FILE PTR
  DIM RAW c AS INTEGER, i AS INTEGER, j AS INTEGER, side AS INTEGER
  '! struct BookEntry FAR  *entry;
  DIM RAW entry AS struct_BookEntry PTR
  DIM RAW mv AS UINT, mp AS UINT PTR, tmp[100] AS UINT
  DIM RAW lpFile[MAX_PATH + 1 + MAX_PATH + 1 + MAX_PATH + 1 + MAX_PATH + 1] AS char
  DIM RAW sFname[MAX_PATH + 1] AS char, sExt[MAX_PATH + 1] AS char, sDrive[MAX_PATH + 1] AS char, sDir[MAX_PATH + 1] AS char

  GetModuleFileName ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), lpFile, SIZEOF (lpFile))

  _splitpath (lpFile, sDrive, sDir, sFname, sExt)
  sprintf (lpFile, "%s%s%s.%s", sDrive, sDir, "gnuchess.book", "txt")
  fd = fopen (lpFile, "r")
  IF fd <> NULL THEN
    hBook = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (32 *1024 *SIZEOF (char)))

    IF hBook = NULL THEN
      Book = NULL
      SMessageBox (hWnd, IDS_OBAE, IDS_CHESS)
      EXIT SUB
    END IF
    xBook = (char *) GlobalLock (hBook)

    Book = NULL
    i = 0
    side = white
    
    c = parse (fd, &mv, side)

    WHILE c >= 0
      IF c = 1 THEN
        tmp[++i] = mv
        side = otherside[side]
      ELSEIF c = 0  AND  i > 0 THEN
        entry = (struct_BookEntry *) Book_alloc (SIZEOF (struct_BookEntry))
        mp = (UINT *) Book_alloc ((i + 1) *SIZEOF (UINT))
        IF (entry = 0)  OR  (mp = 0) THEN
          Book = NULL
          SMessageBox (hWnd, IDS_OBAE, IDS_CHESS)
          GlobalUnlock (hBook)
          GlobalFree (hBook)
          EXIT SUB
        END IF
        entry->mv = mp
        entry->nnext = Book
        Book = entry
        j = 1
        WHILE j<=i
          *(mp++) = tmp[j]
          j++
        WEND
        *mp = 0
        i = 0
        side = white
      END IF
      c = parse (fd, &mv, side)
    WEND
    fclose (fd)
  ELSE
    SMessageBox (hWnd, IDS_OBNF, IDS_CHESS)
  END IF
END SUB

'
'Go thru each of the opening lines of play and check for a match with the
'current game listing. If a match occurs, generate a random number. If this
'number is the largest generated so far then the next move in this line
'becomes the current "candidate". After all lines are checked, the
'candidate move is put at the top of the Tree[] array and will be played by
'the program. Note that the program does not handle book transpositions.
'

SUB OpeningBook (hint AS UINT PTR)
  DIM RAW j AS INTEGER, pnt AS INTEGER
  DIM RAW m AS UINT, mp AS UINT PTR
  DIM RAW r AS UINT, r0 AS UINT
  DIM RAW p AS struct_BookEntry PTR

  srand ((UINT) time ((time_t *) 0))
  r0 = m = 0
  p = Book

  WHILE p <> NULL
    mp = p->mv
    j = 1

    WHILE j<=GameCnt

      IF GameList[j] .gmove <> *(mp++) THEN
        EXIT LOOP
      END IF
      j++
    WEND

    IF j > GameCnt THEN
      r = urand ()
      IF r > r0 THEN
        r0 = r
        m = *mp
        *hint = *(++mp)
      END IF
    END IF
    p = p->nnext
  WEND

  pnt = TrPnt [1]
  WHILE pnt<TrPnt[2]
    IF ((Tree[pnt].f << 8) BOR Tree[pnt].t) = (INTEGER) m THEN
      Tree[pnt] .score = 0
    END IF
    pnt++
  WEND

  pick (TrPnt[1], TrPnt[2] - 1)

  IF Tree[TrPnt[1]].score < 0 THEN
    FreeBook ()
    Book = NULL
  END IF
END SUB
