'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Based on Ideas and code segments of Charles Petzold from artices in
'MicroSoft Systems Journal.
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'


$HEADER
#define CBLACK RGB ( 0 , 0 , 0 )
#define BLUE RGB ( 0 , 0 , 255 )
#define GREEN RGB ( 0 , 255 , 0 )
#define CYAN RGB ( 128 , 255 , 255 )
#define RED RGB ( 255 , 0 , 0 )
#define PINK RGB ( 255 , 0 , 255 )
#define YELLOW RGB ( 255 , 255 , 0 )
#define PALEGRAY RGB ( 192 , 192 , 192 )
#define DARKGRAY RGB ( 127 , 127 , 127 )
#define DARKBLUE RGB ( 0 , 0 , 128 )
#define DARKGREEN RGB ( 0 , 128 , 0 )
#define DARKCYAN RGB ( 0 , 255 , 255 )
#define DARKRED RGB ( 128 , 0 , 0 )
#define DARKPINK RGB ( 255 , 0 , 128 )
#define BROWN RGB ( 128 , 128 , 64 )
#define CWHITE RGB ( 255 , 255 , 255 )
$HEADER



SUB SetStandardColors ()
  clrBackGround = BROWN
  clrBlackSquare = DARKGREEN
  clrWhiteSquare = PALEGRAY
  clrBlackPiece = RED
  clrWhitePiece = CWHITE
  clrText = CBLACK
END SUB


SHAREDSET lpChessini [ ] AS char
  "chess.ini"
END SET
SHAREDSET lpBackGround [ ] AS char
  "BackGround"
END SET
SHAREDSET lpBlackSquare [ ] AS char
  "BlackSquare"
END SET
SHAREDSET lpWhiteSquare [ ] AS char
  "WhiteSquare"
END SET
SHAREDSET lpBlackPiece [ ] AS char
  "BlackPiece"
END SET
SHAREDSET lpWhitePiece [ ] AS char
  "WhitePiece"
END SET
SHAREDSET lpDefault [ ] AS char
  "Default"
END SET
SHAREDSET lpText [ ] AS char
  "Text"
END SET

SHAREDSET np08lX [ ] AS char
  "%08lX"
END SET

SUB SaveColors (appname AS LPSTR)
  DIM RAW ostring[30] AS char

  wsprintf (ostring, np08lX, clrBackGround)
  WritePrivateProfileString (appname, lpBackGround, ostring, lpChessini)

  wsprintf (ostring, np08lX, clrBlackSquare)
  WritePrivateProfileString (appname, lpBlackSquare, ostring, lpChessini)

  wsprintf (ostring, np08lX, clrWhiteSquare)
  WritePrivateProfileString (appname, lpWhiteSquare, ostring, lpChessini)

  wsprintf (ostring, np08lX, clrBlackPiece)
  WritePrivateProfileString (appname, lpBlackPiece, ostring, lpChessini)

  wsprintf (ostring, np08lX, clrWhitePiece)
  WritePrivateProfileString (appname, lpWhitePiece, ostring, lpChessini)

  wsprintf (ostring, np08lX, clrText)
  WritePrivateProfileString (appname, lpText, ostring, lpChessini)
END SUB

SUB GetStartupColors (appname AS LPSTR)
  DIM RAW istring[30] AS char

  SetStandardColors ()

  GetPrivateProfileString (appname, lpBackGround, lpDefault, istring, SIZEOF (istring), lpChessini)
  IF strcmp (istring, lpDefault) <> 0 THEN
    sscanf (istring, np08lX, &clrBackGround)
  END IF
  GetPrivateProfileString (appname, lpBlackSquare, lpDefault, istring, SIZEOF (istring), lpChessini)
  IF strcmp (istring, lpDefault) <> 0 THEN
    sscanf (istring, np08lX, &clrBlackSquare)
  END IF
  GetPrivateProfileString (appname, lpWhiteSquare, lpDefault, istring, SIZEOF (istring), lpChessini)
  IF strcmp (istring, lpDefault) <> 0 THEN
    sscanf (istring, np08lX, &clrWhiteSquare)
  END IF
  GetPrivateProfileString (appname, lpBlackPiece, lpDefault, istring, SIZEOF (istring), lpChessini)
  IF strcmp (istring, lpDefault) <> 0 THEN
    sscanf (istring, np08lX, &clrBlackPiece)
  END IF
  GetPrivateProfileString (appname, lpWhitePiece, lpDefault, istring, SIZEOF (istring), lpChessini)
  IF strcmp (istring, lpDefault) <> 0 THEN
    sscanf (istring, np08lX, &clrWhitePiece)
  END IF
  GetPrivateProfileString (appname, lpText, lpDefault, istring, SIZEOF (istring), lpChessini)
  IF strcmp (istring, lpDefault) <> 0 THEN
    sscanf (istring, np08lX, &clrText)
  END IF
END SUB


FUNCTION ColorDialog (hWnd AS HWND, hInst AS HANDLE, Param AS DWORD) AS INTEGER
  DIM RAW lpProcColor AS FARPROC
  DIM RAW status AS INTEGER

  lpProcColor = (FARPROC) MakeProcInstance (ColorDlgProc, hInst)
  status = DialogBoxParam (hInst, MAKEINTRESOURCE (COOLOR), hWnd, (DLGPROC) lpProcColor, Param)
  FreeProcInstance (lpProcColor)
  FUNCTION = status
END FUNCTION

FUNCTION ColorToIndex (ccolor AS DWORD) AS INTEGER
  IF ccolor = CBLACK THEN
    FUNCTION = CNT_BLACK
  ELSEIF ccolor = BLUE THEN
    FUNCTION = CNT_BLUE
  ELSEIF ccolor = GREEN THEN
    FUNCTION = CNT_GREEN
  ELSEIF ccolor = CYAN THEN
    FUNCTION = CNT_CYAN
  ELSEIF ccolor = RED THEN
    FUNCTION = CNT_RED
  ELSEIF ccolor = PINK THEN
    FUNCTION = CNT_PINK
  ELSEIF ccolor = YELLOW THEN
    FUNCTION = CNT_YELLOW
  ELSEIF ccolor = PALEGRAY THEN
    FUNCTION = CNT_PALEGRAY
  ELSEIF ccolor = DARKGRAY THEN
    FUNCTION = CNT_DARKGRAY
  ELSEIF ccolor = DARKBLUE THEN
    FUNCTION = CNT_DARKBLUE
  ELSEIF ccolor = DARKGREEN THEN
    FUNCTION = CNT_DARKGREEN
  ELSEIF ccolor = DARKCYAN THEN
    FUNCTION = CNT_DARKCYAN
  ELSEIF ccolor = DARKRED THEN
    FUNCTION = CNT_DARKRED
  ELSEIF ccolor = DARKPINK THEN
    FUNCTION = CNT_DARKPINK
  ELSEIF ccolor = BROWN THEN
    FUNCTION = CNT_BROWN
  ELSEIF ccolor = CWHITE THEN
    FUNCTION = CNT_WHITE
  END IF
  FUNCTION = CNT_WHITE
END FUNCTION

FUNCTION IndexToColor (ccolor AS INTEGER) AS DWORD
  IF ccolor = CNT_BLACK THEN
    FUNCTION = CBLACK
  ELSEIF ccolor = CNT_BLUE THEN
    FUNCTION = BLUE
  ELSEIF ccolor = CNT_GREEN THEN
    FUNCTION = GREEN
  ELSEIF ccolor = CNT_CYAN THEN
    FUNCTION = CYAN
  ELSEIF ccolor = CNT_RED THEN
    FUNCTION = RED
  ELSEIF ccolor = CNT_PINK THEN
    FUNCTION = PINK
  ELSEIF ccolor = CNT_YELLOW THEN
    FUNCTION = YELLOW
  ELSEIF ccolor = CNT_PALEGRAY THEN
    FUNCTION = PALEGRAY
  ELSEIF ccolor = CNT_DARKGRAY THEN
    FUNCTION = DARKGRAY
  ELSEIF ccolor = CNT_DARKBLUE THEN
    FUNCTION = DARKBLUE
  ELSEIF ccolor = CNT_DARKGREEN THEN
    FUNCTION = DARKGREEN
  ELSEIF ccolor = CNT_DARKCYAN THEN
    FUNCTION = DARKCYAN
  ELSEIF ccolor = CNT_DARKRED THEN
    FUNCTION = DARKRED
  ELSEIF ccolor = CNT_DARKPINK THEN
    FUNCTION = DARKPINK
  ELSEIF ccolor = CNT_BROWN THEN
    FUNCTION = BROWN
  ELSEIF ccolor = CNT_WHITE THEN
    FUNCTION = CWHITE
  END IF
  FUNCTION = RGB (255, 0, 0)
END FUNCTION

SHAREDSET lpWBGC [ ] AS char
  "Window background color"
END SET
SHAREDSET lpBS [ ] AS char
  "Black square color"
END SET
SHAREDSET lpWS [ ] AS char
  "White square color"
END SET
SHAREDSET lpBP [ ] AS char
  "Black piece color"
END SET
SHAREDSET lpWP [ ] AS char
  "White piece color"
END SET
SHAREDSET lpTX [ ] AS char
  "Text color"
END SET

STATIC pclr AS DWORD PTR
STATIC index AS INTEGER

FUNCTION ColorDlgProc (hDlg AS HWND, message AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK
  DIM RAW pchHeading AS char PTR

  SELECT CASE (message)
    '  message: initialize dialog box
  CASE WM_INITDIALOG
    SELECT CASE (lParam)
    CASE ELSE, IDM_BACKGROUND
      pchHeading = (char *) lpWBGC
      pclr = &clrBackGround

    CASE IDM_BLACKSQUARE
      pchHeading = (char *) lpBS
      pclr = &clrBlackSquare

    CASE IDM_WHITESQUARE
      pchHeading = (char *) lpWS
      pclr = &clrWhiteSquare

    CASE IDM_BLACKPIECE
      pchHeading = (char *) lpBP
      pclr = &clrBlackPiece

    CASE IDM_WHITEPIECE
      pchHeading = (char *) lpWP
      pclr = &clrWhitePiece

    CASE IDM_TEXT
      pchHeading = (char *) lpTX
      pclr = &clrText
    END SELECT

    SetDlgItemText (hDlg, IDD_HEADING, pchHeading)
    index = ColorToIndex (*pclr)
    CheckRadioButton (hDlg, CNT_BLACK, CNT_WHITE, index)
    FUNCTION = TRUE

    '  message: received a command
  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))

    CASE IDD_OK
      EndDialog (hDlg, 1)
      *pclr = IndexToColor (index)
      FUNCTION = TRUE

    CASE IDD_CANCEL
      EndDialog (hDlg, (INTEGER) NULL)
      FUNCTION = TRUE

    CASE CNT_BLACK, CNT_BLUE, CNT_GREEN, CNT_CYAN, CNT_RED, CNT_PINK, CNT_YELLOW, CNT_PALEGRAY, CNT_DARKGRAY, CNT_DARKBLUE, CNT_DARKGREEN, CNT_DARKCYAN, CNT_DARKRED, CNT_DARKPINK, CNT_BROWN, CNT_WHITE
      index = wParam
      CheckRadioButton (hDlg, CNT_BLACK, CNT_WHITE, index)
    END SELECT
  END SELECT

  FUNCTION = FALSE                                      'Didn't process a message
END FUNCTION
