'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
'Copyright (c) 1988, 1989, 1990  John Stanback
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'

GLOBAL mycntl1 AS INTEGER, mycntl2 AS INTEGER
GLOBAL mvstr[4][6] AS CHAR
GLOBAL evrate AS LONG

CONST pxx = " PNBRQK"
CONST qxx = " pnbrqk"


SUB Initialize ()
  mycntl1 = mycntl2 = 0
END SUB

SUB ExitChess ()

END SUB

SUB Die (Sig AS INTEGER)
  UNREFERENCED_PARAMETER (Sig)
END SUB

SUB TerminateSearch (Sig AS INTEGER)
  UNREFERENCED_PARAMETER (Sig)

  flag.timeout = true
  flag.bothsides = false
END SUB


'
'Generate move strings in different formats.
'
SUB algbr (f AS INTEGER, t AS INTEGER, flag AS INTEGER)
  DIM RAW m3p AS INTEGER

  IF f <> t THEN
    ' algebraic notation
    mvstr[0][0] = (char) (ASC("a") + column (f))
    mvstr[0][1] = (char) (ASC("1") + row (f))
    mvstr[0][2] = (char) (ASC("a") + column (t))
    mvstr[0][3] = (char) (ASC("1") + row (t))
    mvstr[0][4] = mvstr[3][0] = 0
    mvstr [ 1 ] [ 0 ] = pxx [ board [ f ] ]
    IF mvstr[1][0] = ASC("P") THEN
      ' pawn did not eat
      IF mvstr[0][0] = mvstr[0][2] THEN
        mvstr[2][0] = mvstr[1][0] = mvstr[0][2]        'to column
        mvstr[2][1] = mvstr[1][1] = mvstr[0][3]        'to row
        m3p = 2
        '  pawn ate
      ELSE
        mvstr[2][0] = mvstr[1][0] = mvstr[0][0]        'from column
        mvstr[2][1] = mvstr[1][1] = mvstr[0][2]        'to column
        mvstr[2][2] = mvstr[0][3]
        m3p = 3                                        'to row
      END IF
      mvstr[2][m3p] = mvstr[1][2] = 0
      IF flag BAND promote THEN
        mvstr[0][4] = mvstr[1][2] = mvstr[2][m3p] = qxx[flag BAND pmask]
        mvstr[1][3] = mvstr[2][m3p + 1] = mvstr[0][5] = 0
      END IF
      '  not a pawn
    ELSE
      mvstr[2][0] = mvstr[1][0]
      mvstr[2][1] = mvstr[0][1]
      mvstr[2][2] = mvstr[1][1] = mvstr[0][2]           'to column
      mvstr[2][3] = mvstr[1][2] = mvstr[0][3]           'to row
      mvstr[2][4] = mvstr[1][3] = 0
      strcpy (mvstr[3], mvstr[2])
      mvstr[3][1] = mvstr[0][0]
      IF flag BAND cstlmask THEN
        IF t > f THEN
          strcpy (mvstr[1], "o-o")
          strcpy (mvstr[2], "O-O")
        ELSE
          strcpy (mvstr[1], "o-o-o")
          strcpy (mvstr[2], "O-O-O")
        END IF
      END IF
    END IF
  ELSE
    mvstr[0][0] = mvstr[1][0] = mvstr[2][0] = mvstr[3][0] = 0
  END IF
END SUB


'
'Compare the string 's' to the list of legal moves available for the
'opponent. If a match is found, make the move on the board.
'
FUNCTION VerifyMove (hWnd AS HWND, s AS char PTR, iop AS INTEGER, mv AS UINT PTR) AS INTEGER
  STATIC pnt AS INTEGER, tempb AS INTEGER, tempc AS INTEGER, tempsf AS INTEGER, tempst AS INTEGER, cnt AS INTEGER
'!  static struct leaf xnode;
'!  struct leaf  FAR *node;
  STATIC xnode AS struct_leaf
  DIM RAW node AS struct_leaf PTR
  *mv = 0
  IF iop = 2 THEN
    UnmakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst)
    FUNCTION = FALSE
  END IF
  cnt = 0
  MoveList (opponent, 2)
  pnt = TrPnt[2]

  WHILE pnt < TrPnt[3]
    node = &Tree[pnt++]
    algbr (node->f, node->t, (INTEGER) node->flags)
    IF strcmp (s, mvstr[0]) = 0  OR  strcmp (s, mvstr[1]) = 0  OR  strcmp (s, mvstr[2]) = 0  OR  strcmp (s, mvstr[3]) = 0 THEN
      cnt++
      xnode = *node
    END IF
  WEND

  IF cnt = 1 THEN
    MakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst, &INCscore)
    IF SqAtakd (PieceList[opponent][0], computer) THEN
      UnmakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst)
      SMessageBox (hWnd, IDS_ILLEGALMOVE, IDS_CHESS)
      FUNCTION = FALSE
    ELSE
      IF iop = 1 THEN
        FUNCTION = TRUE
      END IF
      UpdateDisplay (hWnd, xnode.f, xnode.t, 0, (INTEGER) xnode.flags)
      IF (board[xnode.t] = pawn)  OR  (xnode.flags BAND capture)  OR  (xnode.flags BAND cstlmask) THEN
        Game50 = GameCnt
        ZeroRPT ()
      END IF
      GameList[GameCnt] .depth = GameList[GameCnt] .score = 0
      GameList[GameCnt] .nodes = 0
      ElapsedTime (1)
      GameList[GameCnt].time = (INTEGER) et
      TimeControl.clock[opponent] -= et
      --TimeControl.moves[opponent]
      *mv = (xnode.f << 8) BOR xnode.t
      algbr (xnode.f, xnode.t, false)
      FUNCTION = TRUE
    END IF
  END IF
  IF cnt > 1 THEN
    SMessageBox (hWnd, IDS_AMBIGUOUSMOVE, IDS_CHESS)
  END IF
  FUNCTION = FALSE
END FUNCTION



'
'Determine the time that has passed since the search was started. If
'the elapsed time exceeds the target (ResponseTime+ExtraTime) then set
'timeout to true which will terminate the search.
'
SUB ElapsedTime (iop AS INTEGER)
  et = time ((ULONG *) 0) - time0
  IF et < 0 THEN
    et = 0
  END IF
  ETnodes += 50
  IF et > et0  OR  iop = 1 THEN
    IF et > ResponseTime + ExtraTime  AND  Sdepth > 1 THEN
      flag.timeout = true
    END IF
    et0 = et
    IF iop = 1 THEN
      time0 = time ((ULONG *) 0)
      et0 = 0
    END IF
    ' evrate used to be Nodes / cputime I dont` know why
    IF et > 0 THEN
      evrate = NodeCnt / (et + ft)
    ELSE
      evrate = 0
    END IF
    ETnodes = NodeCnt + 50
    UpdateClocks ()
  END IF
END SUB

SUB SetTimeControl ()
  IF TCflag THEN
    TimeControl.moves[white] = TimeControl.moves[black] = TCmoves
    TimeControl.clock[white] = TimeControl.clock[black] = 60 *(long) TCminutes
  ELSE
    TimeControl.moves[white] = TimeControl.moves[black] = 0
    TimeControl.clock[white] = TimeControl.clock[black] = 0
    Level = 60 *(long) TCminutes
  END IF
  et = 0
  ElapsedTime (1)
END SUB

SUB GetGame (hWnd AS HWND, fname AS char PTR)
  DIM RAW fd AS FILE PTR
  DIM RAW c AS INTEGER
  DIM RAW sq AS INTEGER
  DIM RAW m AS UINT

  '! struct GameRec tmp_rec;
  DIM RAW tmp_rec AS struct_GameRec
  fd = fopen (fname, "r")

  IF fd = NULL THEN
    SMessageBox (hWnd, IDS_LOADFAILED, IDS_CHESS)
    EXIT SUB
  END IF
  fscanf (fd, "%ld%ld%ld", &computer, &opponent, &Game50)
  fscanf (fd, "%ld%ld", &castld[white], &castld[black])
  fscanf (fd, "%ld%ld", &TCflag, &OperatorTime)
  fscanf (fd, "%ld%ld%ld%ld", &TimeControl.clock[white], &TimeControl.clock[black], &TimeControl.moves[white], &TimeControl.moves[black])

  sq = 0
  WHILE sq<64
    fscanf (fd, "%ld%ld", &m, &Mvboard[sq])
    board[sq] = (m >> 8)
    cColor[sq] = (m BAND 0xFF)
    IF cColor[sq] = 0 THEN
      cColor[sq] = neutral
    ELSE
      --cColor[sq]
    END IF
    sq++
  WEND

  GameCnt = 0
  c = ASC("?")
  WHILE c <> CEOF
    ++GameCnt
    c = fscanf (fd, "%d%d%d%d%d%d%d", &tmp_rec.gmove, &tmp_rec.score, &tmp_rec.depth, &tmp_rec.nodes, &tmp_rec.time, &tmp_rec.piece, &tmp_rec.ccolor)
    GameList[GameCnt] = tmp_rec
    IF GameList[GameCnt].ccolor = 0 THEN
      GameList[GameCnt].ccolor = neutral
    ELSE
      --GameList[GameCnt].ccolor
    END IF
  WEND

  GameCnt--
  IF TimeControl.clock[white] > 0 THEN
    TCflag = true
  END IF
  computer--
  opponent--

  fclose (fd)

  InitializeStats ()

  Sdepth = 0
  UpdateDisplay (hWnd, 0, 0, 1, 0)

END SUB

SUB SaveGame (hWnd AS HWND, fname AS char PTR)
  DIM RAW fd AS FILE PTR
  DIM RAW sq AS INTEGER, i AS INTEGER, c AS INTEGER

  fd = fopen (fname , "w")
  IF NULL = fd THEN
    ShowMessage (hWnd, "Not saved")
    EXIT SUB
  END IF
  $IPRINT_OFF
  fprintf (fd, "%d %d %d\n", computer + 1, opponent + 1, Game50)
  fprintf (fd, "%d %d\n", castld[white], castld[black])
  fprintf (fd, "%d %d\n", TCflag, OperatorTime)
  fprintf (fd, "%d %d %d %d\n", TimeControl.clock[white], TimeControl.clock[black], TimeControl.moves[white], TimeControl.moves[black])
  $IPRINT_ON
  sq = 0
  WHILE sq<64
    IF cColor[sq] = neutral THEN
      c = 0
    ELSE
      c = cColor[sq] + 1
    END IF
    $IPRINT_OFF
    fprintf (fd, "%d %d\n", 256 *board[sq] + c, Mvboard[sq])
    $IPRINT_ON
    sq++
  WEND
  i = 1
  WHILE i<=GameCnt
    IF GameList[i] .ccolor = neutral THEN
      c = 0
    ELSE
      c = GameList[i] .ccolor + 1
    END IF
    $IPRINT_OFF
    fprintf (fd, "%d %d %d %d %d %d %d\n", GameList[i] .gmove, GameList[i] .score, GameList[i] .depth, GameList[i] .nodes, GameList[i] .time, GameList[i] .piece, c)
    $IPRINT_ON
    i++
  WEND
  fclose (fd)
END SUB

SUB ListGame (hWnd AS HWND, fname AS char PTR)
  DIM RAW fd AS FILE PTR
  DIM RAW i AS INTEGER, f AS INTEGER, t AS INTEGER

  fd = fopen (fname , "w")
  IF fd = NULL THEN
    ShowMessage (hWnd, "Cannot write chess.lst")
    EXIT SUB
  END IF
  $IPRINT_OFF
  fprintf (fd, "\n")
  $IPRINT_ON
  fprintf (fd, "       score  depth   nodes  time         ")
  $IPRINT_OFF
  fprintf (fd, "       score  depth   nodes  time\n")
  $IPRINT_ON
  i = 1
  WHILE i<=GameCnt
    f = GameList[i] .gmove > > 8
    t = (GameList[i] .gmove BAND 0xFF)
    algbr (f, t, false)
    fprintf (fd, "%5s  %5d     %2d %7d %5d", mvstr[0], GameList[i] .score, GameList[i] .depth, GameList[i] .nodes, GameList[i] .time)

    IF (i % 2) = 0 THEN
      $IPRINT_OFF
      fprintf (fd, "\n")
      $IPRINT_ON
    ELSE
      fprintf (fd, "         ")
    END IF
    i++
  WEND
  $IPRINT_OFF
  fprintf (fd, "\n\n")
  $IPRINT_ON
  fclose (fd)
END SUB

SUB Undo (hWnd AS HWND)

  '
  'Undo the most recent half-move.
  '

  DIM RAW f AS INTEGER, t AS INTEGER
  f = GameList[GameCnt] .gmove >> 8
  t = GameList[GameCnt] .gmove BAND 0xFF
  IF board[t] = king  AND  distance (t, f) > 1 THEN
    (void) castle (GameList[GameCnt].ccolor, f, t, 2)
  ELSE
    ' Check for promotion:
    IF (cColor[t] = white  AND  row (f) = 6  AND  row (t) = 7)  OR  (cColor[t] = black  AND  row (f) = 1  AND  row (t) = 0) THEN
      DIM RAW g AS INTEGER, from = f AS INTEGER
      g = GameCnt - 1
      WHILE g>0
        IF GameList[g].gmove BAND 0xFF = from THEN
          from = GameList[g].gmove >> 8
        END IF
        g--
      WEND
      IF ((cColor[t] = white  AND  row (from) = 1)  OR  (cColor[t] = black  AND  row (from) = 6)) THEN board[t] = pawn
    END IF
    board[f] = board[t]
    cColor[f] = cColor[t]
    board[t] = GameList[GameCnt].piece
    cColor[t] = GameList[GameCnt].ccolor
    IF cColor[t] <> neutral THEN
      Mvboard[t]--
    END IF
    Mvboard[f]--
  END IF
  IF TCflag THEN
    ++TimeControl.moves[cColor[f]]
  END IF
  GameCnt--
  computer = otherside[computer]
  opponent = otherside[opponent]
  flag.mate = false
  Sdepth = 0
  UpdateDisplay (hWnd, 0, 0, 1, 0)
  InitializeStats ()
END SUB

