'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
'Copyright (c) 1988, 1989, 1990  John Stanback
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'

$HEADER
#define taxicab(a,b) *(taxidata+a*64+b)
$HEADER

CONST wking = PieceList[white][0]
CONST bking = PieceList[black][0]
CONST EnemyKing = PieceList[c2][0]


SHAREDSET KingOpening[64] AS INTEGER
  0, 0, - 4, - 10, - 10, - 4, 0, 0, - 4, - 4, - 8, - 12, - 12, - 8, - 4, - 4, - 12, - 16, - 20, - 20, - 20, - 20, - 16, - 12, - 16, - 20, - 24, - 24, - 24, - 24, - 20, - 16, - 16, - 20, - 24, - 24, - 24, - 24, - 20, - 16, - 12, - 16, - 20, - 20, - 20, - 20, - 16, - 12, - 4, - 4, - 8, - 12, - 12, - 8, - 4, - 4, 0, 0, - 4, - 10, - 10, - 4, 0, 0
END SET

SHAREDSET KingEnding[64] AS INTEGER
  0, 6, 12, 18, 18, 12, 6, 0, 6, 12, 18, 24, 24, 18, 12, 6, 12, 18, 24, 30, 30, 24, 18, 12, 18, 24, 30, 36, 36, 30, 24, 18, 18, 24, 30, 36, 36, 30, 24, 18, 12, 18, 24, 30, 30, 24, 18, 12, 6, 12, 18, 24, 24, 18, 12, 6, 0, 6, 12, 18, 18, 12, 6, 0
END SET

SHAREDSET DyingKing[64] AS INTEGER
  0, 8, 16, 24, 24, 16, 8, 0, 8, 32, 40, 48, 48, 40, 32, 8, 16, 40, 56, 64, 64, 56, 40, 16, 24, 48, 64, 72, 72, 64, 48, 24, 24, 48, 64, 72, 72, 64, 48, 24, 16, 40, 56, 64, 64, 56, 40, 16, 8, 32, 40, 48, 48, 40, 32, 8, 0, 8, 16, 24, 24, 16, 8, 0
END SET

SHAREDSET KBNK[64] AS INTEGER
  99, 90, 80, 70, 60, 50, 40, 40, 90, 80, 60, 50, 40, 30, 20, 40, 80, 60, 40, 30, 20, 10, 30, 50, 70, 50, 30, 10, 0, 20, 40, 60, 60, 40, 20, 0, 10, 30, 50, 70, 50, 30, 10, 20, 30, 40, 60, 80, 40, 20, 30, 40, 50, 60, 80, 90, 40, 40, 50, 60, 70, 80, 90, 99
END SET

SHAREDSET pknight[64] AS INTEGER
  0, 4, 8, 10, 10, 8, 4, 0, 4, 8, 16, 20, 20, 16, 8, 4, 8, 16, 24, 28, 28, 24, 16, 8, 10, 20, 28, 32, 32, 28, 20, 10, 10, 20, 28, 32, 32, 28, 20, 10, 8, 16, 24, 28, 28, 24, 16, 8, 4, 8, 16, 20, 20, 16, 8, 4, 0, 4, 8, 10, 10, 8, 4, 0
END SET

SHAREDSET pbishop[64] AS INTEGER
  14, 14, 14, 14, 14, 14, 14, 14, 14, 22, 18, 18, 18, 18, 22, 14, 14, 18, 22, 22, 22, 22, 18, 14, 14, 18, 22, 22, 22, 22, 18, 14, 14, 18, 22, 22, 22, 22, 18, 14, 14, 18, 22, 22, 22, 22, 18, 14, 14, 22, 18, 18, 18, 18, 22, 14, 14, 14, 14, 14, 14, 14, 14, 14
END SET

SHAREDSET PawnAdvance[64] AS INTEGER
  0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 0, 0, 4, 4, 4, 6, 8, 2, 10, 10, 2, 8, 6, 6, 8, 12, 16, 16, 12, 8, 6, 8, 12, 16, 24, 24, 16, 12, 8, 12, 16, 24, 32, 32, 24, 16, 12, 12, 16, 24, 32, 32, 24, 16, 12, 0, 0, 0, 0, 0, 0, 0, 0
END SET

SHAREDSET ccontrol[7] AS INTEGER
  0, ctlP, ctlN, ctlB, ctlR, ctlQ, ctlK
END SET

SHAREDSET PassedPawn0[8] AS INTEGER
  0, 60, 80, 120, 200, 360, 600, 800
END SET

SHAREDSET PassedPawn1[8] AS INTEGER
  0, 30, 40, 60, 100, 180, 300, 800
END SET

SHAREDSET PassedPawn2[8] AS INTEGER
  0, 15, 25, 35, 50, 90, 140, 800
END SET

SHAREDSET PassedPawn3[8] AS INTEGER
  0, 5, 10, 15, 20, 30, 140, 800
END SET

SHAREDSET ISOLANI[8] AS INTEGER
  - 12, - 16, - 20, - 24, - 24, - 20, - 16, - 12
END SET

SHAREDSET BACKWARD[16] AS INTEGER
  - 6, - 10, - 15, - 21, - 28, - 28, - 28, - 28, - 28, - 28, - 28, - 28, - 28, - 28, - 28, - 28
END SET

SHAREDSET BMBLTY[14] AS INTEGER
  - 2, 0, 2, 4, 6, 8, 10, 12, 13, 14, 15, 16, 16, 16
END SET

SHAREDSET RMBLTY[15] AS INTEGER
  0, 2, 4, 6, 8, 10, 11, 12, 13, 14, 14, 14, 14, 14, 14
END SET

SHAREDSET KTHRT[36] AS INTEGER
  0, - 8, - 20, - 36, - 52, - 68, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80, - 80
END SET

'
'ptype is used to separate white and black pawns, like this;
'ptyp = ptype[side][piece]
'piece can be used directly in nextpos/nextdir when generating moves
'for pieces that are not black pawns.
'
SHAREDSET ptype[2][8] AS INTEGER
  no_piece, pawn, knight, bishop, rook, queen, king, no_piece, no_piece, bpawn, knight, bishop, rook, queen, king, no_piece
END SET


SHAREDSET kingP[3] AS INTEGER
  4, 60, 0
END SET

SHAREDSET rank7[3] AS INTEGER
  6, 1, 0
END SET

' ............    POSITIONAL EVALUATION ROUTINES    ............

FUNCTION evaluate (side AS INTEGER, ply AS INTEGER, alpha AS INTEGER, beta AS INTEGER, INCscore AS INTEGER, slk AS INTEGER PTR, InChk AS INTEGER PTR) AS INTEGER

  '
  'Compute an estimate of the score by adding the positional score from the
  'previous ply to the material difference. If this score falls inside a
  'window which is 180 points wider than the alpha-beta window (or within a
  '50 point window during quiescence search) call ScorePosition() to
  'determine a score, otherwise return the estimated score. If one side has
  'only a king and the other either has no pawns or no pieces then the
  'function ScoreLoneKing() is called.
  '

  DIM RAW evflag AS INTEGER, xside AS INTEGER
  DIM RAW s AS INTEGER

  xside = otherside[side]
  s = - Pscore[ply - 1] + mtl[side] - mtl[xside] - INCscore
  hung[white] = hung[black] = 0
  ' This style of code using conditional == || and && outside a conditional
  ' statement (like IF THEN) gives BCX hiccup
   ! *slk = ((mtl[white] == valueK && (pmtl[black] == 0 || emtl[black] == 0)) ||
   !      (mtl[black] == valueK && (pmtl[white] == 0 || emtl[white] == 0)));
  IF *slk THEN
    evflag = FALSE
  ELSE
   ! evflag = (ply == 1 || ply < Sdepth ||
   !    ((ply == Sdepth + 1 || ply == Sdepth + 2) &&
   !     (s > alpha - xwndw && s < beta + xwndw)) ||
   !    (ply > Sdepth + 2 && s >= alpha - 25 && s <= beta + 25));
  END IF
  IF evflag THEN
    EvalNodes++
    ataks (side, atak[side])
    IF Anyatak (side, PieceList[xside][0]) THEN
      FUNCTION = (10001 - ply)
    END IF
    ataks (xside, atak[xside])
    *InChk = Anyatak (xside, PieceList[side][0])
    ScorePosition (side, &s)
  ELSE
    IF SqAtakd (PieceList[xside][0], side) THEN
      FUNCTION = (10001 - ply)
    END IF
    *InChk = SqAtakd (PieceList[side][0], xside)
    IF *slk THEN
      ScoreLoneKing (side, &s)
    END IF
  END IF
  Pscore[ply] = s - mtl[side] + mtl[xside]
  IF *InChk THEN
    ChkFlag[ply - 1] = Pindex[TOsquare]
  ELSE
    ChkFlag[ply - 1] = 0
  END IF
  FUNCTION = s
END FUNCTION


FUNCTION ScoreKPK (side AS INTEGER, winner AS INTEGER, loser AS INTEGER, king1 AS INTEGER, king2 AS INTEGER, sq AS INTEGER) AS INTEGER

  '
  'Score King and Pawns versus King endings.
  '

  DIM RAW s AS INTEGER, r AS INTEGER

  IF PieceCnt[winner] = 1 THEN
    s = 50
  ELSE
    s = 120
  END IF
  IF winner = white THEN
    IF side = loser THEN
      r = row (sq) - 1
    ELSE
      r = row (sq)
    END IF
    IF row (king2) >= r  AND  distance (sq, king2) < 8 - r THEN
      s + = 10 *row (sq)
    ELSE
      s = 500 + 50 *row (sq)
    END IF
    IF row (sq) < 6 THEN
      sq + = 16
    ELSEIF row (sq) = 6 THEN
      sq + = 8
    END IF
  ELSE
    IF side = loser THEN
      r = row (sq) + 1
    ELSE
      r = row (sq)
    END IF
    IF row (king2) <= r  AND  distance (sq, king2) < r + 1 THEN
      s + = 10 *(7 - row (sq))
    ELSE
      s = 500 + 50 *(7 - row (sq))
    END IF
    IF row (sq) > 1 THEN
      sq - = 16
    ELSEIF row (sq) = 1 THEN
      sq - = 8
    END IF
  END IF
  s + = 8 *(taxicab (king2, sq) - taxicab (king1, sq))
  FUNCTION = (s)
END FUNCTION


FUNCTION ScoreKBNK (winner AS INTEGER, king1 AS INTEGER, king2 AS INTEGER) AS INTEGER
  '
  'Score King+Bishop+Knight versus King endings.
  'This doesn't work all that well but it's better than nothing.
  '

  DIM RAW s AS INTEGER, sq AS INTEGER, KBNKsq = 0 AS INTEGER

  sq = 0
  WHILE sq<64
    IF board[sq] = bishop THEN
      IF row (sq) % 2 = column (sq) % 2 THEN
        KBNKsq = 0
      ELSE
        KBNKsq = 7
      END IF
    END IF
    sq++
  WEND
  s = emtl[winner] - 300

  IF KBNKsq = 0 THEN
    s + = KBNK[king2]
  ELSE
    s + = KBNK[locn (row (king2), 7 - column (king2))]
  END IF
  s -= taxicab (king1, king2)
  s -= distance (PieceList[winner][1], king2)
  s -= distance (PieceList[winner][2], king2)
  FUNCTION = s
END FUNCTION


SUB ScoreLoneKing (side AS INTEGER, score AS INTEGER PTR)

  '
  'Static evaluation when loser has only a king and winner has no pawns or no
  'pieces.
  '

  DIM RAW winner AS INTEGER, loser AS INTEGER, king1 AS INTEGER, king2 AS INTEGER, s AS INTEGER, i AS INTEGER

  UpdateWeights ()
  IF mtl[white] > mtl[black] THEN
    winner = white
  ELSE
    winner = black
  END IF
  loser = otherside[winner]
  king1 = PieceList[winner][0]
  king2 = PieceList[loser][0]

  s = 0

  IF pmtl[winner] > 0 THEN
    i = 1
    WHILE i<=PieceCnt[winner]
      s + = ScoreKPK (side, winner, loser, king1, king2, PieceList[winner][i])
      i++
    WEND
  ELSEIF emtl[winner] = valueB + valueN THEN
    s = ScoreKBNK (winner, king1, king2)
  ELSEIF emtl[winner] > valueB THEN
    s = 500 + emtl[winner] - DyingKing[king2] - 2 *distance (king1, king2)
  END IF
  IF side = winner THEN
    *score = s
  ELSE
    *score = - s
  END IF
END SUB


SUB BRscan (sq AS INTEGER, s AS INTEGER PTR, mob AS INTEGER PTR)

  '
  'Find Bishop and Rook mobility, XRAY attacks, and pins. Increment the
  'hung[] array if a pin is found.
  '
  DIM RAW u AS INTEGER, piece AS INTEGER, pin AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR
  DIM RAW Kf AS INTEGER PTR

  Kf = Kfield[c1]
  *mob = 0
  piece = board[sq]
  ppos = nextpos + piece *64 *64 + sq *64
  pdir = nextdir + piece *64 *64 + sq *64
  u = ppos[sq]
  pin = - 1                                               'start new direction
  DO
    *s += Kf[u]
    IF cColor[u] = neutral THEN
      (*mob)++
      IF ppos[u] = pdir[u] THEN                         'oops new direction
        pin = - 1
      END IF
      u = ppos[u]
    ELSEIF pin < 0 THEN
      IF board[u] = pawn  OR  board[u] = king THEN
        u = pdir[u]
      ELSE
        IF ppos[u] <> pdir[u] THEN                     'not on the edge and on to find a pin
          pin = u
        END IF
        u = ppos[u]
      END IF
    ELSE
      IF cColor[u] = c2  AND  (board[u] > piece  OR  atk2[u] = 0) THEN
        IF cColor[pin] = c2 THEN
          *s + = PINVAL
          IF atk2[pin] = 0  OR  atk1[pin] > ccontrol[board[pin]] + 1 THEN
            ++hung[c2]
          END IF
        ELSE
          *s + = XRAY
        END IF
      END IF
      pin = - 1                                         'new direction
      u = pdir[u]
    END IF
  LOOP WHILE u <> sq
END SUB

$HEADER
#define ScoreThreat \
if (cColor[u] != c2)\
  if (atk1[u] == 0 || (atk2[u] & 0xFF) > 1) ++cnt;\
  else *s -= 3
$HEADER
SUB KingScan (sq AS INTEGER, s AS INTEGER PTR)

  '
  'Assign penalties if king can be threatened by checks, if squares
  'near the king are controlled by the enemy (especially the queen),
  'or if there are no pawns near the king.
  'The following must be true:
  'board[sq] == king
  'c1 == cColor[sq]
  'c2 == otherside[c1]
  '

  DIM RAW u AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR
  DIM RAW cnt AS INTEGER, ok AS INTEGER

  cnt = 0
  IF HasBishop[c2]  OR  HasQueen[c2] THEN
    ppos = nextpos + bishop *64 *64 + sq *64
    pdir = nextdir + bishop *64 *64 + sq *64
    u = ppos[sq]
    DO
      IF atk2[u] BAND ctlBQ THEN
        ScoreThreat
      END IF
      ! u = (cColor[u] == neutral ) ? ppos[u] : pdir[u] ;
    LOOP WHILE u <> sq
  END IF
  IF HasRook[c2]  OR  HasQueen[c2] THEN
    ppos = nextpos + rook *64 *64 + sq *64
    pdir = nextdir + rook *64 *64 + sq *64
    u = ppos[sq]
    DO
      IF atk2[u] BAND ctlRQ THEN
        ScoreThreat
      END IF
      ! u = (cColor[u] == neutral ) ? ppos[u] : pdir[u] ;
    LOOP WHILE u <> sq
  END IF
  IF HasKnight[c2] THEN
    pdir = nextdir + knight *64 *64 + sq *64
    u = pdir[sq]
    DO
      IF atk2[u] BAND ctlNN THEN
        ScoreThreat
      END IF
      u = pdir[u]
    LOOP WHILE u <> sq
  END IF
  *s + = (KSFTY *KTHRT[cnt]) / 16

  cnt = 0
  ok = FALSE
  pdir = nextpos + king *64 *64 + sq *64
  u = pdir[sq]
  DO
    IF board[u] = pawn THEN
      ok = TRUE
    END IF
    IF atk2[u] > atk1[u] THEN
      ++cnt
      IF atk2[u] BAND ctlQ THEN
        IF atk2[u] > ctlQ + 1 AND atk1[u] < ctlQ THEN
          *s - = 4 *KSFTY
        END IF
      END IF
    END IF
    u = pdir[u]
  LOOP WHILE u <> sq
  IF  NOT  ok THEN
    *s - = KSFTY
  END IF
  IF cnt > 1 THEN
    *s - = KSFTY
  END IF
END SUB


FUNCTION  trapped (sq AS INTEGER) AS INTEGER

  '
  'See if the attacked piece has unattacked squares to move to.
  'The following must be true:
  'c1 == cColor[sq]
  'c2 == otherside[c1]
  '

  DIM RAW u AS INTEGER, piece AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR

  piece = board[sq]
  ppos = nextpos + (ptype[c1][piece] *64 *64) + sq *64
  pdir = nextdir + (ptype[c1][piece] *64 *64) + sq *64
  IF piece = pawn THEN
    u = ppos[sq]                                      'follow no captures thread
    IF cColor[u] = neutral THEN
      IF atk1[u] >= atk2[u] THEN
        FUNCTION = (FALSE)
      END IF
      IF atk2[u] < ctlP THEN
        u = ppos[u]
        IF cColor[u] = neutral  AND  atk1[u] >= atk2[u] THEN
          FUNCTION = (FALSE)
        END IF
      END IF
    END IF
    u = pdir[sq]                                      'follow captures thread
    IF cColor[u] = c2 THEN
      FUNCTION = (FALSE)
    END IF
    u = pdir[u]
    IF cColor[u] = c2 THEN
      FUNCTION = (FALSE)
    END IF
  ELSE
    u = ppos[sq]
    DO
      IF cColor[u] <> c1 THEN
        IF atk2[u] = 0  OR  board[u] >= piece THEN
          FUNCTION = (FALSE)
        END IF
      END IF
      ! u = (cColor[u] == neutral ) ? ppos[u] : pdir[u];
    LOOP WHILE (u <> sq)
  END IF
  FUNCTION = (TRUE)
END FUNCTION


FUNCTION PawnValue (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'Calculate the positional value for a pawn on 'sq'.
  '

  DIM RAW j AS INTEGER, fyle AS INTEGER, rank AS INTEGER
  DIM RAW s AS INTEGER, a1 AS INTEGER, a2 AS INTEGER, in_square AS INTEGER, r AS INTEGER, e AS INTEGER

  a1 = (atk1[sq] BAND 0x4FFF)
  a2 = (atk2[sq] BAND 0x4FFF)
  rank = row (sq)
  fyle = column (sq)
  s = 0
  IF c1 = white THEN
    s = Mwpawn[sq]
    IF (sq = 11  AND  cColor[19] <> neutral)  OR  (sq = 12  AND  cColor[20] <> neutral) THEN
      s + = PEDRNK2B
    END IF
    IF (fyle = 0  OR  PC1[fyle - 1] = 0)  AND  (fyle = 7  OR  PC1[fyle + 1] = 0) THEN
      s + = ISOLANI[fyle]
    ELSEIF PC1[fyle] > 1 THEN
      s + = PDOUBLED
    END IF
    IF a1 < ctlP  AND  atk1[sq + 8] < ctlP THEN
      s + = BACKWARD[a2 BAND 0xFF]
      IF PC2[fyle] = 0 THEN
        s + = PWEAKH
      END IF
      IF cColor[sq + 8] <> neutral THEN
        s + = PBLOK
      END IF
    END IF
    IF PC2[fyle] = 0 THEN
      IF side = black THEN
        r = rank - 1
      ELSE
        r = rank
      END IF
      in_square = (row (bking) >= r  AND  distance (sq, bking) < 8 - r)
      IF a2 = 0  OR  side = white THEN
        e = 0
      ELSE
        e = 1
      END IF
      j = sq + 8
      WHILE j<64
        IF atk2[j] >= ctlP THEN
          e = 2
          EXIT LOOP
        ELSEIF atk2[j] > 0  OR  cColor[j] <> neutral THEN
          e = 1
        END IF
        j+=8
      WEND
      IF e = 2 THEN
        s + = (stage *PassedPawn3[rank]) / 10
      ELSEIF in_square  OR  e = 1 THEN
        s + = (stage *PassedPawn2[rank]) / 10
      ELSEIF emtl[black] > 0 THEN
        s + = (stage *PassedPawn1[rank]) / 10
      ELSE
        s + = PassedPawn0[rank]
      END IF
    END IF
  ELSEIF c1 = black THEN
    s = Mbpawn[sq]
    IF (sq = 51  AND  cColor[43] <> neutral)  OR  (sq = 52  AND  cColor[44] <> neutral) THEN
      s + = PEDRNK2B
    END IF
    IF (fyle = 0  OR  PC1[fyle - 1] = 0)  AND  (fyle = 7  OR  PC1[fyle + 1] = 0) THEN
      s + = ISOLANI[fyle]
    ELSEIF PC1[fyle] > 1 THEN
      s + = PDOUBLED
    END IF
    IF a1 < ctlP  AND  atk1[sq - 8] < ctlP THEN
      s + = BACKWARD[a2 BAND 0xFF]
      IF PC2[fyle] = 0 THEN
        s + = PWEAKH
      END IF
      IF cColor[sq - 8] <> neutral THEN
        s + = PBLOK
      END IF
    END IF
    IF PC2[fyle] = 0 THEN
      IF side = white THEN
        r = rank + 1
      ELSE
        r = rank
      END IF
      in_square = (row (wking) <= r  AND  distance (sq, wking) < r + 1)
      IF a2 = 0  OR  side = black THEN
        e = 0
      ELSE
        e = 1
      END IF
      j = sq - 8
      WHILE j>=0
        IF atk2[j] >= ctlP THEN
          e = 2
          EXIT LOOP
        ELSEIF atk2[j] > 0  OR  cColor[j] <> neutral THEN
          e = 1
        END IF
        j-=8
      WEND
      IF e = 2 THEN
        s + = (stage *PassedPawn3[7 - rank]) / 10
      ELSEIF in_square  OR  e = 1 THEN
        s + = (stage *PassedPawn2[7 - rank]) / 10
      ELSEIF emtl[white] > 0 THEN
        s + = (stage *PassedPawn1[7 - rank]) / 10
      ELSE
        s + = PassedPawn0[7 - rank]
      END IF
    END IF
  END IF
  IF a2 > 0 THEN
    IF a1 = 0  OR  a2 > ctlP + 1 THEN
      s + = HUNGP
      ++hung[c1]
      IF trapped (sq) THEN
        ++hung[c1]
      END IF
    ELSEIF a2 > a1 THEN
      s + = ATAKD
    END IF
  END IF
  FUNCTION = (s)
END FUNCTION


FUNCTION KnightValue (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'Calculate the positional value for a knight on 'sq'.
  '

  DIM RAW s AS INTEGER, a2 AS INTEGER, a1 AS INTEGER

  UNREFERENCED_PARAMETER (side)

  s = Mknight[c1][sq]
  a2 = (atk2[sq] BAND 0x4FFF)
  IF a2 > 0 THEN
    a1 = (atk1[sq] BAND 0x4FFF)
    IF a1 = 0  OR  a2 > ctlBN + 1 THEN
      s + = HUNGP
      ++hung[c1]
      IF trapped (sq) THEN
        ++hung[c1]
      END IF
    ELSEIF a2 >= ctlBN  OR  a1 < ctlP THEN
      s + = ATAKD
    END IF
  END IF
  FUNCTION = (s)
END FUNCTION


FUNCTION  BishopValue (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'Calculate the positional value for a bishop on 'sq'.
  '

  DIM RAW a2 AS INTEGER, a1 AS INTEGER
  DIM RAW s AS INTEGER, mob AS INTEGER

  UNREFERENCED_PARAMETER (side)

  s = Mbishop[c1][sq]
  BRscan (sq, &s, &mob)
  s + = BMBLTY[mob]
  a2 = (atk2[sq] BAND 0x4FFF)
  IF a2 > 0 THEN
    a1 = (atk1[sq] BAND 0x4FFF)
    IF a1 = 0  OR  a2 > ctlBN + 1 THEN
      s + = HUNGP
      ++hung[c1]
      IF trapped (sq) THEN
        ++hung[c1]
      END IF
    ELSEIF a2 >= ctlBN  OR  a1 < ctlP THEN
      s + = ATAKD
    END IF
  END IF
  FUNCTION = (s)
END FUNCTION


FUNCTION  RookValue (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'Calculate the positional value for a rook on 'sq'.
  '

  DIM RAW fyle AS INTEGER, a2 AS INTEGER, a1 AS INTEGER
  DIM RAW s AS INTEGER, mob AS INTEGER

  UNREFERENCED_PARAMETER (side)

  s = RookBonus
  BRscan (sq, &s, &mob)
  s + = RMBLTY[mob]
  fyle = column (sq)
  IF PC1[fyle] = 0 THEN
    s + = RHOPN
  END IF
  IF PC2[fyle] = 0 THEN
    s + = RHOPNX
  END IF
  IF pmtl[c2] > 100  AND  row (sq) = rank7[c1] THEN
    s + = 10
  END IF
  IF stage > 2 THEN
    s + = 14 - taxicab (sq, EnemyKing)
  END IF
  a2 = (atk2[sq] BAND 0x4FFF)
  IF a2 > 0 THEN
    a1 = (atk1[sq] BAND 0x4FFF)
    IF a1 = 0  OR  a2 > ctlR + 1 THEN
      s + = HUNGP
      ++hung[c1]

      IF trapped (sq) THEN
        ++hung[c1]
      END IF
    ELSEIF a2 >= ctlR  OR  a1 < ctlP THEN
      s + = ATAKD
    END IF
  END IF
  FUNCTION = (s)
END FUNCTION


FUNCTION  QueenValue (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'Calculate the positional value for a queen on 'sq'.
  '

  DIM RAW s AS INTEGER, a2 AS INTEGER, a1 AS INTEGER

  UNREFERENCED_PARAMETER (side)

  ! s = (distance (sq, EnemyKing ) < 3 ) ? 12 : 0 ;
  IF stage > 2 THEN
    s + = 14 - taxicab (sq, EnemyKing)
  END IF
  a2 = (atk2[sq] BAND 0x4FFF)
  IF a2 > 0 THEN
    a1 = (atk1[sq] BAND 0x4FFF)
    IF a1 = 0  OR  a2 > ctlQ + 1 THEN
      s + = HUNGP
      ++hung[c1]
      IF trapped (sq) THEN
        ++hung[c1]
      END IF
    ELSEIF a2 >= ctlQ  OR  a1 < ctlP THEN
      s + = ATAKD
    END IF
  END IF
  FUNCTION = (s)
END FUNCTION


FUNCTION  KingValue (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'Calculate the positional value for a king on 'sq'.
  '

  DIM RAW fyle AS INTEGER, a2 AS INTEGER, a1 AS INTEGER
  DIM RAW s AS INTEGER

  UNREFERENCED_PARAMETER (side)

  s = Mking[c1][sq]
  IF KSFTY > 0 THEN
    IF Developed[c2]  OR  stage > 0 THEN
      KingScan (sq, &s)
    END IF
  END IF
  IF (castld[c1]) THEN
    s + = KCASTLD
  ELSEIF Mvboard[kingP[c1]] THEN
    s + = KMOVD
  END IF
  fyle = column (sq)
  IF PC1[fyle] = 0 THEN
    s + = KHOPN
  END IF
  IF PC2[fyle] = 0 THEN
    s + = KHOPNX
  END IF
  SELECT CASE (fyle)
  CASE 5
    IF PC1[7] = 0 THEN
      s + = KHOPN
    END IF
    IF PC2[7] = 0 THEN
      s + = KHOPNX
    END IF
    ' Fall through
    IF PC1[fyle + 1] = 0 THEN
      s + = KHOPN
    END IF
    IF PC2[fyle + 1] = 0 THEN
      s + = KHOPNX
    END IF
  CASE 4, 6, 0
    IF PC1[fyle + 1] = 0 THEN
      s + = KHOPN
    END IF
    IF PC2[fyle + 1] = 0 THEN
      s + = KHOPNX
    END IF
  CASE 2
    IF PC1[0] = 0 THEN
      s + = KHOPN
    END IF
    IF PC2[0] = 0 THEN
      s + = KHOPNX
    END IF
    ' Fall through
    IF PC1[fyle - 1] = 0 THEN
      s + = KHOPN
    END IF
    IF PC2[fyle - 1] = 0 THEN
      s + = KHOPNX
    END IF
  CASE 3, 1, 7
    IF PC1[fyle - 1] = 0 THEN
      s + = KHOPN
    END IF
    IF PC2[fyle - 1] = 0 THEN
      s + = KHOPNX
    END IF
    '  Impossible!
  CASE ELSE
  END SELECT

  a2 = (atk2[sq] BAND 0x4FFF)
  IF a2 > 0 THEN
    a1 = (atk1[sq] BAND 0x4FFF)
    IF a1 = 0  OR  a2 > ctlK + 1 THEN
      s + = HUNGP
      ++hung[c1]
    ELSE
      s + = ATAKD
    END IF
  END IF
  FUNCTION = (s)
END FUNCTION


SUB ScorePosition (side AS INTEGER, score AS INTEGER PTR)

  '
  'Perform normal static evaluation of board position. A score is generated
  'for each piece and these are summed to get a score for each side.
  '

  DIM RAW sq AS INTEGER, s AS INTEGER, i AS INTEGER, xside AS INTEGER
  DIM RAW pscore[2] AS INTEGER

  UpdateWeights ()
  xside = otherside[side]
  pscore[white] = pscore[black] = 0

  c1 = white
  WHILE c1<=black
    c2 = otherside[c1]
    atk1 = atak[c1]
    atk2 = atak[c2]
    PC1 = PawnCnt[c1]
    PC2 = PawnCnt[c2]
    i = PieceCnt [ c1 ]
    WHILE i>=0
      sq = PieceList[c1][i]
      SELECT CASE (board[sq])
      CASE pawn
        s = PawnValue (sq, side)
      CASE knight
        s = KnightValue (sq, side)
      CASE bishop
        s = BishopValue (sq, side)
      CASE rook
        s = RookValue (sq, side)
      CASE queen
        s = QueenValue (sq, side)
      CASE king
        s = KingValue (sq, side)
      CASE ELSE
        s = 0
      END SELECT
      pscore[c1] + = s
      svalue[sq] = s
      i--
    WEND
    c1++
  WEND
  IF hung[side] > 1 THEN
    pscore[side] + = HUNGX
  END IF
  IF hung[xside] > 1 THEN
    pscore[xside] + = HUNGX
  END IF
  *score = mtl[side] - mtl[xside] + pscore[side] - pscore[xside] + 10
  IF dither THEN
    *score + = urand () % dither
  END IF
  IF *score > 0  AND  pmtl[side] = 0 THEN
    IF emtl[side] < valueR THEN
      *score = 0
    ELSEIF *score < valueR THEN
      *score / = 2
    END IF
  END IF

  IF (*score < 0 AND pmtl[xside] = 0) THEN
    IF (emtl[xside] < valueR) THEN
      *score = 0
    ELSEIF - *score < valueR THEN
      *score / = 2
    END IF
  END IF
  IF mtl[xside] = valueK  AND  emtl[side] > valueB THEN
    *score + = 200
  END IF
  IF mtl[side] = valueK  AND  emtl[xside] > valueB THEN
    *score - = 200
  END IF
END SUB

SUB BlendBoard (a AS INTEGER PTR, b AS INTEGER PTR, c AS INTEGER PTR)
  DIM RAW sq AS INTEGER
  sq = 0
  WHILE sq<64
    *(c+sq) = (*(a+sq) *(10 - stage) + *(b+sq) *stage) / 10
    sq++
  WEND
END SUB

SUB CopyBoard (a AS INTEGER PTR, b AS INTEGER PTR)
  DIM RAW sq AS INTEGER

  sq = 0
  WHILE sq<64
    *(b+sq) = *(a+sq)
    sq++
  WEND
END SUB

SUB ExaminePosition ()

  '
  'This is done one time before the search is started. Set up arrays
  'Mwpawn, Mbpawn, Mknight, Mbishop, Mking which are used in the
  'SqValue() function to determine the positional value of each piece.
  '

  DIM RAW i AS INTEGER, sq AS INTEGER
  DIM RAW wpadv AS INTEGER, bpadv AS INTEGER, wstrong AS INTEGER, bstrong AS INTEGER, z AS INTEGER, side AS INTEGER, pp AS INTEGER, j AS INTEGER, k AS INTEGER, vval AS INTEGER, Pd AS INTEGER, fyle AS INTEGER, rank AS INTEGER
  STATIC PawnStorm = FALSE AS INTEGER

  ataks (white, atak[white])
  ataks (black, atak[black])
  UpdateWeights ()
  HasKnight[white] = HasKnight[black] = 0
  HasBishop[white] = HasBishop[black] = 0
  HasRook[white] = HasRook[black] = 0
  HasQueen[white] = HasQueen[black] = 0
  side = white
  WHILE side<=black
    i = PieceCnt [ side ]
    WHILE i>=0
      SELECT CASE board[PieceList[side][i]]
      CASE knight
        ++HasKnight[side]
      CASE bishop
        ++HasBishop[side]
      CASE rook
        ++HasRook[side]
      CASE queen
        ++HasQueen[side]
      END SELECT
      i--
    WEND
    side++
  WEND
  IF  NOT  Developed[white] THEN
    Developed[white] = (board[1] <> knight AND board[2] <> bishop AND board[5] <> bishop AND board[6] <> knight)
  END IF
  IF  NOT  Developed[black] THEN
    Developed[black] = (board[57] <> knight AND board[58] <> bishop AND board[61] <> bishop AND board[62] <> knight)
  END IF
  IF  NOT  PawnStorm  AND  stage < 5 THEN
    PawnStorm = ((column (wking) < 3 AND column (bking) > 4) || (column (wking) > 4 AND column (bking) < 3))
  END IF
  CopyBoard (pknight, Mknight[white])
  CopyBoard (pknight, Mknight[black])
  CopyBoard (pbishop, Mbishop[white])
  CopyBoard (pbishop, Mbishop[black])
  BlendBoard (KingOpening, KingEnding, Mking[white])
  BlendBoard (KingOpening, KingEnding, Mking[black])

  sq = 0
  WHILE sq<64
    fyle = column (sq)
    rank = row (sq)
    wstrong = bstrong = TRUE
    i = sq
    WHILE i<64
      IF Patak (black, i) THEN
        wstrong = FALSE
        EXIT LOOP
      END IF
      i+=8
    WEND
    i = sq
    WHILE i>=0
      IF Patak (white, i) THEN
        bstrong = FALSE
        EXIT LOOP
      END IF
      i-=8
    WEND
    wpadv = bpadv = PADVNCM
    IF (fyle = 0  OR  PawnCnt[white][fyle - 1] = 0)  AND  (fyle = 7  OR  PawnCnt[white][fyle + 1] = 0) THEN
      wpadv = PADVNCI
    END IF
    IF (fyle = 0  OR  PawnCnt[black][fyle - 1] = 0)  AND  (fyle = 7  OR  PawnCnt[black][fyle + 1] = 0) THEN
      bpadv = PADVNCI
    END IF
    Mwpawn[sq] = (wpadv *PawnAdvance[sq]) / 10
    Mbpawn[sq] = (bpadv *PawnAdvance[63 - sq]) / 10
    Mwpawn[sq] + = PawnBonus
    Mbpawn[sq] + = PawnBonus
    IF Mvboard[kingP[white]] THEN
      IF (fyle < 3  OR  fyle > 4)  AND  distance (sq, wking) < 3 THEN
        Mwpawn[sq] + = PAWNSHIELD
      END IF
    ELSEIF rank < 3  AND  (fyle < 2  OR  fyle > 5) THEN
      Mwpawn[sq] + = PAWNSHIELD / 2
    END IF
    IF Mvboard[kingP[black]] THEN
      IF (fyle < 3  OR  fyle > 4)  AND  distance (sq, bking) < 3 THEN
        Mbpawn[sq] + = PAWNSHIELD
      END IF
    ELSEIF rank > 4  AND  (fyle < 2  OR  fyle > 5) THEN
      Mbpawn[sq] + = PAWNSHIELD / 2
    END IF
    IF PawnStorm THEN
      IF (column (wking) < 4  AND  fyle > 4)  OR  (column (wking) > 3  AND  fyle < 3) THEN
        Mwpawn[sq] + = 3 *rank - 21
      END IF
      IF (column (bking) < 4  AND  fyle > 4)  OR  (column (bking) > 3  AND  fyle < 3) THEN
        Mbpawn[sq] - = 3 *rank
      END IF
    END IF
    Mknight[white][sq] + = 5 - distance (sq, bking)
    Mknight[white][sq] + = 5 - distance (sq, wking)
    Mknight[black][sq] + = 5 - distance (sq, wking)
    Mknight[black][sq] + = 5 - distance (sq, bking)
    Mbishop[white][sq] + = BishopBonus
    Mbishop[black][sq] + = BishopBonus
    DIM RAW xxxtmp AS INTEGER

    i = PieceCnt [ black ]
    WHILE i>=0
      xxxtmp = PieceList[black][i]
      IF distance (sq, xxxtmp) < 3 THEN
        Mknight[white][sq] + = KNIGHTPOST
      END IF
      i--
    WEND
    i = PieceCnt [ white ]
    WHILE i>=0
      xxxtmp = PieceList[white][i]
      IF distance (sq, xxxtmp) < 3 THEN
        Mknight[black][sq] + = KNIGHTPOST
      END IF
      i--
    WEND
    IF wstrong THEN
      Mknight[white][sq] + = KNIGHTSTRONG
    END IF
    IF bstrong THEN
      Mknight[black][sq] + = KNIGHTSTRONG
    END IF
    IF wstrong THEN
      Mbishop[white][sq] + = BISHOPSTRONG
    END IF
    IF bstrong THEN
      Mbishop[black][sq] + = BISHOPSTRONG
    END IF
    IF HasBishop[white] = 2 THEN
      Mbishop[white][sq] + = 8
    END IF
    IF HasBishop[black] = 2 THEN
      Mbishop[black][sq] + = 8
    END IF
    IF HasKnight[white] = 2 THEN
      Mknight[white][sq] + = 5
    END IF
    IF HasKnight[black] = 2 THEN
      Mknight[black][sq] + = 5
    END IF
    Kfield[white][sq] = Kfield[black][sq] = 0
    IF distance (sq, wking) = 1 THEN
      Kfield[black][sq] = KATAK
    END IF
    IF distance (sq, bking) = 1 THEN
      Kfield[white][sq] = KATAK
    END IF
    Pd = 0
    k = 0
    WHILE k<=PieceCnt[white]
      i = PieceList[white][k]
      IF board[i] = pawn THEN
        pp = TRUE
        IF row (i) = 6 THEN
          z = i + 8
        ELSE
          z = i + 16
        END IF
        j = i + 8
        WHILE j<64
          IF Patak (black, j)  OR  board[j] = pawn THEN
            pp = FALSE
            EXIT LOOP
          END IF
          j+=8
        WEND
        IF pp THEN
          Pd + = 5 *taxicab (sq, z)
        ELSE
          Pd + = taxicab (sq, z)
        END IF
      END IF
      k++
    WEND
    k = 0
    WHILE k<=PieceCnt[black]
      i = PieceList[black][k]
      IF board[i] = pawn THEN
        pp = TRUE
        IF row (i) = 1 THEN
          z = i - 8
        ELSE
          z = i - 16
        END IF
        j = i - 8
        WHILE j>=0
          IF Patak (white, j)  OR  board[j] = pawn THEN
            pp = FALSE
            EXIT LOOP
          END IF
          j-=8
        WEND
        IF pp THEN
          Pd + = 5 *taxicab (sq, z)
        ELSE
          Pd + = taxicab (sq, z)
        END IF
      END IF
      k++
    WEND
    IF Pd <> 0 THEN
      vval = (Pd *stage2) / 10
      Mking[white][sq] - = vval
      Mking[black][sq] - = vval
    END IF
    sq++
  WEND
END SUB

SUB UpdateWeights ()

  '
  'If material balance has changed, determine the values for the positional
  'evaluation terms.
  '

  DIM RAW tmtl AS INTEGER, s1 AS INTEGER

  emtl[white] = mtl[white] - pmtl[white] - valueK
  emtl[black] = mtl[black] - pmtl[black] - valueK
  tmtl = emtl[white] + emtl[black]
  ! s1 = (tmtl > 6600 ) ? 0 : ((tmtl < 1400 ) ? 10 : (6600 - tmtl ) / 520 ) ;
  IF s1 <> stage THEN
    stage = s1
    ! stage2 = (tmtl > 3600 ) ? 0 : ((tmtl < 1400 ) ? 10 : (3600 - tmtl ) / 220 ) ;
    PEDRNK2B = - 15                                   'centre pawn on 2nd rank & blocked
    PBLOK = - 4                                       'blocked backward pawn
    PDOUBLED = - 14                                   'doubled pawn
    PWEAKH = - 4                                      'weak pawn on half open file
    PAWNSHIELD = 10 - stage                           'pawn near friendly king
    PADVNCM = 10                                      'advanced pawn multiplier
    PADVNCI = 7                                       'muliplier for isolated pawn
    PawnBonus = stage

    KNIGHTPOST = (stage + 2) / 3                      'knight near enemy pieces
    KNIGHTSTRONG = (stage + 6) / 2                    'occupies pawn hole

    BISHOPSTRONG = (stage + 6) / 2                    'occupies pawn hole
    BishopBonus = 2 *stage

    RHOPN = 10                                        'rook on half open file
    RHOPNX = 4
    RookBonus = 6 *stage

    XRAY = 8                                          'Xray attack on piece
    PINVAL = 10                                       'Pin

    KHOPN = (3 *stage - 30) / 2                       'king on half open file
    KHOPNX = KHOPN / 2
    KCASTLD = 10 - stage
    KMOVD = - 40 / (stage + 1)                        'king moved before castling
    KATAK = (10 - stage) / 2                          'B,R attacks near enemy king
    IF stage < 8 THEN
      KSFTY = 16 - 2 *stage
    ELSE
      KSFTY = 0
    END IF
    ATAKD = - 6                                       'defender > attacker
    HUNGP = - 8                                       'each hung piece
    HUNGX = - 12                                      'extra for >1 hung piece
  END IF
END SUB
