'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'

GLOBAL deltay  AS INTEGER
GLOBAL hitrgn[8]  AS HRGN

SUB InitHitTest ()
  DIM RAW ptls[4] AS POINT
  DIM RAW toppt AS POINT, botpt AS POINT
  DIM RAW i AS INTEGER
  i = 0
  WHILE i<8
    QuerySqOrigin (i, 0, ptls + 0)
    QuerySqOrigin (i, 8, ptls + 1)
    QuerySqOrigin (i + 1, 8, ptls + 2)
    QuerySqOrigin (i + 1, 0, ptls + 3)
    hitrgn[i] = CreatePolygonRgn (ptls, 4, WINDING)
    i++
  WEND
  QuerySqOrigin (0, 0, &botpt)
  QuerySqOrigin (0, 8, &toppt)
  deltay = botpt.y - toppt.y
END SUB

SUB Hittest_Destructor ()
  DIM RAW i AS INTEGER
  i = 0
  WHILE i<8
    DeleteObject (hitrgn[i])
    i++
  WEND
END SUB

FUNCTION HorzHitTest (x AS INTEGER, y AS INTEGER) AS INTEGER
  DIM RAW i AS INTEGER

  i = 0
  WHILE i<8
    IF PtInRegion (hitrgn[i], x, y) THEN
      FUNCTION = i
    END IF
    i++
  WEND
  FUNCTION = - 1
END FUNCTION

FUNCTION HitTest (x AS INTEGER, y AS INTEGER) AS INTEGER
  DIM RAW xsq AS INTEGER, ysq AS INTEGER
  DIM RAW sq00 AS POINT

  xsq = HorzHitTest (x, y)
  IF xsq = - 1 THEN
    FUNCTION = - 1
  END IF
  QuerySqOrigin (0, 0, &sq00)

  IF y > sq00.y THEN
    FUNCTION = - 1
  END IF
  IF y < (sq00.y - deltay) THEN
    FUNCTION = - 1
  END IF
  ysq = 7 - (y - (sq00.y - deltay)) / (deltay / 8)
  FUNCTION = (ysq *8 + xsq)
END FUNCTION

