'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'

FUNCTION ChessInit (hInstance AS HANDLE) AS BOOL
  DIM RAW hMemory AS HANDLE                               'handle to allocated memory
  DIM RAW pWndClass AS PWNDCLASS                          'structure pointer
  DIM RAW bSuccess AS BOOL                                'RegisterClass() result

  hMemory = LocalAlloc (LHND, SIZEOF (WNDCLASS))
  pWndClass = (PWNDCLASS) LocalLock (hMemory)

  pWndClass->style = (DWORD) NULL
  pWndClass->lpfnWndProc = (WNDPROC) ChessWndProc
  pWndClass->hInstance = hInstance
  pWndClass->hIcon = LoadIcon (hInstance, szAppName)
  pWndClass->hCursor = LoadCursor (NULL, IDC_ARROW)
  pWndClass->hbrBackground = GetStockObject (WHITE_BRUSH)
  pWndClass->lpszMenuName = (LPSTR) szAppName
  pWndClass->lpszClassName = (LPSTR) szAppName

  bSuccess = RegisterClass (pWndClass)

  LocalUnlock (hMemory)                                   'Unlocks the memory
  LocalFree (hMemory)                                     'Returns it to Windows

  FUNCTION = (bSuccess)                                   'Returns result of registering the window
END FUNCTION
