'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
'Copyright (c) 1988, 1989, 1990  John Stanback
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'


SUB Initialize_dist ()
  DIM RAW a AS INTEGER, b AS INTEGER, d AS INTEGER, di AS INTEGER

  a = 0
  WHILE a<64
    b = 0
    WHILE b<64
      d = ABS (column (a) - column (b))
      di = ABS (row (a) - row (b))
      *(taxidata + a *64 + b) = d + di
        ! *(distdata+a*64+b ) = (d > di ? d : di );
      b++
    WEND
    a++
  WEND
END SUB

SHAREDSET Stboard[64] AS INTEGER
  rook, knight, bishop, queen, king, bishop, knight, rook, pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn, rook, knight, bishop, queen, king, bishop, knight, rook
END SET

SHAREDSET Stcolor[64] AS INTEGER
  white, white, white, white, white, white, white, white, white, white, white, white, white, white, white, white, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, black, black, black, black, black, black, black, black, black, black, black, black, black, black, black, black
END SET

SHAREDSET direc[8][8] AS INTEGER
  0, 0, 0, 0, 0, 0, 0, 0, 10, 9, 11, 0, 0, 0, 0, 0, 8, - 8, 12, - 12, 19, - 19, 21, - 21, 9, 11, - 9, - 11, 0, 0, 0, 0, 1, 10, - 1, - 10, 0, 0, 0, 0, 1, 10, - 1, - 10, 9, 11, - 9, - 11, 1, 10, - 1, - 10, 9, 11, - 9, - 11, - 10, - 9, - 11, 0, 0, 0, 0, 0
END SET

SHAREDSET max_steps[8] AS INTEGER
  0, 2, 1, 7, 7, 7, 1, 2
END SET

SHAREDSET nunmap[120] AS INTEGER
  - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, 0, 1, 2, 3, 4, 5, 6, 7, - 1, - 1, 8, 9, 10, 11, 12, 13, 14, 15, - 1, - 1, 16, 17, 18, 19, 20, 21, 22, 23, - 1, - 1, 24, 25, 26, 27, 28, 29, 30, 31, - 1, - 1, 32, 33, 34, 35, 36, 37, 38, 39, - 1, - 1, 40, 41, 42, 43, 44, 45, 46, 47, - 1, - 1, 48, 49, 50, 51, 52, 53, 54, 55, - 1, - 1, 56, 57, 58, 59, 60, 61, 62, 63, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1, - 1
END SET

'
' This procedure pre-calculates all moves for every piece from every square.
' This data is stored in nextpos/nextdir and used later in the move generation
' routines.
'
SUB Initialize_moves ()
  DIM RAW ptyp AS INTEGER, po AS INTEGER, d AS INTEGER, di AS INTEGER, s AS INTEGER, delta AS INTEGER
  DIM RAW p0 AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR
  DIM RAW dest[8][8] AS INTEGER
  DIM RAW steps[8] AS INTEGER
  DIM RAW sorted[8] AS INTEGER


  ptyp = 0
  WHILE ptyp<8
    po = 0
    WHILE po<64
      p0 = 0
      WHILE p0<64
        *(nextpos + ptyp *64 *64 + po *64 + p0) = (UCHAR) po
        *(nextdir + ptyp *64 *64 + po *64 + p0) = (UCHAR) po
        p0++
      WEND
      po++
    WEND
    ptyp++
  WEND

  ptyp = 1
  WHILE ptyp<8
    po = 21
    WHILE po<99
      IF nunmap[po] >= 0 THEN
        ppos = nextpos + ptyp *64 *64 + nunmap[po] *64
        pdir = nextdir + ptyp *64 *64 + nunmap[po] *64
        ' dest is a function of direction and steps
        d = 0
        WHILE d<8
          dest[d][0] = nunmap[po]
          delta = direc[ptyp][d]

          IF delta <> 0 THEN
            p0 = po
            s = 0
            WHILE s < max_steps[ptyp]
              p0 = p0 + delta
              '
              'break if (off board) or
              '(pawns only move two steps from home square)
              '
              IF (nunmap[p0] < 0 OR (ptyp = pawn OR ptyp = bpawn) _
                AND s > 0 AND (d > 0 OR Stboard[nunmap[po]] <> pawn)) THEN
                EXIT DO
              ELSE
                dest[d][s] = nunmap[p0]
              END IF
              s++
            WEND
          ELSE
            s = 0
          END IF
          '
          'sort dest in number of steps order
          'currently no sort is done due to compability with
          'the move generation order in old gnu chess
          '
          'Compatibility with what? Lets try sorting.  GOK.
          '
          steps[d] = s
          di = d
          WHILE (s > 0 AND di > 0)
            IF (steps[sorted[di - 1]] < s) THEN '== 0) /* should be: < s */
              sorted[di] = sorted[di - 1]
            ELSE
              EXIT DO
            END IF
            di--
          WEND
          sorted[di] = d
          d++
        WEND
        '
        'update nextpos/nextdir,
        'pawns have two threads (capture and no capture)
        '
        p0 = nunmap[po]
        IF (ptyp = pawn OR ptyp = bpawn) THEN
          s = 0
          WHILE s < steps[0]
            ppos[p0] = (UCHAR) dest[0][s]
            p0 = dest[0][s]
            s++
          WEND
          p0 = nunmap[po]
          d = 1
          WHILE d < 3
            pdir[p0] = (UCHAR) dest[d][0]
            p0 = dest[d][0]
            d++
          WEND
        ELSE
          pdir[p0] = (UCHAR) dest[sorted[0]][0]
          d = 0
          WHILE d < 8
            s = 0
            WHILE s < steps[sorted[d]]
              ppos[p0] = (UCHAR) dest[sorted[d]][s]
              p0 = dest[sorted[d]][s]
              IF d < 7 THEN
                pdir[p0] = (UCHAR) dest[sorted[d + 1]][0]
                ' else is already initialized
              END IF
              s++
            WEND
            d++
          WEND
        END IF
      END IF
      po++
    WEND
    ptyp++
  WEND
END SUB

DIM RAW hGameList AS GLOBALHANDLE, hTree AS GLOBALHANDLE, hHistory AS GLOBALHANDLE, hTTable AS GLOBALHANDLE, hHashCode AS GLOBALHANDLE, hdistdata AS GLOBALHANDLE
DIM RAW htaxidata AS GLOBALHANDLE, hnextdir AS GLOBALHANDLE, hnextpos AS GLOBALHANDLE

' hmm.... shouldn`t main be moved to the interface routines
FUNCTION init_main (hWnd AS HWND) AS INTEGER
  DIM RAW ahead = true AS INTEGER, hash = true AS INTEGER

  ' Mods for MS WINDOWS includes moving statics to dynamic allocated

  hHistory = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (8192 *SIZEOF (char)))

  IF hHistory = NULL THEN
    FUNCTION = 1
  END IF
  history = (UCHAR *) GlobalLock (hHistory)

  hnextdir = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (64 *64 *8 *SIZEOF (char)))

  IF hnextdir = NULL THEN
    FUNCTION = 1
  END IF
  nextdir = (UCHAR *) GlobalLock (hnextdir)

  hnextpos = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (64 *64 *8 *SIZEOF (char)))

  IF hnextpos = NULL THEN
    FUNCTION = 1
  END IF
  nextpos = (UCHAR *) GlobalLock (hnextpos)

  hdistdata = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (64 *64 *SIZEOF (INTEGER)))

  IF hdistdata = NULL THEN
    FUNCTION = 1
  END IF
  distdata = (INTEGER *) GlobalLock (hdistdata)

  htaxidata = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (64 *64 *SIZEOF (INTEGER)))

  IF htaxidata = NULL THEN
    FUNCTION = 1
  END IF
  taxidata = (INTEGER *) GlobalLock (htaxidata)

  hHashCode = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (2 *7 *64 *SIZEOF (struct_hashval)))

  IF hHashCode = NULL THEN
    FUNCTION = 1
  END IF
  hashcode = (struct_hashval *) GlobalLock (hHashCode)

  hTree = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (2000 *SIZEOF (struct_leaf)))

  IF hTree = NULL THEN
    FUNCTION = 1
  END IF
  Tree = (struct_leaf *) GlobalLock (hTree)

  hGameList = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (512 *SIZEOF (struct_GameRec)))

  IF hGameList = NULL THEN
    FUNCTION = 1
  END IF
  GameList = (struct_GameRec *) GlobalLock (hGameList)

  hTTable = GlobalAlloc (GMEM_MOVEABLE BOR GMEM_ZEROINIT, (long) (2 *ttblsz *SIZEOF (struct_hashentry)))

  IF hTTable = NULL THEN
    FUNCTION = 1
  END IF
  ttable = (struct_hashentry *) GlobalLock (hTTable)

  Level = 0
  TCflag = false
  OperatorTime = 0
  Initialize ()
  Initialize_dist ()
  Initialize_moves ()
  NewGame (hWnd)
  GetOpenings (hWnd)

  flag.easy = ahead
  flag.hash = hash
  hashfile = NULL
  FUNCTION = (0)
END FUNCTION


SUB FreeChessGlobals ()
  IF hHistory THEN
    GlobalUnlock (hHistory)
    GlobalFree (hHistory)
  END IF
  IF hnextdir THEN
    GlobalUnlock (hnextdir)
    GlobalFree (hnextdir)
  END IF
  IF hGameList THEN
    GlobalUnlock (hGameList)
    GlobalFree (hGameList)
  END IF
  IF hTTable THEN
    GlobalUnlock (hTTable)
    GlobalFree (hTTable)
  END IF
  IF hTree THEN
    GlobalUnlock (hTree)
    GlobalFree (hTree)
  END IF
  IF hHashCode THEN
    GlobalUnlock (hHashCode)
    GlobalFree (hHashCode)
  END IF
  IF htaxidata THEN
    GlobalUnlock (htaxidata)
    GlobalFree (htaxidata)
  END IF
  IF hdistdata THEN
    GlobalUnlock (hdistdata)
    GlobalFree (hdistdata)
  END IF
  IF hnextpos THEN
    GlobalUnlock (hnextpos)
    GlobalFree (hnextpos)
  END IF
END SUB


SUB NewGame (hWnd AS HWND)

  '
  'Reset the board and other variables to start a new game.
  '

  DIM RAW l AS INTEGER, c AS INTEGER, p AS INTEGER

  stage = stage2 = - 1                                    'the game is not yet started

  IF flag.post THEN
    SendMessage (hStats, WM_SYSCOMMAND, SC_CLOSE, 0)
    flag.post = false
  END IF
  flag.mate = flag.quit = flag.reverse = flag.bothsides = false
  flag.force = false
  flag.hash = flag.easy = flag.beep = flag.rcptr = true
  NodeCnt = et0 = epsquare = 0
  dither = 0
  Awindow = 90
  Bwindow = 90
  xwndw = 90
  MaxSearchDepth = 29
  contempt = 0
  GameCnt = 0
  Game50 = 1
  hint = 0x0C14
  ZeroRPT ()
  Developed[white] = Developed[black] = false
  castld[white] = castld[black] = false
  PawnThreat[0] = CptrFlag[0] = false
  Pscore[0] = 12000
  Tscore[0] = 12000
  opponent = white
  computer = black
  '    Tree[l].f = Tree[l].t = 0;
  l = 0
  WHILE l<2000
    (Tree + l)  ->f = (Tree + l)  ->t = 0
    l++
  WEND

  rehash = 6
  ZeroTTable ()
  srand ((UINT) 1)
  c = white
  WHILE c<=black
    p = pawn
    WHILE p<=king
      l = 0
      WHILE l<64
        (hashcode + c *7 *64 + p *64 + l)  ->key = (((ULONG) urand ()))
        (hashcode + c *7 *64 + p *64 + l)  ->key + = (((ULONG) urand ()) < < 16)
        (hashcode + c *7 *64 + p *64 + l)  ->bd = (((ULONG) urand ()))
        (hashcode + c *7 *64 + p *64 + l)  ->bd + = (((ULONG) urand ()) < < 16)
        l++
      WEND
      p++
    WEND
    c++
  WEND

  l = 0
  WHILE l<64
    board[l] = Stboard[l]
    cColor[l] = Stcolor[l]
    Mvboard[l] = 0
    l++
  WEND
  IF TCflag THEN
    SetTimeControl ()
  ELSEIF Level = 0 THEN
    OperatorTime = 1
    TCmoves = 60
    TCminutes = 5
    TCflag = (TCmoves > 1)
    SetTimeControl ()
  END IF
  InitializeStats ()
  time0 = time ((ULONG *) 0)
  ElapsedTime (1)
  UpdateDisplay (hWnd, 0, 0, 1, 0)
END SUB

