'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
'Copyright (c) 1988, 1989, 1990  John Stanback
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'

SHAREDSET ColorStr[2] AS char PTR
  "White", "Black"
END SET

SUB ShowPlayers ()
  ' display in the status line what color the computer is playing
   !SetWindowText ( hComputerColor, (computer == black ) ? "Computer is black" : "Computer is white" ) ;
END SUB

SUB ShowDepth (ch AS char)
  DIM RAW tmp[30] AS char
  IF hStats THEN
    wsprintf (tmp, "%d%c", Sdepth, ch)
    SetDlgItemText (hStats, DEPTHTEXT, tmp)
  END IF
END SUB

SUB ShowScore (score AS INTEGER)
  DIM RAW tmp[30] AS char
  IF hStats THEN
    wsprintf (tmp, "%d", score)
    SetDlgItemText (hStats, SCORETEXT, tmp)
  END IF
END SUB

SUB ShowMessage (hWnd AS HWND, s AS char PTR)
  MessageBox (hWnd, s, "Chess", MB_OK BOR MB_ICONEXCLAMATION BOR MB_APPLMODAL)
END SUB

SUB SMessageBox (hWnd AS HWND, str_num AS INTEGER, str1_num AS INTEGER)
  DIM RAW sstr[80] AS char, str1[20] AS char
  LoadString ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), str_num, sstr, SIZEOF (sstr))
  LoadString ((HANDLE) GetWindowLong (hWnd, GWL_HINSTANCE), str1_num, str1, SIZEOF (str1))
  MessageBox (hWnd, sstr, str1, MB_OK BOR MB_ICONEXCLAMATION BOR MB_APPLMODAL)
END SUB

SUB ClearMessage ()
END SUB

SUB ShowCurrentMove (pnt AS INTEGER, f AS INTEGER, t AS INTEGER)
  DIM RAW tmp[30] AS char

  IF hStats THEN
    algbr (f, t, false)
    wsprintf (tmp, "(%2d) %4s", pnt, (char *) mvstr[0])
    SetDlgItemText (hStats, POSITIONTEXT, tmp)
  END IF
END SUB

SUB ShowSidetoMove ()
  DIM RAW tmp[30] AS char
  wsprintf (tmp, "It is %s's turn", (char *) ColorStr[player])
  SetWindowText (hWhosTurn, (LPSTR) tmp)

END SUB

SUB ShowPrompt ()
END SUB

SUB ShowNodeCnt (NodeCnt AS long, evrate AS long)
  DIM RAW tmp[40] AS char

  IF hStats THEN
    wsprintf (tmp, "%-8ld", NodeCnt)
    SetDlgItemText (hStats, NODETEXT, tmp)
    wsprintf (tmp, "%-5ld", evrate)
    SetDlgItemText (hStats, NODESECTEXT, tmp)
  END IF
END SUB

SUB ShowResults (score AS INTEGER, bstline AS UINT PTR, ch AS char)
  DIM RAW ply AS UCHAR                                    'd,
  DIM RAW str[300] AS char
  DIM RAW s AS INTEGER

  IF flag.post THEN
    ShowDepth (ch)
    ShowScore (score)
    'd = 7;
    s = 0
    ply = 1
    WHILE bstline[ply]>0
      algbr ((INTEGER) bstline[ply] >> 8, (INTEGER) bstline[ply] BAND 0xFF, false)
      IF ply = 5  OR  ply = 9  OR  ply = 13  OR  ply = 17 THEN
        $IPRINT_OFF
        s + = wsprintf (str + s, "\n")
        $IPRINT_ON
      END IF
      s + = wsprintf (str + s, "%-5s ", (char *) mvstr[0])
      ply++
    WEND
    SetDlgItemText (hStats, BSTLINETEXT, (LPSTR) str)
  END IF
END SUB

SUB SearchStartStuff (side AS INTEGER)

  UNREFERENCED_PARAMETER (side)


END SUB


SUB OutputMove (hWnd AS HWND)
  DIM RAW tmp[30] AS char
  UpdateDisplay (hWnd, root->f, root->t, 0, (INTEGER) root->flags)
  wsprintf (tmp, "My move is %s", (char *) mvstr[0])
  SetWindowText (hComputerMove, tmp)

  IF root->flags BAND draw THEN
    SMessageBox (hWnd, IDS_DRAWGAME, IDS_CHESS)
  ELSEIF root->score = - 9999 THEN
    SMessageBox (hWnd, IDS_YOUWIN, IDS_CHESS)
  ELSEIF root->score = 9998 THEN
    SMessageBox (hWnd, IDS_COMPUTERWIN, IDS_CHESS)
  ELSEIF root->score < - 9000 THEN
    SMessageBox (hWnd, IDS_MATESOON, IDS_CHESS)
  ELSEIF root->score > 9000 THEN
    SMessageBox (hWnd, IDS_COMPMATE, IDS_CHESS)
  END IF
  IF flag.post THEN
    ShowNodeCnt (NodeCnt, evrate)
    '
    'for (i = 1999; i >= 0 && Tree[i].f == 0 && Tree[i].t == 0; i--);
    'printz ("Max Tree= %5d", i);
    '
  END IF
END SUB

SUB UpdateClocks ()
  DIM RAW m AS INTEGER, s AS INTEGER
  DIM RAW tmp[20] AS char

  m = (INTEGER) (et / 60)
  s = (INTEGER) (et - 60 *(long) m)
  IF TCflag THEN
    m = (INTEGER) ((TimeControl.clock[player] - et) / 60)
    s = (INTEGER) (TimeControl.clock[player] - et - 60 *(long) m)
  END IF
  IF m < 0 THEN
    m = 0
  END IF
  IF s < 0 THEN
    s = 0
  END IF
  wsprintf (tmp, "%0d:%02d", m, s)
  IF player = computer THEN
    SetWindowText (hClockComputer, tmp)
  ELSE
    SetWindowText (hClockHuman, tmp)
  END IF
  IF flag.post THEN
    ShowNodeCnt (NodeCnt, evrate)
  END IF
END SUB

SUB ShowPostnValue (sq AS INTEGER)

  UNREFERENCED_PARAMETER (sq)

END SUB

SUB ShowPostnValues ()
END SUB

SUB DrawPiece (hWnd AS HWND, f AS INTEGER)
  DIM RAW aptl[4] AS POINT
  DIM RAW hRgn AS HRGN
  DIM RAW x AS INTEGER, y AS INTEGER

  IF flag.reverse THEN
    x = 7 - (f % 8)
    y = 7 - (f / 8)
  ELSE
    x = f % 8
    y = f / 8
  END IF
  QuerySqCoords (x, y, aptl + 0)
  hRgn = CreatePolygonRgn (aptl, 4, WINDING)
  InvalidateRgn (hWnd, hRgn, FALSE)
  DeleteObject (hRgn)
END SUB

SUB UpdateDisplay (hWnd AS HWND, f AS INTEGER, t AS INTEGER, redraw AS INTEGER, isspec AS INTEGER)
  DIM RAW sq AS INTEGER

  sq = 0
  WHILE sq<64
    boarddraw[sq] = board[sq]
    colordraw[sq] = cColor[sq]
    sq++
  WEND

  IF redraw THEN
    InvalidateRect (hWnd, NULL, TRUE)
    ShowPlayers ()
    UpdateWindow (hWnd)
  ELSE
    DrawPiece (hWnd, f)
    DrawPiece (hWnd, t)
    IF isspec BAND cstlmask THEN
      IF t > f THEN
        DrawPiece (hWnd, f + 3)
        DrawPiece (hWnd, t - 1)
      ELSE
        DrawPiece (hWnd, f - 4)
        DrawPiece (hWnd, t + 1)
      END IF
    ELSEIF isspec BAND epmask THEN
      DrawPiece (hWnd, t - 8)
      DrawPiece (hWnd, t + 8)
    END IF
    UpdateWindow (hWnd)
  END IF
END SUB

SUB GiveHint (hWnd AS HWND)
  DIM RAW s[40] AS char
  algbr ((INTEGER) (hint > > 8), (INTEGER) (hint BAND 0xFF), false)
  strcpy (s, "try ")
  strcat (s, mvstr[0])
  ShowMessage (hWnd, s)
END SUB

