'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Based on Ideas and code segments of Charles Petzold from artices in
'MicroSoft Systems Journal.
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'


CONST PIECE_XAXIS = 32
CONST PIECE_YAXIS = 32
CONST struct_PIECEBITMAP = struct PIECEBITMAP

SUB QuerySqCenter (x AS INTEGER, y AS INTEGER, pptl AS POINT PTR)
  DIM RAW aptl[4] AS POINT

  QuerySqCoords (x, y, aptl)

  pptl->x = (aptl[0] .x + aptl[1] .x + aptl[2] .x + aptl[3] .x) / 4
  pptl->y = (aptl[0] .y + aptl[2] .y) / 2
END SUB


SUB PieceOriginFromCenter (pptl AS POINT PTR)
  pptl->x - = PIECE_XAXIS / 2
  pptl->y - = PIECE_YAXIS / 2
END SUB

SUB QuerySqPieceOrigin (x AS INTEGER, y AS INTEGER, pptl AS POINT PTR)
  QuerySqCenter (x, y, pptl)
  PieceOriginFromCenter (pptl)
END SUB


'
'Draw a piece in the specificed point
'
'Piece_bitmap is a structure with the handles for the mask,
'outline and piece.
'
'

SUB ShowPiece (hDC AS HDC, pptl AS POINT PTR, Piece_bitmap AS struct_PIECEBITMAP PTR, ccolor AS DWORD)
  DIM RAW hMemDC AS HDC
  DIM RAW hBrush AS HBRUSH, hOldBrush AS HBRUSH
  DIM RAW hOldPen AS HPEN


  hOldBrush = SelectObject (hDC, GetStockObject (BLACK_BRUSH))
  hOldPen = SelectObject (hDC, GetStockObject (BLACK_PEN))

  hMemDC = CreateCompatibleDC (hDC)

  ' Write the mask to clear the space
  SelectObject (hMemDC, Piece_bitmap->mask)
  BitBlt (hDC, pptl->x, pptl->y, PIECE_XAXIS, PIECE_YAXIS, hMemDC, 0, 0, SRCAND)

  ' Write out the piece with an OR

  hBrush = CreateSolidBrush (ccolor)
  SelectObject (hDC, hBrush)

  SelectObject (hMemDC, Piece_bitmap->piece)
  BitBlt (hDC, pptl->x, pptl->y, PIECE_XAXIS, PIECE_YAXIS, hMemDC, 0, 0, 0xB80746L)

  ' The draw the outline

  SelectObject (hDC, GetStockObject (BLACK_BRUSH))
  SelectObject (hMemDC, Piece_bitmap->outline)
  BitBlt (hDC, pptl->x, pptl->y, PIECE_XAXIS, PIECE_YAXIS, hMemDC, 0, 0, 0xB80746L)


  SelectObject (hDC, hOldBrush)
  SelectObject (hDC, hOldPen)
  DeleteObject (hBrush)

  IF DeleteDC (hMemDC) = 0 THEN
    MessageBeep (0)
  END IF
END SUB

FUNCTION ConvertCoordToIndex (x AS INTEGER, y AS INTEGER) AS INTEGER
  FUNCTION = (y *8 + x)
END FUNCTION

SUB DrawOnePiece (hDC AS HDC, x AS INTEGER, y AS INTEGER, piece AS struct_PIECEBITMAP PTR, ccolor AS DWORD)
  DIM RAW origin AS POINT

  QuerySqPieceOrigin (x, y, &origin)
  ShowPiece (hDC, &origin, piece, ccolor)

END SUB



SUB DrawAllPieces (hDC AS HDC, reverse AS INTEGER, pbrd AS INTEGER PTR, ccolor AS INTEGER PTR, clrblack AS DWORD, clrwhite AS DWORD)
  DIM RAW x AS INTEGER, y AS INTEGER
  DIM RAW i AS INTEGER

  y = 0
  WHILE y<8
    x = 0
    WHILE x<8
      i = ConvertCoordToIndex (x, y)
      IF *(ccolor + i) <> NETURAL THEN
        IF reverse = 0 THEN
               !DrawOnePiece ( hDC , x , y , pieces + * ( pbrd + i ) , ( * ( ccolor + i ) == BLACK ) ? clrblack : clrwhite ) ;
        ELSE
               !DrawOnePiece ( hDC , 7 - x , 7 - y , pieces + * ( pbrd + i ) , ( * ( ccolor + i ) == BLACK ) ? clrblack : clrwhite ) ;
        END IF
      END IF
      x++
    WEND
    y++
  WEND
END SUB
