'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'


FUNCTION ReviewDialog (hWnd AS HWND, hInst AS HANDLE) AS INTEGER
  DIM RAW lpProcReview AS FARPROC
  DIM RAW status AS INTEGER

  lpProcReview = (FARPROC) MakeProcInstance (ReviewDlgProc, hInst)
  status = DialogBoxParam (hInst, MAKEINTRESOURCE (REVIEW), hWnd, (DLGPROC) lpProcReview, 0)
  FreeProcInstance (lpProcReview)
  FUNCTION = status
END FUNCTION

FUNCTION ReviewDlgProc (hDlg AS HWND, message AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK
  DIM RAW i AS INTEGER, f AS INTEGER, t AS INTEGER
  DIM RAW tmp[50] AS char

  UNREFERENCED_PARAMETER (lParam)

  SELECT CASE (message)
    '  message: initialize dialog box
  CASE WM_INITDIALOG
    i = 1
    WHILE i<=GameCnt
      f = GameList[i] .gmove > > 8
      t = (GameList[i] .gmove BAND 0xFF)
      algbr (f, t, false)
         !wsprintf (tmp, "%4d-%c\t%5s\t%-5d\t%-2d\t%-5d", (i+1 ) /2, (i%2 ?'w':'b'), (char*) mvstr[0], GameList[i].score, GameList[i].depth, GameList[i].time);
      SendDlgItemMessage (hDlg, 100, LB_ADDSTRING, 0, (LONG) tmp)
      i++
    WEND
    SendDlgItemMessage (hDlg, 100, WM_SETREDRAW, TRUE, 0)
    FUNCTION = (TRUE)

  CASE WM_SYSCOMMAND
    IF (wParam BAND 0xfff0) = SC_CLOSE THEN
      EndDialog (hDlg, (INTEGER) NULL)
      FUNCTION = TRUE
    END IF


    '  message: received a command
  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))

    CASE IDOK
      EndDialog (hDlg, 1)
      FUNCTION = TRUE

    END SELECT
  END SELECT

  FUNCTION = (FALSE)                                      'Didn't process a message
END FUNCTION

