'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Based on ideas and code segments from "programming windows" C. Petzold
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'
'
'File open/save dialog box routines
'
'int DoFileOpenDlg ( hInst, hWnd, szFileSpecIn, szDefExtIn, wFileAttrIn,
'szFileNameOut, pofIn)
'
'int DoWildFileOpenDlg ( hInst, hWnd, szFileSpecIn, szDefExtIn, wFileAttrIn,
'szFileNameOut, pofIn)
'
'int DoFileSaveDlg ( hInst, hWnd, szFileSpecIn, szDefExtIn, pwStatusOut,
'szFileNameOut, pofIn)
'
'
'DoWildFileOpenDlg Allows a wildcard to be returned.
'
'to use:
'in rc file:
'#rcinclude "saveopen.dlg"
'
'in def file:
'Exports
'FileOpenDlgProc
'FileSaveDlgProc
'WildFileOpenDlgProc
'
'in source:
'#include "saveopen.h"
'...
'if ( !DoFileSaveDlg ( hInst, hWnd, "chess.chs", ".chs", &Status,
'FileName, &pof) ) break;
'if ( Status == 1 ) {
'strcpy ( str, "Replace Existing ");
'strcat ( str, FileName);
'if ( MessageBox ( hWnd, str, szAppName, MB_YESNO | MB_ICONQUESTION) == IDNO)
'break;
'
'} else OpenFile (FileName, pof, OF_PARSE);
'
'SaveGame ( pof->szPathName );
'
'if ( !DoFileOpenDlg ( hInst, hWnd, "*.chs", ".chs", 0x0, FileName, &pof))
'break;
'
'if ( (hFile=OpenFile(FileName, pof, OF_READ|OF_REOPEN)) == -1) {
'strcpy ( str, "Cannot open file: ");
'strcat ( str, FileName);
'MessageBox (hWnd, str, szAppName, MB_OK);
'break;
'}
'_lclose ( hFile );
'GetGame ( pof->szPathName );
'
CONST IDD_FNAME = 0x10
CONST IDD_FPATH = 0x11
CONST IDD_FLIST = 0x12
CONST IDD_DLIST = 0x13
CONST IDD_BROWSE = 0x14


' FileDlg.c

GLOBAL szDefExt[5]  AS char
GLOBAL szFileName[96]  AS char
GLOBAL szFileSpec[16]  AS char
GLOBAL wFileAttr  AS DWORD, wStatus  AS DWORD
GLOBAL pof  AS POFSTRUCT

FUNCTION DoFileOpenDlg (hInst AS HANDLE, hWnd AS HWND, szFileSpecIn AS char PTR, szDefExtIn AS char PTR, wFileAttrIn AS DWORD, szFileNameOut AS char PTR, pofIn AS POFSTRUCT) AS INTEGER
  DIM RAW lpfnFileOpenProc AS FARPROC
  DIM RAW iReturn AS INTEGER

  strcpy (szFileSpec, szFileSpecIn)
  strcpy (szDefExt, szDefExtIn)
  wFileAttr = wFileAttrIn
  pof = pofIn

  lpfnFileOpenProc = (FARPROC) MakeProcInstance (FileOpenDlgProc, hInst)
  iReturn = DialogBox (hInst, MAKEINTRESOURCE (FILEOPEN), hWnd, (DLGPROC) lpfnFileOpenProc)
  FreeProcInstance (lpfnFileOpenProc)

  strcpy (szFileNameOut, szFileName)
  FUNCTION = iReturn
END FUNCTION

FUNCTION DoWildFileOpenDlg (hInst AS HANDLE, hWnd AS HWND, szFileSpecIn AS char PTR, szDefExtIn AS char PTR, wFileAttrIn AS DWORD, szFileNameOut AS char PTR, pofIn AS POFSTRUCT) AS INTEGER
  DIM RAW lpfnFileOpenProc AS FARPROC
  DIM RAW iReturn AS INTEGER

  strcpy (szFileSpec, szFileSpecIn)
  strcpy (szDefExt, szDefExtIn)
  wFileAttr = wFileAttrIn
  pof = pofIn

  lpfnFileOpenProc = (FARPROC) MakeProcInstance (WildFileOpenDlgProc, hInst)
  iReturn = DialogBox (hInst, MAKEINTRESOURCE (WILDFILEOPEN), hWnd, (DLGPROC) lpfnFileOpenProc)
  FreeProcInstance (lpfnFileOpenProc)

  strcpy (szFileNameOut, szFileName)
  FUNCTION = iReturn
END FUNCTION


FUNCTION DoFileSaveDlg (hInst AS HANDLE, hWnd AS HWND, szFileSpecIn AS char PTR, szDefExtIn AS char PTR, pwStatusOut AS DWORD PTR, szFileNameOut AS char PTR, pofIn AS POFSTRUCT) AS INTEGER
  DIM RAW lpfnFileSaveProc AS FARPROC
  DIM RAW iReturn AS INTEGER

  strcpy (szFileSpec, szFileSpecIn)
  strcpy (szDefExt, szDefExtIn)
  pof = pofIn

  lpfnFileSaveProc = (FARPROC) MakeProcInstance (FileSaveDlgProc, hInst)
  iReturn = DialogBox (hInst, MAKEINTRESOURCE (FILESAVE), hWnd, (DLGPROC) lpfnFileSaveProc)
  FreeProcInstance (lpfnFileSaveProc)

  strcpy (szFileNameOut, szFileName)
  *pwStatusOut = wStatus
  FUNCTION = iReturn
END FUNCTION

FUNCTION FileOpenDlgProc (hDlg AS HWND, iMessage AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK
  DIM RAW cLastChar AS char
  DIM RAW nEditLen AS INTEGER

  SELECT CASE (iMessage)
  CASE WM_INITDIALOG
    SendDlgItemMessage (hDlg, IDD_FNAME, EM_LIMITTEXT, 80, 0L)
    DlgDirList (hDlg, szFileSpec, IDD_FLIST, IDD_FPATH, wFileAttr)
    DlgDirList (hDlg, szFileSpec, IDD_DLIST, (INTEGER) NULL, 0x4010|0x8000)
    SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
    FUNCTION = TRUE

  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))
    CASE IDD_FLIST
      SELECT CASE (HIWORD (wParam))
      CASE LBN_SELCHANGE
        IF DlgDirSelectEx (hDlg, szFileName, SIZEOF (szFileName), IDD_FLIST) THEN
          strcat (szFileName, szFileSpec)
        END IF
        SetDlgItemText (hDlg, IDD_FNAME, szFileName)

      CASE LBN_DBLCLK
        IF DlgDirSelectEx (hDlg, szFileName, SIZEOF (szFileName), IDD_FLIST) THEN
          strcat (szFileName, szFileSpec)
          DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr)
          SetDlgItemText (hDlg, IDD_FNAME, szFileName)
        ELSE
          SetDlgItemText (hDlg, IDD_FNAME, szFileName)
          SendMessage (hDlg, WM_COMMAND, IDOK, 0L)
        END IF
      END SELECT

    CASE IDD_DLIST
      SELECT CASE (HIWORD (wParam))
      CASE LBN_DBLCLK
        IF DlgDirSelectEx (hDlg, szFileName, SIZEOF (szFileName), IDD_DLIST) THEN
          strcat (szFileName, szFileSpec)
          DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr)
          DlgDirList (hDlg, szFileName, IDD_DLIST, (INTEGER) NULL, 0x4010|0x8000)
          SetDlgItemText (hDlg, IDD_FNAME, szFileName)
        END IF
      END SELECT


    CASE IDD_FNAME
      IF HIWORD (wParam) = EN_CHANGE THEN
        EnableWindow (GetDlgItem (hDlg, IDOK), (BOOL) SendMessage ((HWND) lParam, WM_GETTEXTLENGTH, 0, 0L))
      END IF

    CASE IDOK
      GetDlgItemText (hDlg, IDD_FNAME, szFileName, 80)
      nEditLen = strlen (szFileName)
      cLastChar = *AnsiPrev (szFileName, szFileName + nEditLen)

      IF cLastChar = 92  OR  cLastChar = 58 THEN
        strcat (szFileName, szFileSpec)
      END IF
      IF strchr (szFileName, 42)  OR  strchr (szFileName, ASC("?")) THEN
        IF DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr) THEN
          strcpy (szFileSpec, szFileName)
          SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
        ELSE
          MessageBeep (0) : EXIT LOOP
        END IF
      END IF
      $IPRINT_OFF
      strcat (strcat (szFileName, "\\"), szFileSpec)
      $IPRINT_ON

      IF DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr) THEN
        strcpy (szFileSpec, szFileName)
        SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
        EXIT LOOP
      END IF
      szFileName[nEditLen] = 0

      IF OpenFile (szFileName, pof, OF_READ|OF_EXIST) = - 1 THEN
        strcat (szFileName, szDefExt)
        IF OpenFile (szFileName, pof, OF_READ|OF_EXIST) = - 1 THEN
          MessageBeep (0)
          EXIT LOOP
        END IF
      END IF
      strcpy (szFileName, (PSTR) AnsiNext (strrchr (pof->szPathName, 92)))
      OemToAnsi (szFileName, szFileName)
      EndDialog (hDlg, TRUE)

    CASE IDCANCEL
      EndDialog (hDlg, FALSE)

    CASE ELSE
      FUNCTION = FALSE
    END SELECT
  CASE ELSE
    FUNCTION = FALSE
  END SELECT
  FUNCTION = TRUE
END FUNCTION

FUNCTION WildFileOpenDlgProc (hDlg AS HWND, iMessage AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK
  DIM RAW cLastChar AS char
  DIM RAW nEditLen AS INTEGER

  SELECT CASE (iMessage)
  CASE WM_INITDIALOG
    SendDlgItemMessage (hDlg, IDD_FNAME, EM_LIMITTEXT, 80, 0L)
    DlgDirList (hDlg, szFileSpec, IDD_FLIST, IDD_FPATH, wFileAttr)
    DlgDirList (hDlg, szFileSpec, IDD_DLIST, (INTEGER) NULL, 0x4010|0x8000)
    SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
    FUNCTION = TRUE

  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))
    CASE IDD_FLIST
      SELECT CASE (HIWORD (wParam))
      CASE LBN_SELCHANGE
        IF DlgDirSelectEx (hDlg, szFileName, SIZEOF (szFileName), IDD_FLIST) THEN
          strcat (szFileName, szFileSpec)
        END IF
        SetDlgItemText (hDlg, IDD_FNAME, szFileName)

      CASE LBN_DBLCLK
        IF DlgDirSelectEx (hDlg, szFileName, SIZEOF (szFileName), IDD_FLIST) THEN
          strcat (szFileName, szFileSpec)
          DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr)
          SetDlgItemText (hDlg, IDD_FNAME, szFileName)
        ELSE
          SetDlgItemText (hDlg, IDD_FNAME, szFileName)
          SendMessage (hDlg, WM_COMMAND, IDOK, 0L)
        END IF
      END SELECT

    CASE IDD_DLIST
      SELECT CASE (HIWORD (wParam))
      CASE LBN_DBLCLK
        IF DlgDirSelectEx (hDlg, szFileName, SIZEOF (szFileName), IDD_DLIST) THEN
          strcat (szFileName, szFileSpec)
          DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr)
          DlgDirList (hDlg, szFileName, IDD_DLIST, (INTEGER) NULL, 0x4010|0x8000)
          SetDlgItemText (hDlg, IDD_FNAME, szFileName)
        END IF
      END SELECT


    CASE IDD_FNAME
      IF HIWORD (wParam) = EN_CHANGE THEN
        EnableWindow (GetDlgItem (hDlg, IDOK), (BOOL) SendMessage ((HWND) lParam, WM_GETTEXTLENGTH, 0, 0L))
      END IF

    CASE IDD_BROWSE
      GetDlgItemText (hDlg, IDD_FNAME, szFileName, 80)
      nEditLen = strlen (szFileName)
      cLastChar = *AnsiPrev (szFileName, szFileName + nEditLen)

      IF cLastChar = 92  OR  cLastChar = 58 THEN
        strcat (szFileName, szFileSpec)
      END IF
      IF strchr (szFileName, 42)  OR  strchr (szFileName, ASC("?")) THEN
        IF DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr) THEN
          strcpy (szFileSpec, szFileName)
          SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
        ELSE
          MessageBeep (0) : EXIT LOOP
        END IF
      END IF
      $IPRINT_OFF
      strcat (strcat (szFileName, "\\"), szFileSpec)
      $IPRINT_ON

      IF DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr) THEN
        strcpy (szFileSpec, szFileName)
        SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
        EXIT LOOP
      END IF
      szFileName[nEditLen] = 0

      IF OpenFile (szFileName, pof, OF_READ|OF_EXIST) = - 1 THEN
        strcat (szFileName, szDefExt)
        IF OpenFile (szFileName, pof, OF_READ|OF_EXIST) = - 1 THEN
          MessageBeep (0)
          EXIT LOOP
        END IF
      END IF
      '
      'strcpy ( szFileName, (PSTR) AnsiNext(strrchr(pof->szPathName,'\\')));
      'OemToAnsi( szFileName, szFileName);
      'EndDialog (hDlg, TRUE);
      '

    CASE IDOK
      GetDlgItemText (hDlg, IDD_FNAME, szFileName, 80)
      nEditLen = strlen (szFileName)
      cLastChar = *AnsiPrev (szFileName, szFileName + nEditLen)

      IF cLastChar = 92  OR  cLastChar = 58 THEN
        strcat (szFileName, szFileSpec)
      END IF
      IF strchr (szFileName, 42)  OR  strchr (szFileName, ASC("?")) THEN
        IF DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr) THEN
          '
          'strcpy (szFileSpec, szFileName);
          'SetDlgItemText (hDlg, IDD_FNAME, szFileSpec);
          '
          OemToAnsi (szFileName, szFileName)
          EndDialog (hDlg, TRUE)
        ELSE
          MessageBeep (0) : EXIT LOOP
        END IF
      END IF
      $IPRINT_OFF
      strcat (strcat (szFileName, "\\"), szFileSpec)
      $IPRINT_ON

      IF DlgDirList (hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr) THEN
        strcpy (szFileSpec, szFileName)
        SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
        EXIT LOOP
      END IF
      szFileName[nEditLen] = 0

      IF OpenFile (szFileName, pof, OF_READ|OF_EXIST) = - 1 THEN
        strcat (szFileName, szDefExt)
        IF OpenFile (szFileName, pof, OF_READ|OF_EXIST) = - 1 THEN
          MessageBeep (0)
          EXIT LOOP
        END IF
      END IF
      strcpy (szFileName, (PSTR) AnsiNext (strrchr (pof->szPathName, 92)))
      OemToAnsi (szFileName, szFileName)
      EndDialog (hDlg, TRUE)

    CASE IDCANCEL
      EndDialog (hDlg, FALSE)

    CASE ELSE
      FUNCTION = FALSE
    END SELECT
  CASE ELSE
    FUNCTION = FALSE
  END SELECT
  FUNCTION = TRUE
END FUNCTION

FUNCTION FileSaveDlgProc (hDlg AS HWND, iMessage AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK

  SELECT CASE (iMessage)
  CASE WM_INITDIALOG
    SendDlgItemMessage (hDlg, IDD_FNAME, EM_LIMITTEXT, 80, 0L)
    DlgDirList (hDlg, szFileSpec, 0, IDD_FPATH, 0)
    SetDlgItemText (hDlg, IDD_FNAME, szFileSpec)
    FUNCTION = TRUE

  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))
    CASE IDD_FNAME
      IF HIWORD (wParam) = EN_CHANGE THEN
        EnableWindow (GetDlgItem (hDlg, IDOK), (BOOL) SendMessage ((HWND) lParam, WM_GETTEXTLENGTH, 0, 0L))
      END IF

    CASE IDOK
      GetDlgItemText (hDlg, IDD_FNAME, szFileName, 80)
      IF OpenFile (szFileName, pof, OF_PARSE) = - 1 THEN
        MessageBeep (0)
        EXIT LOOP
      END IF
      IF  NOT  strchr ((PSTR) AnsiNext (strrchr (pof->szPathName, 92)), ASC(".")) THEN
        strcat (szFileName, szDefExt)
      END IF
      IF OpenFile (szFileName, pof, OF_WRITE|OF_EXIST) <> - 1 THEN
        wStatus = 1
      ELSEIF OpenFile (szFileName, pof, OF_CREATE|OF_EXIST) <> - 1 THEN
        wStatus = 0
      ELSE
        MessageBeep (0)
        EXIT LOOP
      END IF
      strcpy (szFileName, (PSTR) AnsiNext (strrchr (pof->szPathName, 92)))
      OemToAnsi (szFileName, szFileName)
      EndDialog (hDlg, TRUE)

    CASE IDCANCEL
      EndDialog (hDlg, FALSE)

    CASE ELSE
      FUNCTION = FALSE
    END SELECT

  CASE ELSE
    FUNCTION = FALSE
  END SELECT

  FUNCTION = TRUE
END FUNCTION


