'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
'Copyright (c) 1988, 1989, 1990  John Stanback
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'


SHAREDSET value[7] AS INTEGER
  0, valueP, valueN, valueB, valueR, valueQ, valueK
END SET

SHAREDSET sweep[8] AS INTEGER
  false, false, false, true, true, true, false, false
END SET


' ............    MOVE GENERATION & SEARCH ROUTINES    ..............

SUB pick (p1 AS INTEGER, p2 AS INTEGER)

  '
  'Find the best move in the tree between indexes p1 and p2. Swap the best
  'move into the p1 element.
  '

  DIM RAW p AS INTEGER, s AS INTEGER
  DIM RAW p0 AS INTEGER, s0 AS INTEGER
  ! struct leaf temp;

  s0 = Tree[p1] .score
  p0 = p1
  p = p1 + 1
  WHILE p<=p2
    s = Tree [ p ] .score
    IF s > s0 THEN
      s0 = s
      p0 = p
    END IF
    p++
  WEND
  IF p0 <> p1 THEN
    temp = Tree[p1]
    Tree[p1] = Tree[p0]
    Tree[p0] = temp
  END IF
END SUB

SUB SelectMove (hWnd AS HWND, side AS INTEGER, iop AS INTEGER)

  '
  'Select a move by calling function search() at progressively deeper ply
  'until time is up or a mate or draw is reached. An alpha-beta window of -90
  'to +90 points is set around the score returned from the previous
  'iteration. If Sdepth != 0 then the program has correctly predicted the
  'opponents move and the search will start at a depth of Sdepth+1 rather
  'than a depth of 1.
  '

  STATIC i AS INTEGER, tempb AS INTEGER, tempc AS INTEGER, tempsf AS INTEGER, tempst AS INTEGER, xside AS INTEGER, rpt AS INTEGER
  STATIC alpha AS INTEGER, beta AS INTEGER, score AS INTEGER

  flag.timeout = false
  xside = otherside[side]
  IF iop <> 2 THEN
    player = side
  END IF
  IF TCflag THEN
    IF (TimeControl.moves[side] + 3) <> 0 THEN
      ResponseTime = (TimeControl.clock[side]) / (TimeControl.moves[side] + 3) - OperatorTime
    ELSE
      ResponseTime = 0
    END IF
    ResponseTime + = (ResponseTime *TimeControl.moves[side]) / (2 *TCmoves + 1)
  ELSE
    ResponseTime = Level
  END IF
  IF iop = 2 THEN
    ResponseTime = 99999
  END IF


  IF Sdepth > 0  AND  root->score > Zscore - zwndw THEN
    ResponseTime - = ft
  ELSEIF ResponseTime < 1 THEN
    ResponseTime = 1
  END IF
  ExtraTime = 0
  ExaminePosition ()
  ScorePosition (side, &score)
  ' Pscore[0] = -score;
  ShowSidetoMove ()

  IF Sdepth = 0 THEN

    SearchStartStuff (side)

    memset (history, 0, 8192 *SIZEOF (char))

    FROMsquare = TOsquare = - 1
    PV = 0
    IF iop <> 2 THEN
      hint = 0
    END IF
    i = 0
    WHILE i<maxdepth
      PrVar[i] = killr0[i] = killr1[i] = killr2[i] = killr3[i] = 0
      i++
    WEND
    alpha = score - 90
    beta = score + 90
    rpt = 0
    TrPnt[1] = 0
    root = &Tree[0]
    MoveList (side, 1)
    i = TrPnt [1]
    WHILE i<TrPnt[2]
      pick (i, TrPnt[2] - 1)
      i++
    WEND
    IF Book <> NULL THEN
      OpeningBook (&hint)
    END IF
    IF Book <> NULL THEN
      flag.timeout = true
    END IF
    NodeCnt = ETnodes = EvalNodes = HashCnt = FHashCnt = HashCol = 0
    Zscore = 0
    zwndw = 20
  END IF
  WHILE  NOT  flag.timeout  AND  Sdepth < MaxSearchDepth
    Sdepth++
    ShowDepth (32)
    score = search (side, 1, Sdepth, alpha, beta, PrVar, &rpt)
    i = 1
    WHILE i<=Sdepth
      killr0[i] = PrVar[i]
      i++
    WEND
    IF score < alpha THEN
      ShowDepth (45)
      ExtraTime = 10 *ResponseTime
      ' ZeroTTable ();
      score = search (side, 1, Sdepth, - 9000, score, PrVar, &rpt)
    END IF
    IF score > beta  AND   NOT  (root->flags BAND exact) THEN
      ShowDepth (43)
      ExtraTime = 0
      ' ZeroTTable ();
      score = search (side, 1, Sdepth, score, 9000, PrVar, &rpt)
    END IF
    score = root->score
    IF  NOT  flag.timeout THEN
      i = TrPnt [1] + 1
      WHILE i<TrPnt[2]
        pick (i, TrPnt[2] - 1)
        i++
      WEND
    END IF
    ShowResults (score, PrVar, ASC("."))
    i = 1
    WHILE i<=Sdepth
      killr0[i] = PrVar[i]
      i++
    WEND
    IF score > Zscore - zwndw  AND  score > Tree[1] .score + 250 THEN
      ExtraTime = 0
    ELSEIF score > Zscore - 3 *zwndw THEN
      ExtraTime = ResponseTime
    ELSE
      ExtraTime = 3 *ResponseTime
    END IF
    IF root->flags BAND exact THEN
      flag.timeout = true
    END IF
    IF Tree[1] .score < - 9000 THEN
      flag.timeout = true
    END IF
    IF 4 *et > 2 *ResponseTime + ExtraTime THEN
      flag.timeout = true
    END IF
    IF  NOT  flag.timeout THEN
      Tscore[0] = score
      IF Zscore = 0 THEN
        Zscore = score
      ELSE
        Zscore = (Zscore + score) / 2
      END IF
    END IF
    zwndw = 20 + ABS (Zscore / 12)
    beta = score + Bwindow
    IF Zscore < score THEN
      alpha = Zscore - Awindow - zwndw
    ELSE
      alpha = score - Awindow - zwndw
    END IF
  WEND

  score = root->score
  IF rpt >= 2  OR  score < - 12000 THEN
    root->flags |= draw
  END IF
  IF iop = 2 THEN
    EXIT SUB
  END IF
  IF Book = NULL THEN
    hint = PrVar[2]
  END IF
  ElapsedTime (1)

  IF score > - 9999  AND  rpt <= 2 THEN
    MakeMove (side, root, &tempb, &tempc, &tempsf, &tempst, &INCscore)
    algbr (root->f, root->t, (INTEGER) root->flags)
  ELSE
    algbr (0, 0, 0)
  END IF
  OutputMove (hWnd)
  IF score = - 9999  OR  score = 9998 THEN
    flag.mate = true
  END IF
  IF flag.mate THEN
    hint = 0
  END IF
  IF (board[root->t] = pawn)  OR  (root->flags BAND capture)  OR  (root->flags BAND cstlmask) THEN
    Game50 = GameCnt
    ZeroRPT ()
  END IF
  GameList[GameCnt].score = score
  GameList[GameCnt].nodes = NodeCnt
  GameList[GameCnt].time = (INTEGER) et
  GameList[GameCnt].depth = Sdepth
  IF TCflag THEN
    TimeControl.clock[side] - = (et + OperatorTime)
    IF --TimeControl.moves[side] = 0 THEN
      SetTimeControl ()
    END IF
  END IF
  IF (root->flags BAND draw)  AND  flag.bothsides THEN
    flag.mate = true
  END IF
  IF GameCnt > 470 THEN                                      'out of move store, you loose
    flag.mate = true
  END IF
  player = xside
  Sdepth = 0
END SUB


$HEADER

#define UpdateSearchStatus \
{\
   if (flag.post) ShowCurrentMove(pnt,node->f,node->t);\
     if (pnt > TrPnt[1])\
       {\
          d = best-Zscore; e = best-node->score;\
            if (best < alpha) ExtraTime = 10*ResponseTime;\
            else if (d > -zwndw && e > 4*zwndw) ExtraTime = -ResponseTime/3;\
            else if (d > -zwndw) ExtraTime = 0;\
            else if (d > -3*zwndw) ExtraTime = ResponseTime;\
            else if (d > -9*zwndw) ExtraTime = 3*ResponseTime;\
            else ExtraTime = 5*ResponseTime;\
            }\
            }
#define prune (cf && score+node->score < alpha)
#define ReCapture (flag.rcptr && score > alpha && score < beta &&\
                   ply > 2 && CptrFlag[ply-1] && CptrFlag[ply-2])
/* && depth == Sdepth-ply+1 */
#define Parry (hung[side] > 1 && ply == Sdepth+1)
#define MateThreat (ply < Sdepth+4 && ply > 4 &&\
                    ChkFlag[ply-2] && ChkFlag[ply-4] &&\
                    ChkFlag[ply-2] != ChkFlag[ply-4])
$HEADER

'
'Perform an alpha-beta search to determine the score for the current board
'position. If depth <= 0 only capturing moves, pawn promotions and
'responses to check are generated and searched, otherwise all moves are
'processed. The search depth is modified for check evasions, certain
're-captures and threats. Extensions may continue for up to 11 ply beyond
'the nominal search depth.
'
FUNCTION search (side AS INTEGER, ply AS INTEGER, depth AS INTEGER, alpha AS INTEGER, beta AS INTEGER, bstline AS UINT PTR, rpt AS INTEGER PTR) AS INTEGER
  DIM RAW j AS INTEGER, pnt AS INTEGER
  DIM RAW best AS INTEGER, tempb AS INTEGER, tempc AS INTEGER, tempsf AS INTEGER, tempst AS INTEGER
  DIM RAW xside AS INTEGER, pbst AS INTEGER, d AS INTEGER, e AS INTEGER, cf AS INTEGER, score AS INTEGER, rcnt AS INTEGER, slk AS INTEGER, InChk AS INTEGER
  DIM RAW mv AS UINT, nxtline[maxdepth] AS UINT
  DIM RAW node AS struct_leaf PTR, tmp AS struct_leaf

  NodeCnt++
  xside = otherside[side]

  IF (ply <= Sdepth + 3)  AND  rpthash[side][hashkey BAND 0xFF] > 0 THEN
    repetition (rpt)
  ELSE
    *rpt = 0
  END IF
  ' Detect repetitions a bit earlier. SMC. 12/89
  IF *rpt = 1  AND  ply > 1 THEN
    FUNCTION = (0)
  END IF
  ' if (*rpt >= 2) return(0);

  score = evaluate (side, ply, alpha, beta, INCscore, &slk, &InChk)
  IF score > 9000 THEN
    bstline[ply] = 0
    FUNCTION = (score)
  END IF
  IF depth > 0 THEN
    ' Allow opponent a chance to check again
    IF InChk THEN
         !depth = ( depth < 2 ) ? 2 : depth ;
    ELSEIF PawnThreat[ply - 1]  OR  ReCapture THEN
      ++depth
    END IF
  ELSE
    IF score >= alpha  AND  (InChk  OR  PawnThreat[ply - 1]  OR  Parry) THEN
      depth = 1
    ELSEIF score <= beta  AND  MateThreat THEN
      depth = 1
    END IF
  END IF
  IF depth > 0  AND  flag.hash  AND  ply > 1 THEN
    IF ProbeTTable (side, depth, &alpha, &beta, &score) = false THEN
      bstline[ply] = PV
    END IF
    bstline[ply + 1] = 0
    IF beta = - 20000 THEN
      FUNCTION = (score)
    END IF
    IF alpha > beta THEN
      FUNCTION = (alpha)
    END IF
  END IF
  IF Sdepth = 1 THEN
    d = 7
  ELSE
    d = 11
  END IF
  ' score >= beta ??
  IF ply > Sdepth + d  OR  (depth < 1  AND  score > beta) THEN
    FUNCTION = (score)
  END IF
  IF ply > 1 THEN
    IF depth > 0 THEN
      MoveList (side, ply)
    ELSE
      CaptureList (side, ply)
    END IF
  END IF
  IF (TrPnt[ply] = TrPnt[ply + 1]) THEN FUNCTION = (score)
   ! cf = (depth < 1 && ply > Sdepth + 1 && !ChkFlag[ply - 2] && !slk);
  IF depth > 0 THEN
    best = - 12000
  ELSE
    best = score
  END IF
  IF best > alpha THEN
    alpha = best
  END IF
  ' best < beta ??
  pnt = pbst = TrPnt[ply]
  WHILE pnt<TrPnt[ply+1] AND best<=beta
    DIM RAW msg AS MSG
    IF NOT flag.timeout AND PeekMessage(&msg, NULL, (UINT) NULL, (UINT) NULL, PM_REMOVE) THEN
      TranslateMessage (&msg)
      DispatchMessage (&msg)
    END IF
    IF Running = FALSE THEN END =0
    IF ply > 1 THEN
      pick (pnt, TrPnt[ply + 1] - 1)
    END IF
    node = &Tree[pnt]
    mv = (node->f << 8) BOR node->t
    nxtline[ply + 1] = 0

    IF prune THEN
      EXIT LOOP
    END IF
    IF ply = 1 THEN
      UpdateSearchStatus
    END IF
    IF  NOT  (node->flags BAND exact) THEN
      MakeMove (side, node, &tempb, &tempc, &tempsf, &tempst, &INCscore)
      CptrFlag[ply] = (node->flags BAND capture)
      PawnThreat[ply] = (node->flags BAND pwnthrt)
      Tscore[ply] = node->score
      PV = node->reply
         !node->score = -search (xside, ply + 1, (depth > 0 ) ? depth - 1 : 0, -beta, -alpha, nxtline, &rcnt ) ;
      IF ABS (node->score) > 9000 THEN
        node->flags |= exact
      ELSEIF rcnt = 1 THEN
        node->score / = 2
      END IF
      IF rcnt >= 2  OR  GameCnt - Game50 > 99 OR (node->score = 9999 - ply AND NOT ChkFlag[ply]) THEN
        node->flags |= draw
        node->flags |= exact
        IF side = computer THEN
          node->score = contempt
        ELSE
          node->score = - contempt
        END IF
      END IF
      node->reply = nxtline[ply + 1]
      UnmakeMove (side, node, &tempb, &tempc, &tempsf, &tempst)
    END IF
    IF node->score > best AND NOT flag.timeout THEN
      IF depth > 0 THEN
        IF node->score > alpha AND  NOT  (node->flags BAND exact) THEN
          node->score + = depth
        END IF
      END IF
      best = node->score
      pbst = pnt
      IF best > alpha THEN
        alpha = best
      END IF
      j = ply + 1
      WHILE nxtline[j]>0
        bstline[j] = nxtline[j]
        j++
      WEND
      bstline[j] = 0
      bstline[ply] = mv
      IF ply = 1 THEN
        IF best > root->score THEN
          tmp = Tree[pnt]
          j = pnt - 1
          WHILE j>=0
            Tree[j + 1] = Tree[j]
            j--
          WEND
          Tree[0] = tmp
          pbst = 0
        END IF
        IF Sdepth > 2 THEN
          IF best > beta THEN
            ShowResults (best, bstline, 43)
          ELSEIF best < alpha THEN
            ShowResults (best, bstline, 45)
          ELSE
            ShowResults (best, bstline, 38)
          END IF
        END IF
      END IF
    END IF
    IF NodeCnt > ETnodes THEN
      ElapsedTime (0)
    END IF
    IF flag.timeout THEN
      FUNCTION = (- Tscore[ply - 1])
    END IF
    pnt++
  WEND

  node = &Tree[pbst]
  mv = (node->f < < 8) BOR node->t

  IF flag.hash  AND  ply <= Sdepth  AND  *rpt = 0  AND  best = alpha THEN
    PutInTTable (side, best, depth, alpha, beta, mv)
  END IF
  IF depth > 0 THEN
    j = (node->f < < 6) BOR node->t
    IF side = black THEN
      j |= 0x1000
    END IF
    IF *(history + j) < 150 THEN
      *(history + j) + = (UCHAR) 2 *depth
    END IF
    IF node->t <> (INTEGER) (GameList[GameCnt].gmove BAND 0xFF) THEN
      IF best <= beta THEN
        killr3[ply] = mv
      ELSEIF mv <> killr1[ply] THEN
        killr2[ply] = killr1[ply]
        killr1[ply] = mv
      END IF
    END IF
    IF best > 9000 THEN
      killr0[ply] = mv
    ELSE
      killr0[ply] = 0
    END IF
  END IF
  FUNCTION = (best)
END FUNCTION

'
'  hashbd contains a 32 bit "signature" of the board position. hashkey
'  contains a 16 bit code used to address the hash table. When a move is
'  made, XOR'ing the hashcode of moved piece on the from and to squares with
'  the hashbd and hashkey values keeps things current.
'

$HEADER
#define UpdateHashbd(side, piece, f, t) \
{\
  if ((f) >= 0)\
    {\
      hashbd ^= (hashcode+(side)*7*64+(piece)*64+f)->bd;\
      hashkey ^= (hashcode+(side)*7*64+(piece)*64+f)->key;\
    }\
  if ((t) >= 0)\
    {\
      hashbd ^= (hashcode+(side)*7*64+(piece)*64+t)->bd;\
      hashkey ^= (hashcode+(side)*7*64+(piece)*64+t)->key;\
    }\
}

#define CB(i) (unsigned char) ((cColor[2 * (i)] ? 0x80 : 0)\
               | (board[2 * (i)] << 4)\
               | (cColor[2 * (i) + 1] ? 0x8 : 0)\
               | (board[2 * (i) + 1]))

$HEADER
'
'Look for the current board position in the transposition table.
'
FUNCTION ProbeTTable (side AS INTEGER, depth AS INTEGER, alpha AS INTEGER PTR, beta AS INTEGER PTR, score AS INTEGER PTR) AS INTEGER
  DIM RAW ptbl AS struct_hashentry PTR
  DIM RAW i AS UINT

  ptbl = ttable + side *2 + (hashkey BAND (ttblsz - 1))

  ' rehash max rehash times
  i = 1
  WHILE (ptbl->hashbd!=hashbd) AND ((INT)i<=rehash)
    ptbl = ttable + side *2 + ((hashkey + i) &(ttblsz - 1))
    i++
  WEND
  IF (INTEGER) ptbl->depth >= depth  AND  ptbl->hashbd = hashbd THEN
    HashCnt++

    PV = ptbl->mv
    IF ptbl->flags BAND truescore THEN
      *score = ptbl->score
      *beta = - 20000
    ELSEIF ptbl->flags BAND lowerbound THEN
      IF ptbl->score > *alpha THEN
        *alpha = ptbl->score - 1
      END IF
    END IF
    FUNCTION = (true)
  END IF
  FUNCTION = (false)
END FUNCTION

'
'Store the current board position in the transposition table.
'


SUB PutInTTable (side AS INTEGER, score AS INTEGER, depth AS INTEGER, alpha AS INTEGER, beta AS INTEGER, mv AS UINT)

  DIM RAW ptbl AS struct_hashentry PTR
  DIM RAW i AS UINT

  ptbl = ttable + side *2 + (hashkey BAND (ttblsz - 1))

  ' rehash max rehash times
  i = 1
  WHILE (depth<(INT)ptbl->depth) AND (ptbl->hashbd!=hashbd) AND ((INT)i<=rehash)
    ptbl = ttable + side *2 + ((hashkey + i) &(ttblsz - 1))
    i++
  WEND
  IF (depth >= (INTEGER) ptbl->depth)  OR  (ptbl->hashbd <> hashbd) THEN
    ptbl->hashbd = hashbd
    ptbl->depth = (UCHAR) depth
    ptbl->score = score
    ptbl->mv = mv
    ptbl->flags = 0
    IF score < alpha THEN
      ptbl->flags |= upperbound
    ELSEIF score > beta THEN
      ptbl->flags |= lowerbound
    ELSE
      ptbl->flags |= truescore
    END IF
  END IF
END SUB

SUB ZeroTTable ()
  DIM RAW side AS INTEGER, i AS INTEGER

  IF flag.hash THEN
    side = white
    WHILE side<=black
      i = 0
      WHILE i<ttblsz
        (ttable + side *2 + i)  ->depth = 0
        i++
      WEND
      side++
    WEND
  END IF
END SUB

SUB ZeroRPT ()
  DIM RAW side AS INTEGER, i AS INTEGER

  side = white
  WHILE side<=black
    i = 0
    WHILE i<256
      rpthash[side][i] = 0
      i++
    WEND
    side++
  WEND
END SUB

$HEADER
#define Link(from,to,flag,s) \
{\
   node->f = from; node->t = to;\
     node->reply = 0;\
       node->flags = flag;\
         node->score = s;\
           ++node;\
             ++TrPnt[ply+1];\
             }

$HEADER

SUB LinkMove (ply AS INTEGER, f AS INTEGER, t AS INTEGER, flag AS INTEGER, xside AS INTEGER)

  '
  'Add a move to the tree.  Assign a bonus to order the moves
  'as follows:
  '1. Principle variation
  '2. Capture of last moved piece
  '3. Other captures (major pieces first)
  '4. Killer moves
  '5. "history" killers
  '

  DIM RAW s AS INTEGER, z AS INTEGER
  DIM RAW mv AS UINT
  DIM RAW node AS struct_leaf PTR

  node = &Tree[TrPnt[ply+1]]
  mv = (f << 8) BOR t
  s = 0
  IF mv = Swag0 THEN
    s = 2000
  ELSEIF mv = Swag1 THEN
    s = 60
  ELSEIF mv = Swag2 THEN
    s = 50
  ELSEIF mv = Swag3 THEN
    s = 40
  ELSEIF mv = Swag4 THEN
    s = 30
  END IF
  z = (f < < 6) BOR t
  IF xside = white THEN
    z |= 0x1000
  END IF
  '  s += history[z];
  s + = *(history + z)
  IF cColor[t] <> neutral THEN
    IF t = TOsquare THEN
      s + = 500
    END IF
    s + = value[board[t]] - board[f]
  END IF
  IF board[f] = pawn THEN
    IF row (t) = 0  OR  row (t) = 7 THEN
      flag |= promote
      s + = 800
      Link (f, t, flag BOR queen, s - 20000)
      s - = 200
      Link (f, t, flag BOR knight, s - 20000)
      s - = 50
      Link (f, t, flag BOR rook, s - 20000)
      flag |= bishop
      s - = 50
    ELSEIF row (t) = 1  OR  row (t) = 6 THEN
      flag |= pwnthrt
      s + = 600
    END IF
  END IF
  Link (f, t, flag, s - 20000)
END SUB


SUB GenMoves (ply AS INTEGER, sq AS INTEGER, side AS INTEGER, xside AS INTEGER)

  '
  'Generate moves for a piece. The moves are taken from the precalulated
  'array nextpos/nextdir. If the board is free, next move is choosen from
  'nextpos else from nextdir.
  '

  DIM RAW u AS INTEGER, piece AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR

  piece = board[sq]
  ppos = nextpos + ptype[side][piece] *64 *64 + sq *64
  pdir = nextdir + ptype[side][piece] *64 *64 + sq *64
  IF piece = pawn THEN
    u = ppos[sq]                                         'follow no captures thread
    IF cColor[u] = neutral THEN
      LinkMove (ply, sq, u, 0, xside)
      u = ppos[u]
      IF cColor[u] = neutral THEN
        LinkMove (ply, sq, u, 0, xside)
      END IF
    END IF
    u = pdir[sq]                                         'follow captures thread
    IF cColor[u] = xside THEN
      LinkMove (ply, sq, u, capture, xside)
    ELSEIF u = epsquare THEN
      LinkMove (ply, sq, u, capture BOR epmask, xside)
    END IF
    u = pdir[u]
    IF cColor[u] = xside THEN
      LinkMove (ply, sq, u, capture, xside)
    ELSEIF u = epsquare THEN
      LinkMove (ply, sq, u, capture BOR epmask, xside)
    END IF
  ELSE
    u = ppos[sq]
    DO
      IF cColor[u] = neutral THEN
        LinkMove (ply, sq, u, 0, xside)
        u = ppos[u]
      ELSE
        IF cColor[u] = xside THEN
          LinkMove (ply, sq, u, capture, xside)
        END IF
        u = pdir[u]
      END IF
    LOOP WHILE u <> sq
  END IF
END SUB


SUB MoveList (side AS INTEGER, ply AS INTEGER)

  '
  'Fill the array Tree[] with all available moves for side to play. Array
  'TrPnt[ply] contains the index into Tree[] of the first move at a ply.
  '

  DIM RAW i AS INTEGER, xside AS INTEGER, f AS INTEGER

  xside = otherside[side]
  TrPnt[ply + 1] = TrPnt[ply]
  IF PV = 0 THEN
    Swag0 = killr0[ply]
  ELSE
    Swag0 = PV
  END IF
  Swag1 = killr1[ply]
  Swag2 = killr2[ply]
  Swag3 = killr3[ply]
  IF ply > 2 THEN
    Swag4 = killr1[ply - 2]
  ELSE
    Swag4 = 0
  END IF
  i = PieceCnt [ side ]
  WHILE i>=0
    GenMoves (ply, PieceList[side][i], side, xside)
    i--
  WEND
  IF  NOT  castld[side] THEN
    f = PieceList[side][0]
    IF castle (side, f, f + 2, 0) THEN
      LinkMove (ply, f, f + 2, cstlmask, xside)
    END IF
    IF castle (side, f, f - 2, 0) THEN
      LinkMove (ply, f, f - 2, cstlmask, xside)
    END IF
  END IF
END SUB

SUB CaptureList (side AS INTEGER, ply AS INTEGER)

  '
  'Fill the array Tree[] with all available cature and promote moves for
  'side to play. Array TrPnt[ply] contains the index into Tree[]
  'of the first move at a ply.
  '

  DIM RAW u AS INTEGER, sq AS INTEGER, xside AS INTEGER
  DIM RAW node AS struct_leaf PTR
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR
  DIM RAW i AS INTEGER, piece AS INTEGER, PL AS INTEGER PTR, r7 AS INTEGER

  xside = otherside[side]
  TrPnt[ply + 1] = TrPnt[ply]
  node = &Tree[TrPnt[ply]]
  r7 = rank7[side]
  PL = PieceList[side]
  i = 0
  WHILE i<=PieceCnt[side]
    sq = PL[i]
    piece = board[sq]
    IF sweep[piece] THEN
      ppos = nextpos + piece *64 *64 + sq *64
      pdir = nextdir + piece *64 *64 + sq *64
      u = ppos[sq]
      DO
        IF cColor[u] = neutral THEN
          u = ppos[u]
        ELSE
          IF cColor[u] = xside THEN
            Link (sq, u, capture, value[board[u]] + svalue[board[u]] - piece)
          END IF
          u = pdir[u]
        END IF
      LOOP WHILE u <> sq
    ELSE
      pdir = nextdir + ptype[side][piece] *64 *64 + sq *64
      IF piece = pawn  AND  row (sq) = r7 THEN
        u = pdir[sq]
        IF cColor[u] = xside THEN
          Link (sq, u, capture BOR promote BOR queen, valueQ)
        END IF
        u = pdir[u]
        IF cColor[u] = xside THEN
          Link (sq, u, capture BOR promote BOR queen, valueQ)
        END IF
        ppos = nextpos + ptype[side][piece] *64 *64 + sq *64
        u = ppos[sq]                                   'also generate non capture promote
        IF cColor[u] = neutral THEN
          Link (sq, u, promote BOR queen, valueQ)
        END IF
      ELSE
        u = pdir[sq]
        DO
          IF cColor[u] = xside THEN
            Link (sq, u, capture, value[board[u]] + svalue[board[u]] - piece)
          END IF
          u = pdir[u]
        LOOP WHILE u <> sq
      END IF
    END IF
    i++
  WEND
END SUB


FUNCTION castle (side AS INTEGER, kf AS INTEGER, kt AS INTEGER, iop AS INTEGER) AS INTEGER

  ' Make or Unmake a castling move.

  DIM RAW rf AS INTEGER, rt AS INTEGER, t0 AS INTEGER, xside AS INTEGER

  xside = otherside[side]
  IF kt > kf THEN
    rf = kf + 3
    rt = kt - 1
  ELSE
    rf = kf - 4
    rt = kt + 1
  END IF
  IF iop = 0 THEN
    IF kf <> kingP[side]  OR  board[kf] <> king  OR  board[rf] <> rook  OR  Mvboard[kf] <> 0  OR  Mvboard[rf] <> 0  OR  cColor[kt] <> neutral  OR  cColor[rt] <> neutral  OR  cColor[kt - 1] <> neutral  OR  SqAtakd (kf, xside)  OR  SqAtakd (kt, xside)  OR  SqAtakd (rt, xside) THEN
      FUNCTION = (false)
    END IF
  ELSE
    IF iop = 1 THEN
      castld[side] = true
      Mvboard[kf]++
      Mvboard[rf]++
    ELSE
      castld[side] = false
      Mvboard[kf]--
      Mvboard[rf]--
      t0 = kt
      kt = kf
      kf = t0
      t0 = rt
      rt = rf
      rf = t0
    END IF
    board[kt] = king
    cColor[kt] = side
    Pindex[kt] = 0
    board[kf] = no_piece
    cColor[kf] = neutral
    board[rt] = rook
    cColor[rt] = side
    Pindex[rt] = Pindex[rf]
    board[rf] = no_piece
    cColor[rf] = neutral
    PieceList[side][Pindex[kt]] = kt
    PieceList[side][Pindex[rt]] = rt
    UpdateHashbd (side, king, kf, kt)
    UpdateHashbd (side, rook, rf, rt)
  END IF
  FUNCTION = (true)
END FUNCTION


'
'Make or unmake an en passant move.
'
SUB EnPassant (xside AS INTEGER, f AS INTEGER, t AS INTEGER, iop AS INTEGER)


  DIM RAW l AS INTEGER

  IF t > f THEN
    l = t - 8
  ELSE
    l = t + 8
  END IF
  IF iop = 1 THEN
    board[l] = no_piece
    cColor[l] = neutral
  ELSE
    board[l] = pawn
    cColor[l] = xside
  END IF
  InitializeStats ()
END FUNCTION

'
'Update the PieceList and Pindex arrays when a piece is captured or when a
'capture is unmade.
'

SUB UpdatePieceList (side AS INTEGER, sq AS INTEGER, iop AS INTEGER)

  DIM RAW i AS INTEGER
  IF iop = 1 THEN
    PieceCnt[side]--
    i = Pindex [ sq ]
    WHILE i<=PieceCnt[side]
      PieceList[side][i] = PieceList[side][i + 1]
      Pindex[PieceList[side][i]] = i
      i++
    WEND
  ELSE
    PieceCnt[side]++
    PieceList[side][PieceCnt[side]] = sq
    Pindex[sq] = PieceCnt[side]
  END IF
END SUB


SUB MakeMove (side AS INTEGER, node AS  struct_leaf PTR, tempb AS INTEGER PTR, tempc AS INTEGER PTR, _
  tempsf AS INTEGER PTR, tempst AS INTEGER PTR, INCscore AS INTEGER PTR)

  ' Update Arrays board[], cColor[], and Pindex[] to reflect the new board
  ' position obtained after making the move pointed to by node. Also update
  ' miscellaneous stuff that changes when a move is made.

  DIM RAW f AS INTEGER, t AS INTEGER, xside AS INTEGER, ct AS INTEGER, cf AS INTEGER

  xside = otherside[side]
  GameCnt++
  f = node->f
  t = node->t
  epsquare = - 1
  FROMsquare = f
  TOsquare = t
  *INCscore = 0
  GameList[GameCnt] .gmove = (f < < 8) BOR t
  IF node->flags BAND cstlmask THEN
    GameList[GameCnt].piece = no_piece
    GameList[GameCnt].ccolor = side
    (void) castle (side, f, t, 1)
  ELSE
    *tempc = cColor[t]
    *tempb = board[t]
    *tempsf = svalue[f]
    *tempst = svalue[t]
    GameList[GameCnt] .piece = *tempb
    GameList[GameCnt] .ccolor = *tempc
    IF *tempc <> neutral THEN
      UpdatePieceList (*tempc, t, 1)
      IF *tempb = pawn THEN
        --PawnCnt[*tempc][column (t)]
      END IF
      IF board[f] = pawn THEN
        --PawnCnt[side][column (f)]
        ++PawnCnt[side][column (t)]
        cf = column (f)
        ct = column (t)
        IF PawnCnt[side][ct] > 1 + PawnCnt[side][cf] THEN
          *INCscore - = 15
        ELSEIF PawnCnt[side][ct] < 1 + PawnCnt[side][cf] THEN
          *INCscore + = 15
        ELSEIF ct = 0  OR  ct = 7  OR  PawnCnt[side][ct + ct - cf] = 0 THEN
          *INCscore - = 15
        END IF
      END IF
      mtl[xside] - = value[*tempb]
      IF *tempb = pawn THEN
        pmtl[xside] - = valueP
      END IF
      UpdateHashbd (xside, *tempb, - 1, t)
      *INCscore + = *tempst
      Mvboard[t]++
    END IF
    cColor[t] = cColor[f]
    board[t] = board[f]
    svalue[t] = svalue[f]
    Pindex[t] = Pindex[f]
    PieceList[side][Pindex[t]] = t
    cColor[f] = neutral
    board[f] = no_piece
    IF board[t] = pawn THEN
      IF t - f = 16 THEN
        epsquare = f + 8
      ELSEIF f - t = 16 THEN
        epsquare = f - 8
      END IF
    END IF
    IF (node->flags BAND promote) THEN
      board[t] = node->flags BAND pmask
      IF board[t] = queen THEN
        HasQueen[side]++
      ELSEIF board[t] = rook THEN
        HasRook[side]++
      ELSEIF board[t] = bishop THEN
        HasBishop[side]++
      ELSEIF board[t] = knight THEN
        HasKnight[side]++
      END IF
      --PawnCnt[side][column (t)]
      mtl[side] + = value[board[t]] - valueP
      pmtl[side] - = valueP
      UpdateHashbd (side, pawn, f, - 1)
      UpdateHashbd (side, board[t], f, - 1)
      *INCscore - = *tempsf
    END IF
    IF node->flags BAND epmask THEN
      EnPassant (xside, f, t, 1)
    ELSE
      UpdateHashbd (side, board[t], f, t)
    END IF
    Mvboard[f]++
  END IF
END SUB


SUB UnmakeMove (side AS INTEGER, node AS struct_leaf PTR, tempb AS INTEGER PTR, tempc AS INTEGER PTR, tempsf AS INTEGER PTR, tempst AS INTEGER PTR)
  ' Take back a move.

  DIM RAW f AS INTEGER, t AS INTEGER, xside AS INTEGER

  xside = otherside[side]
  f = node->f
  t = node->t
  epsquare = - 1
  GameCnt--
  IF node->flags BAND cstlmask THEN
    (void) castle (side, f, t, 2)
  ELSE
    cColor[f] = cColor[t]
    board[f] = board[t]
    svalue[f] = *tempsf
    Pindex[f] = Pindex[t]
    PieceList[side][Pindex[f]] = f
    cColor[t] = *tempc
    board[t] = *tempb
    svalue[t] = *tempst
    IF node->flags BAND promote THEN
      board[f] = pawn
      ++PawnCnt[side][column (t)]
      mtl[side] + = valueP - value[node->flags BAND pmask]
      pmtl[side] + = valueP
      UpdateHashbd (side, (INTEGER) node->flags BAND pmask, - 1, t)
      UpdateHashbd (side, pawn, - 1, t)
    END IF
    IF *tempc <> neutral THEN
      UpdatePieceList (*tempc, t, 2)
      IF *tempb = pawn THEN
        ++PawnCnt[*tempc][column (t)]
      END IF
      IF board[f] = pawn THEN
        --PawnCnt[side][column (t)]
        ++PawnCnt[side][column (f)]
      END IF
      mtl[xside] + = value[*tempb]
      IF *tempb = pawn THEN
        pmtl[xside] + = valueP
      END IF
      UpdateHashbd (xside, *tempb, - 1, t)
      Mvboard[t]--
    END IF
    IF node->flags BAND epmask THEN
      EnPassant (xside, f, t, 2)
    ELSE
      UpdateHashbd (side, board[f], f, t)
    END IF
    Mvboard[f]--
    IF  NOT  (node->flags BAND capture)  AND  (board[f] <> pawn) THEN
      rpthash[side][hashkey BAND 0xFF]--
    END IF
  END IF
END SUB


SUB InitializeStats ()

  '
  'Scan thru the board seeing what's on each square. If a piece is found,
  'update the variables PieceCnt, PawnCnt, Pindex and PieceList. Also
  'determine the material for each side and set the hashkey and hashbd
  'variables to represent the current board position. Array
  'PieceList[side][indx] contains the location of all the pieces of either
  'side. Array Pindex[sq] contains the indx into PieceList for a given
  'square.
  '

  DIM RAW i AS INTEGER, sq AS INTEGER

  epsquare = - 1
  i = 0
  WHILE i<8
    PawnCnt[white][i] = PawnCnt[black][i] = 0
    i++
  WEND
  mtl[white] = mtl[black] = pmtl[white] = pmtl[black] = 0
  PieceCnt[white] = PieceCnt[black] = 0
  hashbd = hashkey = 0
  sq = 0
  WHILE sq<64
    IF cColor[sq] <> neutral THEN
      mtl[cColor[sq]] + = value[board[sq]]
      IF board[sq] = pawn THEN
        pmtl[cColor[sq]] + = valueP
        ++PawnCnt[cColor[sq]][column (sq)]
      END IF
      IF board[sq] = king THEN
        Pindex[sq] = 0
      ELSE
        Pindex[sq] =++PieceCnt[cColor[sq]]
      END IF
      PieceList[cColor[sq]][Pindex[sq]] = sq
      hashbd = hashbd XOR (hashcode + cColor[sq] *7 *64 + board[sq] *64 + sq)->bd
      hashkey = hashkey XOR (hashcode + cColor[sq] *7 *64 + board[sq] *64 + sq)->key
    END IF
    sq++
  WEND
END SUB

FUNCTION SqAtakd (sq AS INTEGER, side AS INTEGER) AS INTEGER

  '
  'See if any piece with color 'side' ataks sq.  First check pawns then Queen,
  'Bishop, Rook and King and last Knight.
  '

  DIM RAW u AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR
  DIM RAW xside AS INTEGER

  xside = otherside[side]
  pdir = nextdir + ptype[xside][pawn] *64 *64 + sq *64
  u = pdir[sq]                                            'follow captures thread
  IF u <> sq THEN
    IF board[u] = pawn  AND  cColor[u] = side THEN
      FUNCTION = (true)
    END IF
    u = pdir[u]
    IF u <> sq  AND  board[u] = pawn  AND  cColor[u] = side THEN
      FUNCTION = (true)
    END IF
  END IF
  ' king capture
  IF distance (sq, PieceList[side][0]) = 1 THEN
    FUNCTION = (true)
  END IF
  ' try a queen bishop capture
  ppos = nextpos + bishop *64 *64 + sq *64
  pdir = nextdir + bishop *64 *64 + sq *64
  u = ppos[sq]
  DO
    IF cColor[u] = neutral THEN
      u = ppos[u]
    ELSE
      IF cColor[u] = side  AND  (board[u] = queen  OR  board[u] = bishop) THEN
        FUNCTION = (true)
      END IF
      u = pdir[u]
    END IF
  LOOP WHILE u <> sq
  ' try a queen rook capture
  ppos = nextpos + rook *64 *64 + sq *64
  pdir = nextdir + rook *64 *64 + sq *64
  u = ppos[sq]
  DO
    IF cColor[u] = neutral THEN
      u = ppos[u]
    ELSE
      IF cColor[u] = side  AND  (board[u] = queen  OR  board[u] = rook) THEN
        FUNCTION = (true)
      END IF
      u = pdir[u]
    END IF
  LOOP WHILE u <> sq
  ' try a knight capture
  pdir = nextdir + knight *64 *64 + sq *64
  u = pdir[sq]
  DO
    IF cColor[u] = side  AND  board[u] = knight THEN
      FUNCTION = (true)
    END IF
    u = pdir[u]
  LOOP WHILE u <> sq
  FUNCTION = (false)
END FUNCTION


SUB ataks (side AS INTEGER, a AS INTEGER PTR)

  '
  'Fill array atak[][] with info about ataks to a square.  Bits 8-15 are set
  'if the piece (king..pawn) ataks the square.  Bits 0-7 contain a count of
  'total ataks to the square.
  '

  DIM RAW u AS INTEGER, c AS INTEGER, sq AS INTEGER
  DIM RAW ppos AS UCHAR PTR, pdir AS UCHAR PTR
  DIM RAW i AS INTEGER, piece AS INTEGER, PL AS INTEGER PTR

  memset ((char *) a, 0, 64 *SIZEOF (a[0]))
  PL = PieceList[side]
  i = PieceCnt [ side ]
  WHILE i>=0
    sq = PL[i]
    piece = board[sq]
    c = ccontrol[piece]
    IF sweep[piece] THEN
      ppos = nextpos + piece *64 *64 + sq *64
      pdir = nextdir + piece *64 *64 + sq *64
      u = ppos[sq]
      DO
        a[u] =++a[u] BOR c
            !u = (cColor[u] == neutral ) ? ppos[u] : pdir[u] ;
      LOOP WHILE u <> sq
    ELSE
      pdir = nextdir + ptype[side][piece] *64 *64 + sq *64
      u = pdir[sq]                                      'follow captures thread for pawns
      DO
        a[u] =++a[u] BOR c
        u = pdir[u]
      LOOP WHILE u <> sq
    END IF
    i--
  WEND
END SUB

FUNCTION parse (fd AS FILE, mv AS UINT PTR, side AS INTEGER) AS INTEGER
  DIM RAW c AS INTEGER, i AS INTEGER, r1 AS INTEGER, r2 AS INTEGER, c1 AS INTEGER, c2 AS INTEGER
  DIM RAW s[100] AS char

  c = GETC (fd)
  WHILE c = ASC(" ")
    c = GETC (fd)
  WEND
  i = 0
  s[0] = (char) c
  '\n = 10
  WHILE c <> 32  AND  c <> 10  AND  c <> CEOF
    s[++i] = (char) (c = GETC (fd))
  WEND
  s[++i] = 0
  IF c = CEOF THEN
    FUNCTION = (- 1)
  END IF
  IF s[0] = 33  OR  s[0] = 59  OR  i < 3 THEN
    '\n = 10
    WHILE c <> 10  AND  c <> CEOF
      c = GETC (fd)
    WEND
    FUNCTION = (0)
  END IF
  IF s[4] = ASC("o") THEN
    IF side = black THEN
      *mv = 0x3C3A
    ELSE
      *mv = 0x0402
    END IF
  ELSEIF (s[0] = ASC("o")) THEN
    IF (side = black) THEN
      *mv = 0x3C3E
    ELSE
      *mv = 0x0406
    END IF
  ELSE
    c1 = s[0] - ASC("a")
    r1 = s[1] - ASC("1")
    c2 = s[2] - ASC("a")
    r2 = s[3] - ASC("1")
    *mv = (locn (r1, c1) < < 8) BOR locn (r2, c2)
  END IF
  FUNCTION = (1)
END FUNCTION



'
'  Check for draw by threefold repetition.
'
SUB repetition (cnt AS INTEGER PTR)
  DIM RAW i, c, f, t
  DIM RAW b[64] AS INTEGER
  DIM RAW m AS UINT


  *cnt = c = 0
  IF GameCnt > Game50 + 3 THEN
    memset ((char *) b, 0, SIZEOF (b));
    i = GameCnt
    WHILE i > Game50
      m = GameList[i].gmove;
      f = m >> 8;
      t = m & 0xFF;
      IF ++b[f] = 0 THEN
        c--
      ELSE
        c++
      END IF
      IF --b[t] = 0 THEN
        c--
      ELSE
        c++
      END IF
      IF c = 0 THEN (*cnt)++
      i--
    WEND
  END IF
END SUB

