'
'C source for GNU CHESS
'
'Revision: 1990-09-30
'
'Modified by Daryl Baker for use in MS WINDOWS environment
' Converted to BCX by Garvan O'Keeffe April 2005
'
'This file is part of CHESS.
'
'CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
'WARRANTY.  No author or distributor accepts responsibility to anyone for
'the consequences of using it or for whether it serves any particular
'purpose or works at all, unless he says so in writing.  Refer to the CHESS
'General Public License for full details.
'
'Everyone is granted permission to copy, modify and redistribute CHESS, but
'only under the conditions described in the CHESS General Public License.
'A copy of this license is supposed to have been given to you along with
'CHESS so you can know your rights and responsibilities.  It should be in a
'file named COPYING.  Among other things, the copyright notice and this
'notice must be preserved on all copies.
'



FUNCTION TimeControlDialog (hWnd AS HWND, hInst AS HANDLE, Param AS DWORD) AS INTEGER
  DIM RAW lpProcTime AS FARPROC
  DIM RAW status AS INTEGER

  lpProcTime = (FARPROC) MakeProcInstance (TimeControlDlgProc, hInst)
  status = DialogBoxParam (hInst, MAKEINTRESOURCE (TIMECONTROL), hWnd, (DLGPROC) lpProcTime, Param)
  FreeProcInstance (lpProcTime)
  FUNCTION = status
END FUNCTION

STATIC tmpTCmoves AS INTEGER
STATIC tmpTCminutes AS INTEGER

FUNCTION TimeControlDlgProc (hDlg AS HWND, message AS UINT, wParam AS UINT, lParam AS LONG) AS LONG CALLBACK
  UNREFERENCED_PARAMETER (lParam)

  SELECT CASE (message)
    '  message: initialize dialog box
  CASE WM_INITDIALOG
    CheckRadioButton (hDlg, TMDLG_1MOV, TMDLG_60MOV, TCmoves + TMDLG_MOV)
    CheckRadioButton (hDlg, TMDLG_5MIN, TMDLG_600MIN, TCminutes + TMDLG_MIN)
    tmpTCminutes = TCminutes
    tmpTCmoves = TCmoves
    FUNCTION = (TRUE)

  CASE WM_SYSCOMMAND
    IF (wParam BAND 0xfff0) = SC_CLOSE THEN
      EndDialog (hDlg, (INTEGER) NULL)
      FUNCTION = TRUE
    END IF


    '  message: received a command
  CASE WM_COMMAND
    SELECT CASE (LOWORD (wParam))

    CASE IDOK
      TCminutes = tmpTCminutes
      TCmoves = tmpTCmoves
      EndDialog (hDlg, 1)
      FUNCTION = TRUE

    CASE IDCANCEL
      EndDialog (hDlg, (INTEGER) NULL)
      FUNCTION = TRUE

    CASE TMDLG_1MOV, TMDLG_10MOV, TMDLG_20MOV, TMDLG_40MOV, TMDLG_60MOV
      tmpTCmoves = wParam - TMDLG_MOV
      CheckRadioButton (hDlg, TMDLG_1MOV, TMDLG_60MOV, wParam)

    CASE TMDLG_5MIN, TMDLG_15MIN, TMDLG_30MIN, TMDLG_60MIN, TMDLG_600MIN
      tmpTCminutes = wParam - TMDLG_MIN
      CheckRadioButton (hDlg, TMDLG_5MIN, TMDLG_600MIN, wParam)
    END SELECT
  END SELECT

  FUNCTION = (FALSE)                                      'Didn't process a message
END FUNCTION
