// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 5.11a)
//   BCX (c) 1999 - 2006 by Kevin Diggins
// *************************************************************
//     Translated for compiling with a C Compiler
// *************************************************************
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <wchar.h>      // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif

// Open Watcom defs
#if defined( __WATCOM_CPLUSPLUS__ ) || defined( __TINYC__ )
  #define atanl atan
  #define sinl  sin
  #define cosl  cos
  #define tanl  tan
  #define asinl asin
  #define acosl acos
  #define log10l log10
  #define logl   log
  #define _fcloseall fcloseall
#endif

// Borland C++ 5.5.1 defs - bcc32.exe
#if defined( __BCPLUSPLUS__ )
  // ===== Borland Libraries ==========
  #include <dos.h>
  #pragma comment(lib,"import32.lib")
  #pragma comment(lib,"cw32.lib")
  // ==================================
#endif

// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif

#include <sys\types.h>
#include <sys\stat.h>
#include "gnuchess.h"
#include "chess.h"
#include "saveopen.h"
#include "color.h"
#include "stats.h"
#include "timecnt.h"
// ***************************************************

#define CBLACK RGB ( 0 , 0 , 0 )
#define BLUE RGB ( 0 , 0 , 255 )
#define GREEN RGB ( 0 , 255 , 0 )
#define CYAN RGB ( 128 , 255 , 255 )
#define RED RGB ( 255 , 0 , 0 )
#define PINK RGB ( 255 , 0 , 255 )
#define YELLOW RGB ( 255 , 255 , 0 )
#define PALEGRAY RGB ( 192 , 192 , 192 )
#define DARKGRAY RGB ( 127 , 127 , 127 )
#define DARKBLUE RGB ( 0 , 0 , 128 )
#define DARKGREEN RGB ( 0 , 128 , 0 )
#define DARKCYAN RGB ( 0 , 255 , 255 )
#define DARKRED RGB ( 128 , 0 , 0 )
#define DARKPINK RGB ( 255 , 0 , 128 )
#define BROWN RGB ( 128 , 128 , 64 )
#define CWHITE RGB ( 255 , 255 , 255 )

// ***************************************************

#define taxicab(a,b) *(taxidata+a*64+b)

// ***************************************************

#define ScoreThreat \
if (cColor[u] != c2)\
if (atk1[u] == 0 || (atk2[u] & 0xFF) > 1) ++cnt;\
else *s -= 3

// ***************************************************


#define UpdateSearchStatus \
{\
if (flag.post) ShowCurrentMove(pnt,node->f,node->t);\
if (pnt > TrPnt[1])\
{\
d = best-Zscore; e = best-node->score;\
if (best < alpha) ExtraTime = 10*ResponseTime;\
else if (d > -zwndw && e > 4*zwndw) ExtraTime = -ResponseTime/3;\
else if (d > -zwndw) ExtraTime = 0;\
else if (d > -3*zwndw) ExtraTime = ResponseTime;\
else if (d > -9*zwndw) ExtraTime = 3*ResponseTime;\
else ExtraTime = 5*ResponseTime;\
}\
}
#define prune (cf && score+node->score < alpha)
#define ReCapture (flag.rcptr && score > alpha && score < beta &&\
ply > 2 && CptrFlag[ply-1] && CptrFlag[ply-2])
/* && depth == Sdepth-ply+1 */
#define Parry (hung[side] > 1 && ply == Sdepth+1)
#define MateThreat (ply < Sdepth+4 && ply > 4 &&\
ChkFlag[ply-2] && ChkFlag[ply-4] &&\
ChkFlag[ply-2] != ChkFlag[ply-4])

// ***************************************************

#define UpdateHashbd(side, piece, f, t) \
{\
if ((f) >= 0)\
{\
hashbd ^= (hashcode+(side)*7*64+(piece)*64+f)->bd;\
hashkey ^= (hashcode+(side)*7*64+(piece)*64+f)->key;\
}\
if ((t) >= 0)\
{\
hashbd ^= (hashcode+(side)*7*64+(piece)*64+t)->bd;\
hashkey ^= (hashcode+(side)*7*64+(piece)*64+t)->key;\
}\
}

#define CB(i) (unsigned char) ((cColor[2 * (i)] ? 0x80 : 0)\
| (board[2 * (i)] << 4)\
| (cColor[2 * (i) + 1] ? 0x8 : 0)\
| (board[2 * (i) + 1]))


// ***************************************************

#define Link(from,to,flag,s) \
{\
node->f = from; node->t = to;\
node->reply = 0;\
node->flags = flag;\
node->score = s;\
++node;\
++TrPnt[ply+1];\
}



#if !defined( __LCC__ )
// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#else
#pragma lib <winspool.lib>
#pragma lib <shell32.lib>
#pragma lib <ole32.lib>
#pragma lib <oleaut32.lib>
#pragma lib <uuid.lib>
#pragma lib <odbc32.lib>
#pragma lib <odbccp32.lib>
#pragma lib <winmm.lib>
#pragma lib <imagehlp.lib>
#pragma lib <version.lib>
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************
#endif
// *************************************************
//            User Defined Constants
// *************************************************

#define struct_hashval struct hashval 
#define struct_leaf struct leaf 
#define struct_GameRec struct GameRec 
#define struct_hashentry struct hashentry 
#define struct_flags struct flags 
#define struct_TimeControlRec struct TimeControlRec 
#define struct_PIECEBITMAP struct PIECEBITMAP 
#define struct_BookEntry struct BookEntry 
#define BRD_HORZFRONT 48
#define BRD_HORZBACK 32
#define BRD_VERT 32
#define BRD_EDGE 8
#define BRD_HORZMARGIN 32
#define BRD_BACKMARGIN 5
#define BRD_FRONTMARGIN 5
#define wking PieceList [white ][0]
#define bking PieceList [black ][0]
#define EnemyKing PieceList [c2 ][0]
#define pxx " PNBRQK"
#define qxx " pnbrqk"
#define wking PieceList [white ][0]
#define bking PieceList [black ][0]
#define EnemyKing PieceList [c2 ][0]
#define IDD_INT 0x10
#define IDD_CHAR 0x11
#define PIECE_XAXIS 32
#define PIECE_YAXIS 32
#define struct_PIECEBITMAP struct PIECEBITMAP 
#define IDD_FNAME 0x10
#define IDD_FPATH 0x11
#define IDD_FLIST 0x12
#define IDD_DLIST 0x13
#define IDD_BROWSE 0x14

// *************************************************
//                System Variables
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************

static int     HilitSq;
static HBRUSH  hBrushBackGround;
static HANDLE  ghInst;
static GLOBALHANDLE hBook;
static HMENU   hMainMenu;
static DWORD   clrBackGround;
static DWORD   clrBlackSquare;
static DWORD   clrWhiteSquare;
static DWORD   clrBlackPiece;
static DWORD   clrWhitePiece;
static DWORD   clrText;
static char    *xBook;
static DWORD   *pclr;
static int     index;
static struct_BookEntry *Book;
static ULONG   hashkey;
static ULONG   hashbd;
static struct_hashval *hashcode;
static struct_hashentry *ttable;
static FILE   **hashfile;
static struct_leaf *Tree;
static struct_leaf *root;
static struct_flags flag;
static int     opponent;
static int     computer;
static int     Awindow;
static int     Bwindow;
static int     dither;
static int     INCscore;
static long    ResponseTime;
static long    ExtraTime;
static long    Level;
static long    et;
static long    et0;
static long    time0;
static long    ft;
static long    NodeCnt;
static long    ETnodes;
static long    EvalNodes;
static long    HashCnt;
static long    FHashCnt;
static long    HashCol;
static int     player;
static int     xwndw;
static int     rehash;
static struct_GameRec *GameList;
static int     Sdepth;
static int     GameCnt;
static int     Game50;
static int     MaxSearchDepth;
static int     epsquare;
static int     contempt;
static struct_TimeControlRec TimeControl;
static int     TCflag;
static int     TCmoves;
static int     TCminutes;
static int     OperatorTime;
static UINT    hint;
static int     c1;
static int     c2;
static int     *atk1;
static int     *atk2;
static int     *PC1;
static int     *PC2;
static int     FROMsquare;
static int     TOsquare;
static int     Zscore;
static int     zwndw;
static UINT    PV;
static UINT    Swag0;
static UINT    Swag1;
static UINT    Swag2;
static UINT    Swag3;
static UINT    Swag4;
static UCHAR   *history;
static int     KNIGHTPOST;
static int     KNIGHTSTRONG;
static int     BISHOPSTRONG;
static int     KATAK;
static int     PEDRNK2B;
static int     PWEAKH;
static int     PADVNCM;
static int     PADVNCI;
static int     PAWNSHIELD;
static int     PDOUBLED;
static int     PBLOK;
static int     RHOPN;
static int     RHOPNX;
static int     KHOPN;
static int     KHOPNX;
static int     KSFTY;
static int     ATAKD;
static int     HUNGP;
static int     HUNGX;
static int     KCASTLD;
static int     KMOVD;
static int     XRAY;
static int     PINVAL;
static int     stage;
static int     stage2;
static int     PawnBonus;
static int     BishopBonus;
static int     RookBonus;
static int     *distdata;
static int     *taxidata;
static UCHAR   *nextpos;
static UCHAR   *nextdir;
static HWND    hComputerColor;
static HWND    hComputerMove;
static HWND    hWhosTurn;
static HWND    hClockComputer;
static HWND    hClockHuman;
static HWND    hMsgComputer;
static HWND    hMsgHuman;
static int     mycntl1;
static int     mycntl2;
static long    evrate;
static int     deltay;
static GLOBALHANDLE hGameList;
static GLOBALHANDLE hTree;
static GLOBALHANDLE hHistory;
static GLOBALHANDLE hTTable;
static GLOBALHANDLE hHashCode;
static GLOBALHANDLE hdistdata;
static GLOBALHANDLE htaxidata;
static GLOBALHANDLE hnextdir;
static GLOBALHANDLE hnextpos;
static int     NumberDlgInt;
static int     xstatus;
static DWORD   wFileAttr;
static DWORD   wStatus;
static POFSTRUCT pof;
static int     tmpTCmoves;
static int     tmpTCminutes;
static struct_PIECEBITMAP pieces[7];
static char    Version[]="BCX Conversion";
static char    szAppName[]="Chess";
static int     coords=1;
static int     FirstSq=-1;
static int     GotFirst=FALSE;
static int     EditActive=FALSE;
static int     User_Move=TRUE;
static BOOL    Running=TRUE;
static int     boarddraw[64];
static int     colordraw[64];
static UINT    book_used=0;
static int     TrPnt[maxdepth];
static int     PieceList[2][16];
static int     PawnCnt[2][8];
static int     castld[2];
static int     Mvboard[64];
static int     svalue[64];
static UINT    PrVar[maxdepth];
static int     Pindex[64];
static int     PieceCnt[2];
static int     atak[2][64];
static int     mtl[2];
static int     pmtl[2];
static int     emtl[2];
static int     hung[2];
static int     HasKnight[2];
static int     HasBishop[2];
static int     HasRook[2];
static int     HasQueen[2];
static int     ChkFlag[maxdepth];
static int     CptrFlag[maxdepth];
static int     PawnThreat[maxdepth];
static int     Pscore[maxdepth];
static int     Tscore[maxdepth];
static UINT    killr0[maxdepth];
static UINT    killr1[maxdepth];
static UINT    killr2[maxdepth];
static UINT    killr3[maxdepth];
static int     rpthash[2][256];
static int     Mwpawn[64];
static int     Mbpawn[64];
static int     Mknight[2][64];
static int     Mbishop[2][64];
static int     Mking[2][64];
static int     Kfield[2][64];
static int     Developed[2];
static int     board[64];
static int     cColor[64];
static char    mvstr[4][6];
static HRGN    hitrgn[8];
static char    NumberDlgChar[80];
static char    szDefExt[5];
static char    szFileName[96];
static char    szFileSpec[16];
static HWND    hStats=NULL;



// *************************************************
//               Standard Macros
// *************************************************

#define DefaultFont ((BcxFont==0)?GetStockObject(DEFAULT_GUI_FONT):BcxFont)
#define BAND &
#define BOR |


// *************************************************
//               Standard Prototypes
// *************************************************

char*   BCX_TmpStr(size_t);
char*   join (int, ... );
double  Abs (double);

// *************************************************
//               User Prototypes
// *************************************************

long    CALLBACK About (HWND, UINT, UINT, long);
void    QueryBoardSize (POINT* );
void    QuerySqSize (POINT* );
void    QuerySqOrigin (int, int, POINT* );
void    QuerySqCoords (int, int, POINT* );
void    DrawOneSquare (HDC, int, int);
void    Draw_Board (HDC, int, DWORD, DWORD);
void    DrawCoords (HDC, int, DWORD, DWORD);
void    DrawWindowBackGround (HDC, HWND, DWORD);
void    HiliteSquare (HWND, int);
void    UnHiliteSquare (HWND, int);
void    FreeBook (void);
void*   Book_alloc (UINT);
void    GetOpenings (HWND);
void    OpeningBook (UINT* );
void    SetStandardColors (void);
void    SaveColors (LPSTR);
void    GetStartupColors (LPSTR);
int     ColorDialog (HWND, HANDLE, DWORD);
int     ColorToIndex (DWORD);
DWORD   IndexToColor (int);
long    CALLBACK ColorDlgProc (HWND, UINT, UINT, long);
void    Create_Children (HWND, HANDLE, int, int);
void    Initialize (void);
void    ExitChess (void);
void    Die (int);
void    TerminateSearch (int);
void    algbr (int, int, int);
int     VerifyMove (HWND, char* , int, UINT* );
void    ElapsedTime (int);
void    SetTimeControl (void);
void    GetGame (HWND, char* );
void    SaveGame (HWND, char* );
void    ListGame (HWND, char* );
void    Undo (HWND);
int     evaluate (int, int, int, int, int, int* , int* );
int     ScoreKPK (int, int, int, int, int, int);
int     ScoreKBNK (int, int, int);
void    ScoreLoneKing (int, int* );
void    BRscan (int, int* , int* );
void    KingScan (int, int* );
int     trapped (int);
int     PawnValue (int, int);
int     KnightValue (int, int);
int     BishopValue (int, int);
int     RookValue (int, int);
int     QueenValue (int, int);
int     KingValue (int, int);
void    ScorePosition (int, int* );
void    BlendBoard (int* , int* , int* );
void    CopyBoard (int* , int* );
void    ExaminePosition (void);
void    UpdateWeights (void);
void    InitHitTest (void);
void    Hittest_Destructor (void);
int     HorzHitTest (int, int);
int     HitTest (int, int);
BOOL    ChessInit (HANDLE);
void    Initialize_dist (void);
void    Initialize_moves (void);
int     init_main (HWND);
void    FreeChessGlobals (void);
void    NewGame (HWND);
void    Init_Menus (HWND, UINT, long);
void    ShowPlayers (void);
void    ShowDepth (char);
void    ShowScore (int);
void    ShowMessage (HWND, char* );
void    SMessageBox (HWND, int, int);
void    ClearMessage (void);
void    ShowCurrentMove (int, int, int);
void    ShowSidetoMove (void);
void    ShowPrompt (void);
void    ShowNodeCnt (long, long);
void    ShowResults (int, UINT* , char);
void    SearchStartStuff (int);
void    OutputMove (HWND);
void    UpdateClocks (void);
void    ShowPostnValue (int);
void    ShowPostnValues (void);
void    DrawPiece (HWND, int);
void    UpdateDisplay (HWND, int, int, int, int);
void    GiveHint (HWND);
long    CALLBACK NumberDlgDlgProc (HWND, UINT, UINT, long);
int     DoGetNumberDlg (HANDLE, HWND, char* , int);
void    QuerySqCenter (int, int, POINT* );
void    PieceOriginFromCenter (POINT* );
void    QuerySqPieceOrigin (int, int, POINT* );
void    ShowPiece (HDC, POINT* , struct_PIECEBITMAP* , DWORD);
int     ConvertCoordToIndex (int, int);
void    DrawOnePiece (HDC, int, int, struct_PIECEBITMAP* , DWORD);
void    DrawAllPieces (HDC, int, int* , int* , DWORD, DWORD);
int     PromoteDialog (HWND, HANDLE);
long    CALLBACK PromoteDlgProc (HWND, UINT, UINT, long);
int     ReviewDialog (HWND, HANDLE);
long    CALLBACK ReviewDlgProc (HWND, UINT, UINT, long);
int     DoFileOpenDlg (HANDLE, HWND, char* , char* , DWORD, char* , POFSTRUCT);
int     DoWildFileOpenDlg (HANDLE, HWND, char* , char* , DWORD, char* , POFSTRUCT);
int     DoFileSaveDlg (HANDLE, HWND, char* , char* , DWORD* , char* , POFSTRUCT);
long    CALLBACK FileOpenDlgProc (HWND, UINT, UINT, long);
long    CALLBACK WildFileOpenDlgProc (HWND, UINT, UINT, long);
long    CALLBACK FileSaveDlgProc (HWND, UINT, UINT, long);
void    pick (int, int);
void    SelectMove (HWND, int, int);
int     search (int, int, int, int, int, UINT* , int* );
int     ProbeTTable (int, int, int* , int* , int* );
void    PutInTTable (int, int, int, int, int, UINT);
void    ZeroTTable (void);
void    ZeroRPT (void);
void    LinkMove (int, int, int, int, int);
void    GenMoves (int, int, int, int);
void    MoveList (int, int);
void    CaptureList (int, int);
int     castle (int, int, int, int);
void    EnPassant (int, int, int, int);
void    UpdatePieceList (int, int, int);
void    MakeMove (int, struct_leaf* , int* , int* , int* , int* , int* );
void    UnmakeMove (int, struct_leaf* , int* , int* , int* , int* );
void    InitializeStats (void);
int     SqAtakd (int, int);
void    ataks (int, int* );
int     parse (FILE*, UINT* , int);
void    repetition (int* );
HWND    StatDialog (HWND, HANDLE);
long    CALLBACK StatDlgProc (HWND, UINT, UINT, long);
int     TimeControlDialog (HWND, HANDLE, DWORD);
long    CALLBACK TimeControlDlgProc (HWND, UINT, UINT, long);
int     WINAPI WinMain (HINSTANCE, HINSTANCE, LPSTR, int);
long    CALLBACK ChessWndProc (HWND, UINT, UINT, long);

// *************************************************
//              User GLOBAL SET Statements
// *************************************************

char lpChessini[]=
{
  "chess.ini"
};

char lpBackGround[]=
{
  "BackGround"
};

char lpBlackSquare[]=
{
  "BlackSquare"
};

char lpWhiteSquare[]=
{
  "WhiteSquare"
};

char lpBlackPiece[]=
{
  "BlackPiece"
};

char lpWhitePiece[]=
{
  "WhitePiece"
};

char lpDefault[]=
{
  "Default"
};

char lpText[]=
{
  "Text"
};

char np08lX[]=
{
  "%08lX"
};

char lpWBGC[]=
{
  "Window background color"
};

char lpBS[]=
{
  "Black square color"
};

char lpWS[]=
{
  "White square color"
};

char lpBP[]=
{
  "Black piece color"
};

char lpWP[]=
{
  "White piece color"
};

char lpTX[]=
{
  "Text color"
};

static int otherside[3]=
{
  1,0,2
};

int KingOpening[64]=
{
  0,0,-4,-10,-10,-4,0,0,-4,-4,-8,-12,-12,-8,-4,-4,-12,-16,-20,-20,-20,-20,-16,-12,-16,-20,-24,-24,-24,-24,-20,-16,-16,-20,-24,-24,-24,-24,-20,-16,-12,-16,-20,-20,-20,-20,-16,-12,-4,-4,-8,-12,-12,-8,-4,-4,0,0,-4,-10,-10,-4,0,0
};

int KingEnding[64]=
{
  0,6,12,18,18,12,6,0,6,12,18,24,24,18,12,6,12,18,24,30,30,24,18,12,18,24,30,36,36,30,24,18,18,24,30,36,36,30,24,18,12,18,24,30,30,24,18,12,6,12,18,24,24,18,12,6,0,6,12,18,18,12,6,0
};

int DyingKing[64]=
{
  0,8,16,24,24,16,8,0,8,32,40,48,48,40,32,8,16,40,56,64,64,56,40,16,24,48,64,72,72,64,48,24,24,48,64,72,72,64,48,24,16,40,56,64,64,56,40,16,8,32,40,48,48,40,32,8,0,8,16,24,24,16,8,0
};

int KBNK[64]=
{
  99,90,80,70,60,50,40,40,90,80,60,50,40,30,20,40,80,60,40,30,20,10,30,50,70,50,30,10,0,20,40,60,60,40,20,0,10,30,50,70,50,30,10,20,30,40,60,80,40,20,30,40,50,60,80,90,40,40,50,60,70,80,90,99
};

int pknight[64]=
{
  0,4,8,10,10,8,4,0,4,8,16,20,20,16,8,4,8,16,24,28,28,24,16,8,10,20,28,32,32,28,20,10,10,20,28,32,32,28,20,10,8,16,24,28,28,24,16,8,4,8,16,20,20,16,8,4,0,4,8,10,10,8,4,0
};

int pbishop[64]=
{
  14,14,14,14,14,14,14,14,14,22,18,18,18,18,22,14,14,18,22,22,22,22,18,14,14,18,22,22,22,22,18,14,14,18,22,22,22,22,18,14,14,18,22,22,22,22,18,14,14,22,18,18,18,18,22,14,14,14,14,14,14,14,14,14
};

int PawnAdvance[64]=
{
  0,0,0,0,0,0,0,0,4,4,4,0,0,4,4,4,6,8,2,10,10,2,8,6,6,8,12,16,16,12,8,6,8,12,16,24,24,16,12,8,12,16,24,32,32,24,16,12,12,16,24,32,32,24,16,12,0,0,0,0,0,0,0,0
};

int ccontrol[7]=
{
  0,ctlP,ctlN,ctlB,ctlR,ctlQ,ctlK
};

int PassedPawn0[8]=
{
  0,60,80,120,200,360,600,800
};

int PassedPawn1[8]=
{
  0,30,40,60,100,180,300,800
};

int PassedPawn2[8]=
{
  0,15,25,35,50,90,140,800
};

int PassedPawn3[8]=
{
  0,5,10,15,20,30,140,800
};

int ISOLANI[8]=
{
  -12,-16,-20,-24,-24,-20,-16,-12
};

int BACKWARD[16]=
{
  -6,-10,-15,-21,-28,-28,-28,-28,-28,-28,-28,-28,-28,-28,-28,-28
};

int BMBLTY[14]=
{
  -2,0,2,4,6,8,10,12,13,14,15,16,16,16
};

int RMBLTY[15]=
{
  0,2,4,6,8,10,11,12,13,14,14,14,14,14,14
};

int KTHRT[36]=
{
  0,-8,-20,-36,-52,-68,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80,-80
};

int ptype[2][8]=
{
  no_piece,pawn,knight,bishop,rook,queen,king,no_piece,no_piece,bpawn,knight,bishop,rook,queen,king,no_piece
};

int kingP[3]=
{
  4,60,0
};

int rank7[3]=
{
  6,1,0
};

int Stboard[64]=
{
  rook,knight,bishop,queen,king,bishop,knight,rook,pawn,pawn,pawn,pawn,pawn,pawn,pawn,pawn,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,pawn,pawn,pawn,pawn,pawn,pawn,pawn,pawn,rook,knight,bishop,queen,king,bishop,knight,rook
};

int Stcolor[64]=
{
  white,white,white,white,white,white,white,white,white,white,white,white,white,white,white,white,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,black,black,black,black,black,black,black,black,black,black,black,black,black,black,black,black
};

int direc[8][8]=
{
  0,0,0,0,0,0,0,0,10,9,11,0,0,0,0,0,8,-8,12,-12,19,-19,21,-21,9,11,-9,-11,0,0,0,0,1,10,-1,-10,0,0,0,0,1,10,-1,-10,9,11,-9,-11,1,10,-1,-10,9,11,-9,-11,-10,-9,-11,0,0,0,0,0
};

int max_steps[8]=
{
  0,2,1,7,7,7,1,2
};

int nunmap[120]=
{
  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,2,3,4,5,6,7,-1,-1,8,9,10,11,12,13,14,15,-1,-1,16,17,18,19,20,21,22,23,-1,-1,24,25,26,27,28,29,30,31,-1,-1,32,33,34,35,36,37,38,39,-1,-1,40,41,42,43,44,45,46,47,-1,-1,48,49,50,51,52,53,54,55,-1,-1,56,57,58,59,60,61,62,63,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
};

char* ColorStr[2]=
{
  "White","Black"
};

int value[7]=
{
  0,valueP,valueN,valueB,valueR,valueQ,valueK
};

int sweep[8]=
{
  FALSE,FALSE,FALSE,TRUE,TRUE,TRUE,FALSE,FALSE
};


 #define CEOF EOF

// *************************************************
//                 Runtime Functions
// *************************************************

char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[ 512];
  StrCnt=(++StrCnt & 511);
  StrFunc[StrCnt]=(char*)realloc(StrFunc[StrCnt],Bites + 128);
  return (char*)memset(StrFunc[StrCnt],0,Bites+128);
}


char * join(int n, ...)
{
  register int i = n, tmplen = 0;
  register char *s_;
  register char *strtmp;
  va_list marker;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) tmplen += strlen(s_);
  }
  strtmp = BCX_TmpStr(tmplen);
  va_end(marker); // Reset variable arguments
  i = n;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) strcat(strtmp, s_);
  }
  va_end(marker); // Reset variable arguments
  return strtmp;
}


double Abs (double a)
{
  if(a<0) return -a;
  return  a;
}



// ************************************
//       User Subs and Functions
// ************************************


long CALLBACK About (HWND hDlg, UINT message, UINT wParam, long lParam)
{
  UNREFERENCED_PARAMETER(lParam);
  while(1)
  {
    if((message)==WM_INITDIALOG)
      {
        SetDlgItemText(hDlg,106,Version);
        return TRUE;
      }
    if((message)==WM_SYSCOMMAND)
      {
        if((wParam BAND 0xfff0)==SC_CLOSE)
          {
            EndDialog(hDlg,(int)NULL);
            return TRUE;
          }
        break;
      }
    if((message)==WM_COMMAND)
      {
        if(LOWORD(wParam)==IDOK)
          {
            EndDialog(hDlg,(int)NULL);
            return TRUE;
          }
      }
    break;
  }
  return FALSE;
}


void QueryBoardSize (POINT* pptl)
{
  pptl->x=2*BRD_HORZMARGIN+8*BRD_HORZFRONT;
  pptl->y=BRD_BACKMARGIN+8*BRD_VERT+2*BRD_FRONTMARGIN+2*BRD_EDGE;
}


void QuerySqSize (POINT* pptl)
{
  pptl->x=BRD_HORZFRONT;
  pptl->y=BRD_VERT;
}


void QuerySqOrigin (int x, int y, POINT* pptl)
{
  pptl->x=BRD_HORZMARGIN+y*(BRD_HORZFRONT-BRD_HORZBACK)/2+x*(y*BRD_HORZBACK+(8-y)*BRD_HORZFRONT)/8;
  pptl->y=(BRD_BACKMARGIN+8*BRD_VERT+BRD_FRONTMARGIN)-y*BRD_VERT;
}


void QuerySqCoords (int x, int y, POINT* aptl)
{
  QuerySqOrigin(x,y,aptl+0);
  QuerySqOrigin(x+1,y,aptl+1);
  QuerySqOrigin(x+1,y+1,aptl+2);
  QuerySqOrigin(x,y+1,aptl+3);
}


void DrawOneSquare (HDC hDC, int x, int y)
{
  POINT  aptl[4];
  QuerySqCoords(x,y,aptl);
  Polygon(hDC,aptl,4);
}


void Draw_Board (HDC hDC, int reverse, DWORD DarkColor, DWORD LightColor)
{
  int  x;
  int  y;
  int  OldPolyMode;
  HBRUSH  hOldBrush;
  HBRUSH  hBrush_lt;
  HBRUSH  hBrush_dk;
  HPEN  hOldPen;
  POINT  aptl[4];
  hBrush_lt=CreateSolidBrush(LightColor);
  hBrush_dk=CreateSolidBrush(DarkColor);
  hOldBrush=SelectObject(hDC,hBrush_lt);
  hOldPen=SelectObject(hDC,GetStockObject(BLACK_PEN));
  OldPolyMode=SetPolyFillMode(hDC,WINDING);
  y=0;
  while(y<8)
    {
      x=0;
      while(x<8)
        {
          if(reverse==0)
            {
  SelectObject ( hDC, ((x+y ) &1 ) ? hBrush_lt : hBrush_dk ) ;
              DrawOneSquare(hDC,x,y);
            }
          else
            {
  SelectObject ( hDC , ( ( ( 7 - x ) + ( 7 - y ) ) & 1 ) ? hBrush_lt : hBrush_dk ) ;
              DrawOneSquare(hDC,7-x,7-y);
            }
          x++;
        }
      y++;
    }
  x=0;
  while(x<8)
    {
      QuerySqCoords(x,0,aptl);
      aptl[2].x=aptl[1].x;
      aptl[2].y=aptl[1].y+BRD_EDGE;
      aptl[3].x=aptl[0].x;
      aptl[3].y=aptl[0].y+BRD_EDGE;
  SelectObject ( hDC, (x&1 ) ? hBrush_lt : hBrush_dk ) ;
      Polygon(hDC,aptl,4);
      x++;
    }
  SetPolyFillMode(hDC,OldPolyMode);
  SelectObject(hDC,hOldPen);
  SelectObject(hDC,hOldBrush);
  DeleteObject(hBrush_lt);
  DeleteObject(hBrush_dk);
}


void DrawCoords (HDC hDC, int reverse, DWORD clrBackGround, DWORD clrText)
{
  HFONT  hFont;
  HFONT  hOldFont;
  int  i;
  int  OldBkMode;
  DWORD  OldBkColor;
  DWORD  OldTextColor;
  int  xchar;
  int  ychar;
  POINT  pt;
  TEXTMETRIC  tm;
  hFont=CreateFont(13,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FIXED_PITCH BOR FF_SWISS,"Helv");
  hOldFont=SelectObject(hDC,hFont);
  OldBkColor=SetBkColor(hDC,clrBackGround);
  OldBkMode=SetBkMode(hDC,TRANSPARENT);
  OldTextColor=SetTextColor(hDC,clrText);
  GetTextMetrics(hDC, &tm);
  xchar=tm.tmMaxCharWidth;
  ychar=tm.tmHeight;
  i=0;
  while(i<8)
    {
      QuerySqOrigin(0,i, &pt);
  TextOut (hDC, pt.x-xchar, pt.y-BRD_VERT/2-ychar/2, (reverse ? "87654321"+i : "12345678"+i ),1);
      QuerySqOrigin(i,0, &pt);
  TextOut (hDC, pt.x+BRD_HORZFRONT/2-xchar/2, pt.y+BRD_EDGE, (reverse ? "hgfedcba"+i : "abcdefgh"+i ), 1);
      i++;
    }
  SelectObject(hDC,hOldFont);
  DeleteObject(hFont);
  SetBkColor(hDC,OldBkColor);
  SetBkMode(hDC,OldBkMode);
  SetTextColor(hDC,OldTextColor);
}


void DrawWindowBackGround (HDC hDC, HWND hWnd, DWORD bkcolor)
{
  RECT  rect;
  HBRUSH  hBrush;
  HBRUSH  hOldBrush;
  hBrush=CreateSolidBrush(bkcolor);
  hOldBrush=SelectObject(hDC,hBrush);
  GetClientRect(hWnd, &rect);
  FillRect(hDC, &rect,hBrush);
  SelectObject(hDC,hOldBrush);
  DeleteObject(hBrush);
}


void HiliteSquare (HWND hWnd, int Square)
{
  HDC  hDC;
  int  x;
  int  y;
  POINT  aptl[4];
  HRGN  hRgn;
  y=Square/8;
  x=Square % 8;
  QuerySqCoords(x,y,aptl+0);
  hRgn=CreatePolygonRgn(aptl,4,WINDING);
  hDC=GetDC(hWnd);
  InvertRgn(hDC,hRgn);
  ReleaseDC(hWnd,hDC);
  DeleteObject(hRgn);
  HilitSq=Square;
}


void UnHiliteSquare (HWND hWnd, int Square)
{
  HDC  hDC;
  int  x;
  int  y;
  POINT  aptl[4];
  HRGN  hRgn;
  if(HilitSq==-1)
    {
      return;
    }
  y=Square/8;
  x=Square % 8;
  QuerySqCoords(x,y,aptl+0);
  hRgn=CreatePolygonRgn(aptl,4,WINDING);
  hDC=GetDC(hWnd);
  InvertRgn(hDC,hRgn);
  ReleaseDC(hWnd,hDC);
  DeleteObject(hRgn);
  HilitSq=-1;
}


void FreeBook (void)
{
  GlobalUnlock(hBook);
  GlobalFree(hBook);
  hBook=0;
  book_used=0;
}


void* Book_alloc (UINT size)
{
  char*  temp;
  if(book_used>32*1024)
    {
      return (void*)0;
    }
  temp=xBook+book_used;
  book_used+=size;
  return temp;
}


void GetOpenings (HWND hWnd)
{
  static  FILE*   fd;
  int  c;
  int  i;
  int  j;
  int  side;
  struct_BookEntry*  entry;
  UINT  mv;
  UINT*  mp;
  UINT  tmp[100];
  char  lpFile[MAX_PATH+1+MAX_PATH+1+MAX_PATH+1+MAX_PATH+1];
  char  sFname[MAX_PATH+1];
  char  sExt[MAX_PATH+1];
  char  sDrive[MAX_PATH+1];
  char  sDir[MAX_PATH+1];
  GetModuleFileName((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),lpFile,sizeof(lpFile));
  _splitpath(lpFile,sDrive,sDir,sFname,sExt);
  sprintf(lpFile,"%s%s%s.%s",sDrive,sDir,"gnuchess.book","txt");
  fd=fopen(lpFile,"r");
  if(fd!=NULL)
    {
      hBook=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(32*1024*sizeof(char)));
      if(hBook==NULL)
        {
          Book=NULL;
          SMessageBox(hWnd,IDS_OBAE,IDS_CHESS);
          return;
        }
      xBook=(char*)GlobalLock(hBook);
      Book=NULL;
      i=0;
      side=white;
      c=parse(fd, &mv,side);
      while(c>=0)
        {
          if(c==1)
            {
              tmp[++i]=mv;
              side=otherside[side];
            }
          else if(c==0&&i>0)
            {
              entry=(struct_BookEntry*)Book_alloc(sizeof(struct_BookEntry));
              mp=(UINT*)Book_alloc((i+1)*sizeof(UINT));
              if((entry==0)||(mp==0))
                {
                  Book=NULL;
                  SMessageBox(hWnd,IDS_OBAE,IDS_CHESS);
                  GlobalUnlock(hBook);
                  GlobalFree(hBook);
                  return;
                }
              entry->mv=mp;
              entry->nnext=Book;
              Book=entry;
              j=1;
              while(j<=i)
                {
                  *(mp++)=tmp[j];
                  j++;
                }
              *mp=0;
              i=0;
              side=white;
            }
          c=parse(fd, &mv,side);
        }
      fclose(fd);
    }
  else
    {
      SMessageBox(hWnd,IDS_OBNF,IDS_CHESS);
    }
}


void OpeningBook (UINT* hint)
{
  int  j;
  int  pnt;
  UINT  m;
  UINT*  mp;
  UINT  r;
  UINT  r0;
  struct_BookEntry*  p;
  srand((UINT)time((time_t*)0));
  r0=m=0;
  p=Book;
  while(p!=NULL)
    {
      mp=p->mv;
      j=1;
      while(j<=GameCnt)
        {
          if(GameList[j].gmove!=*(mp++))
            {
              break;
            }
          j++;
        }
      if(j>GameCnt)
        {
          r=urand();
          if(r>r0)
            {
              r0=r;
              m=*mp;
              *hint=*(++mp);
            }
        }
      p=p->nnext;
    }
  pnt=TrPnt[1];
  while(pnt<TrPnt[2])
    {
      if(((Tree[pnt].f<<8) BOR Tree[pnt].t)==(int)m)
        {
          Tree[pnt].score=0;
        }
      pnt++;
    }
  pick(TrPnt[1],TrPnt[2]-1);
  if(Tree[TrPnt[1]].score<0)
    {
      FreeBook();
      Book=NULL;
    }
}


void SetStandardColors (void)
{
  clrBackGround=BROWN;
  clrBlackSquare=DARKGREEN;
  clrWhiteSquare=PALEGRAY;
  clrBlackPiece=RED;
  clrWhitePiece=CWHITE;
  clrText=CBLACK;
}


void SaveColors (LPSTR appname)
{
  char  ostring[30];
  wsprintf(ostring,np08lX,clrBackGround);
  WritePrivateProfileString(appname,lpBackGround,ostring,lpChessini);
  wsprintf(ostring,np08lX,clrBlackSquare);
  WritePrivateProfileString(appname,lpBlackSquare,ostring,lpChessini);
  wsprintf(ostring,np08lX,clrWhiteSquare);
  WritePrivateProfileString(appname,lpWhiteSquare,ostring,lpChessini);
  wsprintf(ostring,np08lX,clrBlackPiece);
  WritePrivateProfileString(appname,lpBlackPiece,ostring,lpChessini);
  wsprintf(ostring,np08lX,clrWhitePiece);
  WritePrivateProfileString(appname,lpWhitePiece,ostring,lpChessini);
  wsprintf(ostring,np08lX,clrText);
  WritePrivateProfileString(appname,lpText,ostring,lpChessini);
}


void GetStartupColors (LPSTR appname)
{
  char  istring[30];
  SetStandardColors();
  GetPrivateProfileString(appname,lpBackGround,lpDefault,istring,sizeof(istring),lpChessini);
  if(strcmp(istring,lpDefault)!=0)
    {
      sscanf(istring,np08lX, &clrBackGround);
    }
  GetPrivateProfileString(appname,lpBlackSquare,lpDefault,istring,sizeof(istring),lpChessini);
  if(strcmp(istring,lpDefault)!=0)
    {
      sscanf(istring,np08lX, &clrBlackSquare);
    }
  GetPrivateProfileString(appname,lpWhiteSquare,lpDefault,istring,sizeof(istring),lpChessini);
  if(strcmp(istring,lpDefault)!=0)
    {
      sscanf(istring,np08lX, &clrWhiteSquare);
    }
  GetPrivateProfileString(appname,lpBlackPiece,lpDefault,istring,sizeof(istring),lpChessini);
  if(strcmp(istring,lpDefault)!=0)
    {
      sscanf(istring,np08lX, &clrBlackPiece);
    }
  GetPrivateProfileString(appname,lpWhitePiece,lpDefault,istring,sizeof(istring),lpChessini);
  if(strcmp(istring,lpDefault)!=0)
    {
      sscanf(istring,np08lX, &clrWhitePiece);
    }
  GetPrivateProfileString(appname,lpText,lpDefault,istring,sizeof(istring),lpChessini);
  if(strcmp(istring,lpDefault)!=0)
    {
      sscanf(istring,np08lX, &clrText);
    }
}


int ColorDialog (HWND hWnd, HANDLE hInst, DWORD Param)
{
  FARPROC  lpProcColor;
  int  status;
  lpProcColor=(FARPROC)MakeProcInstance(ColorDlgProc,hInst);
  status=DialogBoxParam(hInst,MAKEINTRESOURCE(COOLOR),hWnd,(DLGPROC)lpProcColor,Param);
  FreeProcInstance(lpProcColor);
  return status;
}


int ColorToIndex (DWORD ccolor)
{
  if(ccolor==CBLACK)
    {
      return CNT_BLACK;
    }
  else if(ccolor==BLUE)
    {
      return CNT_BLUE;
    }
  else if(ccolor==GREEN)
    {
      return CNT_GREEN;
    }
  else if(ccolor==CYAN)
    {
      return CNT_CYAN;
    }
  else if(ccolor==RED)
    {
      return CNT_RED;
    }
  else if(ccolor==PINK)
    {
      return CNT_PINK;
    }
  else if(ccolor==YELLOW)
    {
      return CNT_YELLOW;
    }
  else if(ccolor==PALEGRAY)
    {
      return CNT_PALEGRAY;
    }
  else if(ccolor==DARKGRAY)
    {
      return CNT_DARKGRAY;
    }
  else if(ccolor==DARKBLUE)
    {
      return CNT_DARKBLUE;
    }
  else if(ccolor==DARKGREEN)
    {
      return CNT_DARKGREEN;
    }
  else if(ccolor==DARKCYAN)
    {
      return CNT_DARKCYAN;
    }
  else if(ccolor==DARKRED)
    {
      return CNT_DARKRED;
    }
  else if(ccolor==DARKPINK)
    {
      return CNT_DARKPINK;
    }
  else if(ccolor==BROWN)
    {
      return CNT_BROWN;
    }
  else if(ccolor==CWHITE)
    {
      return CNT_WHITE;
    }
  return CNT_WHITE;
}


DWORD IndexToColor (int ccolor)
{
  if(ccolor==CNT_BLACK)
    {
      return CBLACK;
    }
  else if(ccolor==CNT_BLUE)
    {
      return BLUE;
    }
  else if(ccolor==CNT_GREEN)
    {
      return GREEN;
    }
  else if(ccolor==CNT_CYAN)
    {
      return CYAN;
    }
  else if(ccolor==CNT_RED)
    {
      return RED;
    }
  else if(ccolor==CNT_PINK)
    {
      return PINK;
    }
  else if(ccolor==CNT_YELLOW)
    {
      return YELLOW;
    }
  else if(ccolor==CNT_PALEGRAY)
    {
      return PALEGRAY;
    }
  else if(ccolor==CNT_DARKGRAY)
    {
      return DARKGRAY;
    }
  else if(ccolor==CNT_DARKBLUE)
    {
      return DARKBLUE;
    }
  else if(ccolor==CNT_DARKGREEN)
    {
      return DARKGREEN;
    }
  else if(ccolor==CNT_DARKCYAN)
    {
      return DARKCYAN;
    }
  else if(ccolor==CNT_DARKRED)
    {
      return DARKRED;
    }
  else if(ccolor==CNT_DARKPINK)
    {
      return DARKPINK;
    }
  else if(ccolor==CNT_BROWN)
    {
      return BROWN;
    }
  else if(ccolor==CNT_WHITE)
    {
      return CWHITE;
    }
  return RGB(255,0,0);
}


long CALLBACK ColorDlgProc (HWND hDlg, UINT message, UINT wParam, long lParam)
{
  char*  pchHeading;
  while(1)
  {
    if((message)==WM_INITDIALOG)
      {
        while(1)
        {
          pchHeading=(char*)lpWBGC;
          pclr= &clrBackGround;
          if((lParam)==IDM_BLACKSQUARE)
            {
              pchHeading=(char*)lpBS;
              pclr= &clrBlackSquare;
              break;
            }
          if((lParam)==IDM_WHITESQUARE)
            {
              pchHeading=(char*)lpWS;
              pclr= &clrWhiteSquare;
              break;
            }
          if((lParam)==IDM_BLACKPIECE)
            {
              pchHeading=(char*)lpBP;
              pclr= &clrBlackPiece;
              break;
            }
          if((lParam)==IDM_WHITEPIECE)
            {
              pchHeading=(char*)lpWP;
              pclr= &clrWhitePiece;
              break;
            }
          if((lParam)==IDM_TEXT)
            {
              pchHeading=(char*)lpTX;
              pclr= &clrText;
            }
          break;
        }
        SetDlgItemText(hDlg,IDD_HEADING,pchHeading);
        index=ColorToIndex(*pclr);
        CheckRadioButton(hDlg,CNT_BLACK,CNT_WHITE,index);
        return TRUE;
      }
    if((message)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDD_OK)
            {
              EndDialog(hDlg,1);
              *pclr=IndexToColor(index);
              return TRUE;
            }
          if((LOWORD(wParam))==IDD_CANCEL)
            {
              EndDialog(hDlg,(int)NULL);
              return TRUE;
            }
          if((LOWORD(wParam))==CNT_BLACK||(LOWORD(wParam))==CNT_BLUE||(LOWORD(wParam))==CNT_GREEN||(LOWORD(wParam))==CNT_CYAN||(LOWORD(wParam))==CNT_RED||(LOWORD(wParam))==CNT_PINK||(LOWORD(wParam))==CNT_YELLOW||(LOWORD(wParam))==CNT_PALEGRAY||(LOWORD(wParam))==CNT_DARKGRAY||(LOWORD(wParam))==CNT_DARKBLUE||(LOWORD(wParam))==CNT_DARKGREEN||(LOWORD(wParam))==CNT_DARKCYAN||(LOWORD(wParam))==CNT_DARKRED||(LOWORD(wParam))==CNT_DARKPINK||(LOWORD(wParam))==CNT_BROWN||(LOWORD(wParam))==CNT_WHITE)
            {
              index=wParam;
              CheckRadioButton(hDlg,CNT_BLACK,CNT_WHITE,index);
            }
          break;
        }
      }
    break;
  }
  return FALSE;
}


void Create_Children (HWND hWnd, HANDLE hInst, int xchar, int ychar)
{
  POINT  pt;
  char lpStatic[]=
{
  "Static"
};

  QueryBoardSize( &pt);
  hComputerColor=CreateWindow(lpStatic,NULL,WS_CHILD BOR SS_CENTER BOR WS_VISIBLE,0,pt.y,10*xchar,ychar,hWnd,(HMENU)(HMENU)1000,hInst,NULL);
  hWhosTurn=CreateWindow(lpStatic,NULL,WS_CHILD BOR SS_CENTER BOR WS_VISIBLE,10*xchar,pt.y,10*xchar,ychar,hWnd,(HMENU)(HMENU)1001,hInst,NULL);
  hComputerMove=CreateWindow(lpStatic,NULL,WS_CHILD BOR SS_LEFT BOR WS_VISIBLE,375,10,10*xchar,ychar,hWnd,(HMENU)(HMENU)1003,hInst,NULL);
  hClockComputer=CreateWindow(lpStatic,NULL,WS_CHILD BOR SS_CENTER BOR WS_VISIBLE,390,55,6*xchar,ychar,hWnd,(HMENU)(HMENU)1010,hInst,NULL);
  hClockHuman=CreateWindow(lpStatic,NULL,WS_CHILD BOR SS_CENTER BOR WS_VISIBLE,390,55+3*ychar,6*xchar,ychar,hWnd,(HMENU)(HMENU)1011,hInst,NULL);
  hMsgComputer=CreateWindow(lpStatic,"Computer:",WS_CHILD BOR SS_CENTER BOR WS_VISIBLE,390,55-3*ychar/2,6*xchar,ychar,hWnd,(HMENU)(HMENU)1020,hInst,NULL);
  hMsgHuman=CreateWindow(lpStatic,"You:",WS_CHILD BOR SS_CENTER BOR WS_VISIBLE,390,55+3*ychar/2,6*xchar,ychar,hWnd,(HMENU)(HMENU)1021,hInst,NULL);
}


void Initialize (void)
{
  mycntl1=mycntl2=0;
}


void ExitChess (void)
{
}


void Die (int Sig)
{
  UNREFERENCED_PARAMETER(Sig);
}


void TerminateSearch (int Sig)
{
  UNREFERENCED_PARAMETER(Sig);
  flag.timeout=TRUE;
  flag.bothsides=FALSE;
}


void algbr (int f, int t, int flag)
{
  int  m3p;
  if(f!=t)
    {
      mvstr[0][0]=(char)(97+column(f));
      mvstr[0][1]=(char)(49+row(f));
      mvstr[0][2]=(char)(97+column(t));
      mvstr[0][3]=(char)(49+row(t));
      mvstr[0][4]=mvstr[3][0]=0;
      mvstr[1][0]=pxx[board[f]];
      if(mvstr[1][0]==80)
        {
          if(mvstr[0][0]==mvstr[0][2])
            {
              mvstr[2][0]=mvstr[1][0]=mvstr[0][2];
              mvstr[2][1]=mvstr[1][1]=mvstr[0][3];
              m3p=2;
            }
          else
            {
              mvstr[2][0]=mvstr[1][0]=mvstr[0][0];
              mvstr[2][1]=mvstr[1][1]=mvstr[0][2];
              mvstr[2][2]=mvstr[0][3];
              m3p=3;
            }
          mvstr[2][m3p]=mvstr[1][2]=0;
          if(flag BAND promote)
            {
              mvstr[0][4]=mvstr[1][2]=mvstr[2][m3p]=qxx[flag BAND pmask];
              mvstr[1][3]=mvstr[2][m3p+1]=mvstr[0][5]=0;
            }
        }
      else
        {
          mvstr[2][0]=mvstr[1][0];
          mvstr[2][1]=mvstr[0][1];
          mvstr[2][2]=mvstr[1][1]=mvstr[0][2];
          mvstr[2][3]=mvstr[1][2]=mvstr[0][3];
          mvstr[2][4]=mvstr[1][3]=0;
          strcpy(mvstr[3],mvstr[2]);
          mvstr[3][1]=mvstr[0][0];
          if(flag BAND cstlmask)
            {
              if(t>f)
                {
                  strcpy(mvstr[1],"o-o");
                  strcpy(mvstr[2],"O-O");
                }
              else
                {
                  strcpy(mvstr[1],"o-o-o");
                  strcpy(mvstr[2],"O-O-O");
                }
            }
        }
    }
  else
    {
      mvstr[0][0]=mvstr[1][0]=mvstr[2][0]=mvstr[3][0]=0;
    }
}


int VerifyMove (HWND hWnd, char* s, int iop, UINT* mv)
{
  static  int  pnt;
  static  int  tempb;
  static  int  tempc;
  static  int  tempsf;
  static  int  tempst;
  static  int  cnt;
  static  struct_leaf  xnode;
  struct_leaf*  node;
  *mv=0;
  if(iop==2)
    {
      UnmakeMove(opponent, &xnode, &tempb, &tempc, &tempsf, &tempst);
      return FALSE;
    }
  cnt=0;
  MoveList(opponent,2);
  pnt=TrPnt[2];
  while(pnt<TrPnt[3])
    {
      node= &Tree[pnt++];
      algbr(node->f,node->t,(int)node->flags);
      if(strcmp(s,mvstr[0])==0||strcmp(s,mvstr[1])==0||strcmp(s,mvstr[2])==0||strcmp(s,mvstr[3])==0)
        {
          cnt++;
          xnode=*node;
        }
    }
  if(cnt==1)
    {
      MakeMove(opponent, &xnode, &tempb, &tempc, &tempsf, &tempst, &INCscore);
      if(SqAtakd(PieceList[opponent][0],computer))
        {
          UnmakeMove(opponent, &xnode, &tempb, &tempc, &tempsf, &tempst);
          SMessageBox(hWnd,IDS_ILLEGALMOVE,IDS_CHESS);
          return FALSE;
        }
      else
        {
          if(iop==1)
            {
              return TRUE;
            }
          UpdateDisplay(hWnd,xnode.f,xnode.t,0,(int)xnode.flags);
          if((board[xnode.t]==pawn)||(xnode.flags BAND capture)||(xnode.flags BAND cstlmask))
            {
              Game50=GameCnt;
              ZeroRPT();
            }
          GameList[GameCnt].depth=GameList[GameCnt].score=0;
          GameList[GameCnt].nodes=0;
          ElapsedTime(1);
          GameList[GameCnt].time=(int)et;
          TimeControl.clock[opponent]-=et;
          --TimeControl.moves[opponent];
          *mv=(xnode.f<<8) BOR xnode.t;
          algbr(xnode.f,xnode.t,FALSE);
          return TRUE;
        }
    }
  if(cnt>1)
    {
      SMessageBox(hWnd,IDS_AMBIGUOUSMOVE,IDS_CHESS);
    }
  return FALSE;
}


void ElapsedTime (int iop)
{
  et=time((ULONG*)0)-time0;
  if(et<0)
    {
      et=0;
    }
  ETnodes+=50;
  if(et>et0||iop==1)
    {
      if(et>ResponseTime+ExtraTime&&Sdepth>1)
        {
          flag.timeout=TRUE;
        }
      et0=et;
      if(iop==1)
        {
          time0=time((ULONG*)0);
          et0=0;
        }
      if(et>0)
        {
          evrate=NodeCnt/(et+ft);
        }
      else
        {
          evrate=0;
        }
      ETnodes=NodeCnt+50;
      UpdateClocks();
    }
}


void SetTimeControl (void)
{
  if(TCflag)
    {
      TimeControl.moves[white]=TimeControl.moves[black]=TCmoves;
      TimeControl.clock[white]=TimeControl.clock[black]=60*(long)TCminutes;
    }
  else
    {
      TimeControl.moves[white]=TimeControl.moves[black]=0;
      TimeControl.clock[white]=TimeControl.clock[black]=0;
      Level=60*(long)TCminutes;
    }
  et=0;
  ElapsedTime(1);
}


void GetGame (HWND hWnd, char* fname)
{
  static  FILE*   fd;
  int  c;
  int  sq;
  UINT  m;
  struct_GameRec  tmp_rec;
  fd=fopen(fname,"r");
  if(fd==NULL)
    {
      SMessageBox(hWnd,IDS_LOADFAILED,IDS_CHESS);
      return;
    }
  fscanf(fd,"%ld%ld%ld", &computer, &opponent, &Game50);
  fscanf(fd,"%ld%ld", &castld[white], &castld[black]);
  fscanf(fd,"%ld%ld", &TCflag, &OperatorTime);
  fscanf(fd,"%ld%ld%ld%ld", &TimeControl.clock[white], &TimeControl.clock[black], &TimeControl.moves[white], &TimeControl.moves[black]);
  sq=0;
  while(sq<64)
    {
      fscanf(fd,"%ld%ld", &m, &Mvboard[sq]);
      board[sq]=(m>>8);
      cColor[sq]=(m BAND 0xFF);
      if(cColor[sq]==0)
        {
          cColor[sq]=neutral;
        }
      else
        {
          --cColor[sq];
        }
      sq++;
    }
  GameCnt=0;
  c=63;
  while(c!=CEOF)
    {
      ++GameCnt;
      c=fscanf(fd,"%d%d%d%d%d%d%d", &tmp_rec.gmove, &tmp_rec.score, &tmp_rec.depth, &tmp_rec.nodes, &tmp_rec.time, &tmp_rec.piece, &tmp_rec.ccolor);
      GameList[GameCnt]=tmp_rec;
      if(GameList[GameCnt].ccolor==0)
        {
          GameList[GameCnt].ccolor=neutral;
        }
      else
        {
          --GameList[GameCnt].ccolor;
        }
    }
  GameCnt--;
  if(TimeControl.clock[white]>0)
    {
      TCflag=TRUE;
    }
  computer--;
  opponent--;
  fclose(fd);
  InitializeStats();
  Sdepth=0;
  UpdateDisplay(hWnd,0,0,1,0);
}


void SaveGame (HWND hWnd, char* fname)
{
  static  FILE*   fd;
  int  sq;
  int  i;
  int  c;
  fd=fopen(fname,"w");
  if(NULL==fd)
    {
      ShowMessage(hWnd,"Not saved");
      return;
    }
  fprintf(fd,"%d %d %d\n",computer+1,opponent+1,Game50);
  fprintf(fd,"%d %d\n",castld[white],castld[black]);
  fprintf(fd,"%d %d\n",TCflag,OperatorTime);
  fprintf(fd,"%d %d %d %d\n",TimeControl.clock[white],TimeControl.clock[black],TimeControl.moves[white],TimeControl.moves[black]);
  sq=0;
  while(sq<64)
    {
      if(cColor[sq]==neutral)
        {
          c=0;
        }
      else
        {
          c=cColor[sq]+1;
        }
      fprintf(fd,"%d %d\n",256*board[sq]+c,Mvboard[sq]);
      sq++;
    }
  i=1;
  while(i<=GameCnt)
    {
      if(GameList[i].ccolor==neutral)
        {
          c=0;
        }
      else
        {
          c=GameList[i].ccolor+1;
        }
      fprintf(fd,"%d %d %d %d %d %d %d\n",GameList[i].gmove,GameList[i].score,GameList[i].depth,GameList[i].nodes,GameList[i].time,GameList[i].piece,c);
      i++;
    }
  fclose(fd);
}


void ListGame (HWND hWnd, char* fname)
{
  static  FILE*   fd;
  int  i;
  int  f;
  int  t;
  fd=fopen(fname,"w");
  if(fd==NULL)
    {
      ShowMessage(hWnd,"Cannot write chess.lst");
      return;
    }
  fprintf(fd,"\n");
  fprintf(fd,"       score  depth   nodes  time         ");
  fprintf(fd,"       score  depth   nodes  time\n");
  i=1;
  while(i<=GameCnt)
    {
      f=GameList[i].gmove>>8;
      t=(GameList[i].gmove BAND 0xFF);
      algbr(f,t,FALSE);
      fprintf(fd,"%5s  %5d     %2d %7d %5d",mvstr[0],GameList[i].score,GameList[i].depth,GameList[i].nodes,GameList[i].time);
      if((i % 2)==0)
        {
          fprintf(fd,"\n");
        }
      else
        {
          fprintf(fd,"         ");
        }
      i++;
    }
  fprintf(fd,"\n\n");
  fclose(fd);
}


void Undo (HWND hWnd)
{
  int  f;
  int  t;
  f=GameList[GameCnt].gmove>>8;
  t=GameList[GameCnt].gmove BAND 0xFF;
  if(board[t]==king&&distance(t,f)>1)
    {
      (void)castle(GameList[GameCnt].ccolor,f,t,2);
    }
  else
    {
      if((cColor[t]==white&&row(f)==6&&row(t)==7)||(cColor[t]==black&&row(f)==1&&row(t)==0))
        {
          int  g;
          int  from=f;
          g=GameCnt-1;
          while(g>0)
            {
              if(GameList[g].gmove BAND 0xFF==from)
                {
                  from=GameList[g].gmove>>8;
                }
              g--;
            }
          if(((cColor[t]==white&&row(from)==1)||(cColor[t]==black&&row(from)==6)))
            {
              board[t]=pawn;
            }
        }
      board[f]=board[t];
      cColor[f]=cColor[t];
      board[t]=GameList[GameCnt].piece;
      cColor[t]=GameList[GameCnt].ccolor;
      if(cColor[t]!=neutral)
        {
          Mvboard[t]--;
        }
      Mvboard[f]--;
    }
  if(TCflag)
    {
      ++TimeControl.moves[cColor[f]];
    }
  GameCnt--;
  computer=otherside[computer];
  opponent=otherside[opponent];
  flag.mate=FALSE;
  Sdepth=0;
  UpdateDisplay(hWnd,0,0,1,0);
  InitializeStats();
}


int evaluate (int side, int ply, int alpha, int beta, int INCscore, int* slk, int* InChk)
{
  int  evflag;
  int  xside;
  int  s;
  xside=otherside[side];
  s=-Pscore[ply-1]+mtl[side]-mtl[xside]-INCscore;
  hung[white]=hung[black]=0;
  *slk = ((mtl[white] == valueK && (pmtl[black] == 0 || emtl[black] == 0)) ||
       (mtl[black] == valueK && (pmtl[white] == 0 || emtl[white] == 0)));
  if(*slk)
    {
      evflag=FALSE;
    }
  else
    {
  evflag = (ply == 1 || ply < Sdepth ||
     ((ply == Sdepth + 1 || ply == Sdepth + 2) &&
      (s > alpha - xwndw && s < beta + xwndw)) ||
     (ply > Sdepth + 2 && s >= alpha - 25 && s <= beta + 25));
    }
  if(evflag)
    {
      EvalNodes++;
      ataks(side,atak[side]);
      if(Anyatak(side,PieceList[xside][0]))
        {
          return (10001-ply);
        }
      ataks(xside,atak[xside]);
      *InChk=Anyatak(xside,PieceList[side][0]);
      ScorePosition(side, &s);
    }
  else
    {
      if(SqAtakd(PieceList[xside][0],side))
        {
          return (10001-ply);
        }
      *InChk=SqAtakd(PieceList[side][0],xside);
      if(*slk)
        {
          ScoreLoneKing(side, &s);
        }
    }
  Pscore[ply]=s-mtl[side]+mtl[xside];
  if(*InChk)
    {
      ChkFlag[ply-1]=Pindex[TOsquare];
    }
  else
    {
      ChkFlag[ply-1]=0;
    }
  return s;
}


int ScoreKPK (int side, int winner, int loser, int king1, int king2, int sq)
{
  int  s;
  int  r;
  if(PieceCnt[winner]==1)
    {
      s=50;
    }
  else
    {
      s=120;
    }
  if(winner==white)
    {
      if(side==loser)
        {
          r=row(sq)-1;
        }
      else
        {
          r=row(sq);
        }
      if(row(king2)>=r&&distance(sq,king2)<8-r)
        {
          s+=10*row(sq);
        }
      else
        {
          s=500+50*row(sq);
        }
      if(row(sq)<6)
        {
          sq+=16;
        }
      else if(row(sq)==6)
        {
          sq+=8;
        }
    }
  else
    {
      if(side==loser)
        {
          r=row(sq)+1;
        }
      else
        {
          r=row(sq);
        }
      if(row(king2)<=r&&distance(sq,king2)<r+1)
        {
          s+=10*(7-row(sq));
        }
      else
        {
          s=500+50*(7-row(sq));
        }
      if(row(sq)>1)
        {
          sq-=16;
        }
      else if(row(sq)==1)
        {
          sq-=8;
        }
    }
  s+=8*(taxicab(king2,sq)-taxicab(king1,sq));
  return (s);
}


int ScoreKBNK (int winner, int king1, int king2)
{
  int  s;
  int  sq;
  int  KBNKsq=0;
  sq=0;
  while(sq<64)
    {
      if(board[sq]==bishop)
        {
          if(row(sq) % 2==column(sq) % 2)
            {
              KBNKsq=0;
            }
          else
            {
              KBNKsq=7;
            }
        }
      sq++;
    }
  s=emtl[winner]-300;
  if(KBNKsq==0)
    {
      s+=KBNK[king2];
    }
  else
    {
      s+=KBNK[locn(row(king2),7-column(king2))];
    }
  s-=taxicab(king1,king2);
  s-=distance(PieceList[winner][1],king2);
  s-=distance(PieceList[winner][2],king2);
  return s;
}


void ScoreLoneKing (int side, int* score)
{
  int  winner;
  int  loser;
  int  king1;
  int  king2;
  int  s;
  int  i;
  UpdateWeights();
  if(mtl[white]>mtl[black])
    {
      winner=white;
    }
  else
    {
      winner=black;
    }
  loser=otherside[winner];
  king1=PieceList[winner][0];
  king2=PieceList[loser][0];
  s=0;
  if(pmtl[winner]>0)
    {
      i=1;
      while(i<=PieceCnt[winner])
        {
          s+=ScoreKPK(side,winner,loser,king1,king2,PieceList[winner][i]);
          i++;
        }
    }
  else if(emtl[winner]==valueB+valueN)
    {
      s=ScoreKBNK(winner,king1,king2);
    }
  else if(emtl[winner]>valueB)
    {
      s=500+emtl[winner]-DyingKing[king2]-2*distance(king1,king2);
    }
  if(side==winner)
    {
      *score=s;
    }
  else
    {
      *score=-s;
    }
}


void BRscan (int sq, int* s, int* mob)
{
  int  u;
  int  piece;
  int  pin;
  UCHAR*  ppos;
  UCHAR*  pdir;
  int*  Kf;
  Kf=Kfield[c1];
  *mob=0;
  piece=board[sq];
  ppos=nextpos+piece*64*64+sq*64;
  pdir=nextdir+piece*64*64+sq*64;
  u=ppos[sq];
  pin=-1;
  while(1)
    {
      *s+=Kf[u];
      if(cColor[u]==neutral)
        {
          (*mob)++;
          if(ppos[u]==pdir[u])
            {
              pin=-1;
            }
          u=ppos[u];
        }
      else if(pin<0)
        {
          if(board[u]==pawn||board[u]==king)
            {
              u=pdir[u];
            }
          else
            {
              if(ppos[u]!=pdir[u])
                {
                  pin=u;
                }
              u=ppos[u];
            }
        }
      else
        {
          if(cColor[u]==c2&&(board[u]>piece||atk2[u]==0))
            {
              if(cColor[pin]==c2)
                {
                  *s+=PINVAL;
                  if(atk2[pin]==0||atk1[pin]>ccontrol[board[pin]]+1)
                    {
                      ++hung[c2];
                    }
                }
              else
                {
                  *s+=XRAY;
                }
            }
          pin=-1;
          u=pdir[u];
        }
      if(!(u!=sq))
        {
          break;
        }
    }
}


void KingScan (int sq, int* s)
{
  int  u;
  UCHAR*  ppos;
  UCHAR*  pdir;
  int  cnt;
  int  ok;
  cnt=0;
  if(HasBishop[c2]||HasQueen[c2])
    {
      ppos=nextpos+bishop*64*64+sq*64;
      pdir=nextdir+bishop*64*64+sq*64;
      u=ppos[sq];
      while(1)
        {
          if(atk2[u] BAND ctlBQ)
            {
              ScoreThreat;
            }
  u = (cColor[u] == neutral ) ? ppos[u] : pdir[u] ;
          if(!(u!=sq))
            {
              break;
            }
        }
    }
  if(HasRook[c2]||HasQueen[c2])
    {
      ppos=nextpos+rook*64*64+sq*64;
      pdir=nextdir+rook*64*64+sq*64;
      u=ppos[sq];
      while(1)
        {
          if(atk2[u] BAND ctlRQ)
            {
              ScoreThreat;
            }
  u = (cColor[u] == neutral ) ? ppos[u] : pdir[u] ;
          if(!(u!=sq))
            {
              break;
            }
        }
    }
  if(HasKnight[c2])
    {
      pdir=nextdir+knight*64*64+sq*64;
      u=pdir[sq];
      while(1)
        {
          if(atk2[u] BAND ctlNN)
            {
              ScoreThreat;
            }
          u=pdir[u];
          if(!(u!=sq))
            {
              break;
            }
        }
    }
  *s+=(KSFTY*KTHRT[cnt])/16;
  cnt=0;
  ok=FALSE;
  pdir=nextpos+king*64*64+sq*64;
  u=pdir[sq];
  while(1)
    {
      if(board[u]==pawn)
        {
          ok=TRUE;
        }
      if(atk2[u]>atk1[u])
        {
          ++cnt;
          if(atk2[u] BAND ctlQ)
            {
              if(atk2[u]>ctlQ+1&&atk1[u]<ctlQ)
                {
                  *s-=4*KSFTY;
                }
            }
        }
      u=pdir[u];
      if(!(u!=sq))
        {
          break;
        }
    }
  if(!ok)
    {
      *s-=KSFTY;
    }
  if(cnt>1)
    {
      *s-=KSFTY;
    }
}


int trapped (int sq)
{
  int  u;
  int  piece;
  UCHAR*  ppos;
  UCHAR*  pdir;
  piece=board[sq];
  ppos=nextpos+(ptype[c1][piece]*64*64)+sq*64;
  pdir=nextdir+(ptype[c1][piece]*64*64)+sq*64;
  if(piece==pawn)
    {
      u=ppos[sq];
      if(cColor[u]==neutral)
        {
          if(atk1[u]>=atk2[u])
            {
              return (FALSE);
            }
          if(atk2[u]<ctlP)
            {
              u=ppos[u];
              if(cColor[u]==neutral&&atk1[u]>=atk2[u])
                {
                  return (FALSE);
                }
            }
        }
      u=pdir[sq];
      if(cColor[u]==c2)
        {
          return (FALSE);
        }
      u=pdir[u];
      if(cColor[u]==c2)
        {
          return (FALSE);
        }
    }
  else
    {
      u=ppos[sq];
      while(1)
        {
          if(cColor[u]!=c1)
            {
              if(atk2[u]==0||board[u]>=piece)
                {
                  return (FALSE);
                }
            }
  u = (cColor[u] == neutral ) ? ppos[u] : pdir[u];
          if(!((u!=sq)))
            {
              break;
            }
        }
    }
  return (TRUE);
}


int PawnValue (int sq, int side)
{
  int  j;
  int  fyle;
  int  rank;
  int  s;
  int  a1;
  int  a2;
  int  in_square;
  int  r;
  int  e;
  a1=(atk1[sq] BAND 0x4FFF);
  a2=(atk2[sq] BAND 0x4FFF);
  rank=row(sq);
  fyle=column(sq);
  s=0;
  if(c1==white)
    {
      s=Mwpawn[sq];
      if((sq==11&&cColor[19]!=neutral)||(sq==12&&cColor[20]!=neutral))
        {
          s+=PEDRNK2B;
        }
      if((fyle==0||PC1[fyle-1]==0)&&(fyle==7||PC1[fyle+1]==0))
        {
          s+=ISOLANI[fyle];
        }
      else if(PC1[fyle]>1)
        {
          s+=PDOUBLED;
        }
      if(a1<ctlP&&atk1[sq+8]<ctlP)
        {
          s+=BACKWARD[a2 BAND 0xFF];
          if(PC2[fyle]==0)
            {
              s+=PWEAKH;
            }
          if(cColor[sq+8]!=neutral)
            {
              s+=PBLOK;
            }
        }
      if(PC2[fyle]==0)
        {
          if(side==black)
            {
              r=rank-1;
            }
          else
            {
              r=rank;
            }
          in_square=(row(bking)>=r BAND distance(sq,bking)<8-r);
          if(a2==0||side==white)
            {
              e=0;
            }
          else
            {
              e=1;
            }
          j=sq+8;
          while(j<64)
            {
              if(atk2[j]>=ctlP)
                {
                  e=2;
                  break;
                }
              else if(atk2[j]>0||cColor[j]!=neutral)
                {
                  e=1;
                }
              j+=8;
            }
          if(e==2)
            {
              s+=(stage*PassedPawn3[rank])/10;
            }
          else if(in_square||e==1)
            {
              s+=(stage*PassedPawn2[rank])/10;
            }
          else if(emtl[black]>0)
            {
              s+=(stage*PassedPawn1[rank])/10;
            }
          else
            {
              s+=PassedPawn0[rank];
            }
        }
    }
  else if(c1==black)
    {
      s=Mbpawn[sq];
      if((sq==51&&cColor[43]!=neutral)||(sq==52&&cColor[44]!=neutral))
        {
          s+=PEDRNK2B;
        }
      if((fyle==0||PC1[fyle-1]==0)&&(fyle==7||PC1[fyle+1]==0))
        {
          s+=ISOLANI[fyle];
        }
      else if(PC1[fyle]>1)
        {
          s+=PDOUBLED;
        }
      if(a1<ctlP&&atk1[sq-8]<ctlP)
        {
          s+=BACKWARD[a2 BAND 0xFF];
          if(PC2[fyle]==0)
            {
              s+=PWEAKH;
            }
          if(cColor[sq-8]!=neutral)
            {
              s+=PBLOK;
            }
        }
      if(PC2[fyle]==0)
        {
          if(side==white)
            {
              r=rank+1;
            }
          else
            {
              r=rank;
            }
          in_square=(row(wking)<=r BAND distance(sq,wking)<r+1);
          if(a2==0||side==black)
            {
              e=0;
            }
          else
            {
              e=1;
            }
          j=sq-8;
          while(j>=0)
            {
              if(atk2[j]>=ctlP)
                {
                  e=2;
                  break;
                }
              else if(atk2[j]>0||cColor[j]!=neutral)
                {
                  e=1;
                }
              j-=8;
            }
          if(e==2)
            {
              s+=(stage*PassedPawn3[7-rank])/10;
            }
          else if(in_square||e==1)
            {
              s+=(stage*PassedPawn2[7-rank])/10;
            }
          else if(emtl[white]>0)
            {
              s+=(stage*PassedPawn1[7-rank])/10;
            }
          else
            {
              s+=PassedPawn0[7-rank];
            }
        }
    }
  if(a2>0)
    {
      if(a1==0||a2>ctlP+1)
        {
          s+=HUNGP;
          ++hung[c1];
          if(trapped(sq))
            {
              ++hung[c1];
            }
        }
      else if(a2>a1)
        {
          s+=ATAKD;
        }
    }
  return (s);
}


int KnightValue (int sq, int side)
{
  int  s;
  int  a2;
  int  a1;
  UNREFERENCED_PARAMETER(side);
  s=Mknight[c1][sq];
  a2=(atk2[sq] BAND 0x4FFF);
  if(a2>0)
    {
      a1=(atk1[sq] BAND 0x4FFF);
      if(a1==0||a2>ctlBN+1)
        {
          s+=HUNGP;
          ++hung[c1];
          if(trapped(sq))
            {
              ++hung[c1];
            }
        }
      else if(a2>=ctlBN||a1<ctlP)
        {
          s+=ATAKD;
        }
    }
  return (s);
}


int BishopValue (int sq, int side)
{
  int  a2;
  int  a1;
  int  s;
  int  mob;
  UNREFERENCED_PARAMETER(side);
  s=Mbishop[c1][sq];
  BRscan(sq, &s, &mob);
  s+=BMBLTY[mob];
  a2=(atk2[sq] BAND 0x4FFF);
  if(a2>0)
    {
      a1=(atk1[sq] BAND 0x4FFF);
      if(a1==0||a2>ctlBN+1)
        {
          s+=HUNGP;
          ++hung[c1];
          if(trapped(sq))
            {
              ++hung[c1];
            }
        }
      else if(a2>=ctlBN||a1<ctlP)
        {
          s+=ATAKD;
        }
    }
  return (s);
}


int RookValue (int sq, int side)
{
  int  fyle;
  int  a2;
  int  a1;
  int  s;
  int  mob;
  UNREFERENCED_PARAMETER(side);
  s=RookBonus;
  BRscan(sq, &s, &mob);
  s+=RMBLTY[mob];
  fyle=column(sq);
  if(PC1[fyle]==0)
    {
      s+=RHOPN;
    }
  if(PC2[fyle]==0)
    {
      s+=RHOPNX;
    }
  if(pmtl[c2]>100&&row(sq)==rank7[c1])
    {
      s+=10;
    }
  if(stage>2)
    {
      s+=14-taxicab(sq,EnemyKing);
    }
  a2=(atk2[sq] BAND 0x4FFF);
  if(a2>0)
    {
      a1=(atk1[sq] BAND 0x4FFF);
      if(a1==0||a2>ctlR+1)
        {
          s+=HUNGP;
          ++hung[c1];
          if(trapped(sq))
            {
              ++hung[c1];
            }
        }
      else if(a2>=ctlR||a1<ctlP)
        {
          s+=ATAKD;
        }
    }
  return (s);
}


int QueenValue (int sq, int side)
{
  int  s;
  int  a2;
  int  a1;
  UNREFERENCED_PARAMETER(side);
  s = (distance (sq, EnemyKing ) < 3 ) ? 12 : 0 ;
  if(stage>2)
    {
      s+=14-taxicab(sq,EnemyKing);
    }
  a2=(atk2[sq] BAND 0x4FFF);
  if(a2>0)
    {
      a1=(atk1[sq] BAND 0x4FFF);
      if(a1==0||a2>ctlQ+1)
        {
          s+=HUNGP;
          ++hung[c1];
          if(trapped(sq))
            {
              ++hung[c1];
            }
        }
      else if(a2>=ctlQ||a1<ctlP)
        {
          s+=ATAKD;
        }
    }
  return (s);
}


int KingValue (int sq, int side)
{
  int  fyle;
  int  a2;
  int  a1;
  int  s;
  UNREFERENCED_PARAMETER(side);
  s=Mking[c1][sq];
  if(KSFTY>0)
    {
      if(Developed[c2]||stage>0)
        {
          KingScan(sq, &s);
        }
    }
  if((castld[c1]))
    {
      s+=KCASTLD;
    }
  else if(Mvboard[kingP[c1]])
    {
      s+=KMOVD;
    }
  fyle=column(sq);
  if(PC1[fyle]==0)
    {
      s+=KHOPN;
    }
  if(PC2[fyle]==0)
    {
      s+=KHOPNX;
    }
  while(1)
  {
    if((fyle)==5)
      {
        if(PC1[7]==0)
          {
            s+=KHOPN;
          }
        if(PC2[7]==0)
          {
            s+=KHOPNX;
          }
        if(PC1[fyle+1]==0)
          {
            s+=KHOPN;
          }
        if(PC2[fyle+1]==0)
          {
            s+=KHOPNX;
          }
        break;
      }
    if((fyle)==4||(fyle)==6||(fyle)==0)
      {
        if(PC1[fyle+1]==0)
          {
            s+=KHOPN;
          }
        if(PC2[fyle+1]==0)
          {
            s+=KHOPNX;
          }
        break;
      }
    if((fyle)==2)
      {
        if(PC1[0]==0)
          {
            s+=KHOPN;
          }
        if(PC2[0]==0)
          {
            s+=KHOPNX;
          }
        if(PC1[fyle-1]==0)
          {
            s+=KHOPN;
          }
        if(PC2[fyle-1]==0)
          {
            s+=KHOPNX;
          }
        break;
      }
    if((fyle)==3||(fyle)==1||(fyle)==7)
      {
        if(PC1[fyle-1]==0)
          {
            s+=KHOPN;
          }
        if(PC2[fyle-1]==0)
          {
            s+=KHOPNX;
          }
        break;
      }
      // case else
      {
      }
    break;
  }
  a2=(atk2[sq] BAND 0x4FFF);
  if(a2>0)
    {
      a1=(atk1[sq] BAND 0x4FFF);
      if(a1==0||a2>ctlK+1)
        {
          s+=HUNGP;
          ++hung[c1];
        }
      else
        {
          s+=ATAKD;
        }
    }
  return (s);
}


void ScorePosition (int side, int* score)
{
  int  sq;
  int  s;
  int  i;
  int  xside;
  int  pscore[2];
  UpdateWeights();
  xside=otherside[side];
  pscore[white]=pscore[black]=0;
  c1=white;
  while(c1<=black)
    {
      c2=otherside[c1];
      atk1=atak[c1];
      atk2=atak[c2];
      PC1=PawnCnt[c1];
      PC2=PawnCnt[c2];
      i=PieceCnt[c1];
      while(i>=0)
        {
          sq=PieceList[c1][i];
          while(1)
          {
            if((board[sq])==pawn)
              {
                s=PawnValue(sq,side);
                break;
              }
            if((board[sq])==knight)
              {
                s=KnightValue(sq,side);
                break;
              }
            if((board[sq])==bishop)
              {
                s=BishopValue(sq,side);
                break;
              }
            if((board[sq])==rook)
              {
                s=RookValue(sq,side);
                break;
              }
            if((board[sq])==queen)
              {
                s=QueenValue(sq,side);
                break;
              }
            if((board[sq])==king)
              {
                s=KingValue(sq,side);
                break;
              }
              // case else
              {
                s=0;
              }
            break;
          }
          pscore[c1]+=s;
          svalue[sq]=s;
          i--;
        }
      c1++;
    }
  if(hung[side]>1)
    {
      pscore[side]+=HUNGX;
    }
  if(hung[xside]>1)
    {
      pscore[xside]+=HUNGX;
    }
  *score=mtl[side]-mtl[xside]+pscore[side]-pscore[xside]+10;
  if(dither)
    {
      *score+=urand() % dither;
    }
  if(*score>0&&pmtl[side]==0)
    {
      if(emtl[side]<valueR)
        {
          *score=0;
        }
      else if(*score<valueR)
        {
          *score/=2;
        }
    }
  if((*score<0&&pmtl[xside]==0))
    {
      if((emtl[xside]<valueR))
        {
          *score=0;
        }
      else if(-*score<valueR)
        {
          *score/=2;
        }
    }
  if(mtl[xside]==valueK&&emtl[side]>valueB)
    {
      *score+=200;
    }
  if(mtl[side]==valueK&&emtl[xside]>valueB)
    {
      *score-=200;
    }
}


void BlendBoard (int* a, int* b, int* c)
{
  int  sq;
  sq=0;
  while(sq<64)
    {
      *(c+sq)=(*(a+sq)*(10-stage)+*(b+sq)*stage)/10;
      sq++;
    }
}


void CopyBoard (int* a, int* b)
{
  int  sq;
  sq=0;
  while(sq<64)
    {
      *(b+sq)=*(a+sq);
      sq++;
    }
}


void ExaminePosition (void)
{
  int  i;
  int  sq;
  int  wpadv;
  int  bpadv;
  int  wstrong;
  int  bstrong;
  int  z;
  int  side;
  int  pp;
  int  j;
  int  k;
  int  vval;
  int  Pd;
  int  fyle;
  int  rank;
  static  int  PawnStorm=FALSE;
  ataks(white,atak[white]);
  ataks(black,atak[black]);
  UpdateWeights();
  HasKnight[white]=HasKnight[black]=0;
  HasBishop[white]=HasBishop[black]=0;
  HasRook[white]=HasRook[black]=0;
  HasQueen[white]=HasQueen[black]=0;
  side=white;
  while(side<=black)
    {
      i=PieceCnt[side];
      while(i>=0)
        {
          while(1)
          {
            if(board[PieceList[side][i]]==knight)
              {
                ++HasKnight[side];
                break;
              }
            if(board[PieceList[side][i]]==bishop)
              {
                ++HasBishop[side];
                break;
              }
            if(board[PieceList[side][i]]==rook)
              {
                ++HasRook[side];
                break;
              }
            if(board[PieceList[side][i]]==queen)
              {
                ++HasQueen[side];
              }
            break;
          }
          i--;
        }
      side++;
    }
  if(!Developed[white])
    {
      Developed[white]=(board[1]!=knight BAND board[2]!=bishop BAND board[5]!=bishop BAND board[6]!=knight);
    }
  if(!Developed[black])
    {
      Developed[black]=(board[57]!=knight BAND board[58]!=bishop BAND board[61]!=bishop BAND board[62]!=knight);
    }
  if(!PawnStorm&&stage<5)
    {
      PawnStorm=((column(wking)<3 BAND column(bking)>4)||(column(wking)>4 BAND column(bking)<3));
    }
  CopyBoard(pknight,Mknight[white]);
  CopyBoard(pknight,Mknight[black]);
  CopyBoard(pbishop,Mbishop[white]);
  CopyBoard(pbishop,Mbishop[black]);
  BlendBoard(KingOpening,KingEnding,Mking[white]);
  BlendBoard(KingOpening,KingEnding,Mking[black]);
  sq=0;
  while(sq<64)
    {
      fyle=column(sq);
      rank=row(sq);
      wstrong=bstrong=TRUE;
      i=sq;
      while(i<64)
        {
          if(Patak(black,i))
            {
              wstrong=FALSE;
              break;
            }
          i+=8;
        }
      i=sq;
      while(i>=0)
        {
          if(Patak(white,i))
            {
              bstrong=FALSE;
              break;
            }
          i-=8;
        }
      wpadv=bpadv=PADVNCM;
      if((fyle==0||PawnCnt[white][fyle-1]==0)&&(fyle==7||PawnCnt[white][fyle+1]==0))
        {
          wpadv=PADVNCI;
        }
      if((fyle==0||PawnCnt[black][fyle-1]==0)&&(fyle==7||PawnCnt[black][fyle+1]==0))
        {
          bpadv=PADVNCI;
        }
      Mwpawn[sq]=(wpadv*PawnAdvance[sq])/10;
      Mbpawn[sq]=(bpadv*PawnAdvance[63-sq])/10;
      Mwpawn[sq]+=PawnBonus;
      Mbpawn[sq]+=PawnBonus;
      if(Mvboard[kingP[white]])
        {
          if((fyle<3||fyle>4)&&distance(sq,wking)<3)
            {
              Mwpawn[sq]+=PAWNSHIELD;
            }
        }
      else if(rank<3&&(fyle<2||fyle>5))
        {
          Mwpawn[sq]+=PAWNSHIELD/2;
        }
      if(Mvboard[kingP[black]])
        {
          if((fyle<3||fyle>4)&&distance(sq,bking)<3)
            {
              Mbpawn[sq]+=PAWNSHIELD;
            }
        }
      else if(rank>4&&(fyle<2||fyle>5))
        {
          Mbpawn[sq]+=PAWNSHIELD/2;
        }
      if(PawnStorm)
        {
          if((column(wking)<4&&fyle>4)||(column(wking)>3&&fyle<3))
            {
              Mwpawn[sq]+=3*rank-21;
            }
          if((column(bking)<4&&fyle>4)||(column(bking)>3&&fyle<3))
            {
              Mbpawn[sq]-=3*rank;
            }
        }
      Mknight[white][sq]+=5-distance(sq,bking);
      Mknight[white][sq]+=5-distance(sq,wking);
      Mknight[black][sq]+=5-distance(sq,wking);
      Mknight[black][sq]+=5-distance(sq,bking);
      Mbishop[white][sq]+=BishopBonus;
      Mbishop[black][sq]+=BishopBonus;
      int  xxxtmp;
      i=PieceCnt[black];
      while(i>=0)
        {
          xxxtmp=PieceList[black][i];
          if(distance(sq,xxxtmp)<3)
            {
              Mknight[white][sq]+=KNIGHTPOST;
            }
          i--;
        }
      i=PieceCnt[white];
      while(i>=0)
        {
          xxxtmp=PieceList[white][i];
          if(distance(sq,xxxtmp)<3)
            {
              Mknight[black][sq]+=KNIGHTPOST;
            }
          i--;
        }
      if(wstrong)
        {
          Mknight[white][sq]+=KNIGHTSTRONG;
        }
      if(bstrong)
        {
          Mknight[black][sq]+=KNIGHTSTRONG;
        }
      if(wstrong)
        {
          Mbishop[white][sq]+=BISHOPSTRONG;
        }
      if(bstrong)
        {
          Mbishop[black][sq]+=BISHOPSTRONG;
        }
      if(HasBishop[white]==2)
        {
          Mbishop[white][sq]+=8;
        }
      if(HasBishop[black]==2)
        {
          Mbishop[black][sq]+=8;
        }
      if(HasKnight[white]==2)
        {
          Mknight[white][sq]+=5;
        }
      if(HasKnight[black]==2)
        {
          Mknight[black][sq]+=5;
        }
      Kfield[white][sq]=Kfield[black][sq]=0;
      if(distance(sq,wking)==1)
        {
          Kfield[black][sq]=KATAK;
        }
      if(distance(sq,bking)==1)
        {
          Kfield[white][sq]=KATAK;
        }
      Pd=0;
      k=0;
      while(k<=PieceCnt[white])
        {
          i=PieceList[white][k];
          if(board[i]==pawn)
            {
              pp=TRUE;
              if(row(i)==6)
                {
                  z=i+8;
                }
              else
                {
                  z=i+16;
                }
              j=i+8;
              while(j<64)
                {
                  if(Patak(black,j)||board[j]==pawn)
                    {
                      pp=FALSE;
                      break;
                    }
                  j+=8;
                }
              if(pp)
                {
                  Pd+=5*taxicab(sq,z);
                }
              else
                {
                  Pd+=taxicab(sq,z);
                }
            }
          k++;
        }
      k=0;
      while(k<=PieceCnt[black])
        {
          i=PieceList[black][k];
          if(board[i]==pawn)
            {
              pp=TRUE;
              if(row(i)==1)
                {
                  z=i-8;
                }
              else
                {
                  z=i-16;
                }
              j=i-8;
              while(j>=0)
                {
                  if(Patak(white,j)||board[j]==pawn)
                    {
                      pp=FALSE;
                      break;
                    }
                  j-=8;
                }
              if(pp)
                {
                  Pd+=5*taxicab(sq,z);
                }
              else
                {
                  Pd+=taxicab(sq,z);
                }
            }
          k++;
        }
      if(Pd!=0)
        {
          vval=(Pd*stage2)/10;
          Mking[white][sq]-=vval;
          Mking[black][sq]-=vval;
        }
      sq++;
    }
}


void UpdateWeights (void)
{
  int  tmtl;
  int  s1;
  emtl[white]=mtl[white]-pmtl[white]-valueK;
  emtl[black]=mtl[black]-pmtl[black]-valueK;
  tmtl=emtl[white]+emtl[black];
  s1 = (tmtl > 6600 ) ? 0 : ((tmtl < 1400 ) ? 10 : (6600 - tmtl ) / 520 ) ;
  if(s1!=stage)
    {
      stage=s1;
  stage2 = (tmtl > 3600 ) ? 0 : ((tmtl < 1400 ) ? 10 : (3600 - tmtl ) / 220 ) ;
      PEDRNK2B=-15;
      PBLOK=-4;
      PDOUBLED=-14;
      PWEAKH=-4;
      PAWNSHIELD=10-stage;
      PADVNCM=10;
      PADVNCI=7;
      PawnBonus=stage;
      KNIGHTPOST=(stage+2)/3;
      KNIGHTSTRONG=(stage+6)/2;
      BISHOPSTRONG=(stage+6)/2;
      BishopBonus=2*stage;
      RHOPN=10;
      RHOPNX=4;
      RookBonus=6*stage;
      XRAY=8;
      PINVAL=10;
      KHOPN=(3*stage-30)/2;
      KHOPNX=KHOPN/2;
      KCASTLD=10-stage;
      KMOVD=-40/(stage+1);
      KATAK=(10-stage)/2;
      if(stage<8)
        {
          KSFTY=16-2*stage;
        }
      else
        {
          KSFTY=0;
        }
      ATAKD=-6;
      HUNGP=-8;
      HUNGX=-12;
    }
}


void InitHitTest (void)
{
  POINT  ptls[4];
  POINT  toppt;
  POINT  botpt;
  int  i;
  i=0;
  while(i<8)
    {
      QuerySqOrigin(i,0,ptls+0);
      QuerySqOrigin(i,8,ptls+1);
      QuerySqOrigin(i+1,8,ptls+2);
      QuerySqOrigin(i+1,0,ptls+3);
      hitrgn[i]=CreatePolygonRgn(ptls,4,WINDING);
      i++;
    }
  QuerySqOrigin(0,0, &botpt);
  QuerySqOrigin(0,8, &toppt);
  deltay=botpt.y-toppt.y;
}


void Hittest_Destructor (void)
{
  int  i;
  i=0;
  while(i<8)
    {
      DeleteObject(hitrgn[i]);
      i++;
    }
}


int HorzHitTest (int x, int y)
{
  int  i;
  i=0;
  while(i<8)
    {
      if(PtInRegion(hitrgn[i],x,y))
        {
          return i;
        }
      i++;
    }
  return -1;
}


int HitTest (int x, int y)
{
  int  xsq;
  int  ysq;
  POINT  sq00;
  xsq=HorzHitTest(x,y);
  if(xsq==-1)
    {
      return -1;
    }
  QuerySqOrigin(0,0, &sq00);
  if(y>sq00.y)
    {
      return -1;
    }
  if(y<(sq00.y-deltay))
    {
      return -1;
    }
  ysq=7-(y-(sq00.y-deltay))/(deltay/8);
  return (ysq*8+xsq);
}


BOOL ChessInit (HANDLE hInstance)
{
  HANDLE  hMemory;
  PWNDCLASS  pWndClass;
  BOOL  bSuccess;
  hMemory=LocalAlloc(LHND,sizeof(WNDCLASS));
  pWndClass=(PWNDCLASS)LocalLock(hMemory);
  pWndClass->style=(DWORD)NULL;
  pWndClass->lpfnWndProc=(WNDPROC)ChessWndProc;
  pWndClass->hInstance=hInstance;
  pWndClass->hIcon=LoadIcon(hInstance,szAppName);
  pWndClass->hCursor=LoadCursor(NULL,IDC_ARROW);
  pWndClass->hbrBackground=GetStockObject(WHITE_BRUSH);
  pWndClass->lpszMenuName=(LPSTR)szAppName;
  pWndClass->lpszClassName=(LPSTR)szAppName;
  bSuccess=RegisterClass(pWndClass);
  LocalUnlock(hMemory);
  LocalFree(hMemory);
  return (bSuccess);
}


void Initialize_dist (void)
{
  int  a;
  int  b;
  int  d;
  int  di;
  a=0;
  while(a<64)
    {
      b=0;
      while(b<64)
        {
          d=Abs(column(a)-column(b));
          di=Abs(row(a)-row(b));
          *(taxidata+a*64+b)=d+di;
  *(distdata+a*64+b ) = (d > di ? d : di );
          b++;
        }
      a++;
    }
}


void Initialize_moves (void)
{
  int  ptyp;
  int  po;
  int  d;
  int  di;
  int  s;
  int  delta;
  int  p0;
  UCHAR*  ppos;
  UCHAR*  pdir;
  int  dest[8][8];
  int  steps[8];
  int  sorted[8];
  ptyp=0;
  while(ptyp<8)
    {
      po=0;
      while(po<64)
        {
          p0=0;
          while(p0<64)
            {
              *(nextpos+ptyp*64*64+po*64+p0)=(UCHAR)po;
              *(nextdir+ptyp*64*64+po*64+p0)=(UCHAR)po;
              p0++;
            }
          po++;
        }
      ptyp++;
    }
  ptyp=1;
  while(ptyp<8)
    {
      po=21;
      while(po<99)
        {
          if(nunmap[po]>=0)
            {
              ppos=nextpos+ptyp*64*64+nunmap[po]*64;
              pdir=nextdir+ptyp*64*64+nunmap[po]*64;
              d=0;
              while(d<8)
                {
                  dest[d][0]=nunmap[po];
                  delta=direc[ptyp][d];
                  if(delta!=0)
                    {
                      p0=po;
                      s=0;
                      while(s<max_steps[ptyp])
                        {
                          p0+=delta;
                          if((nunmap[p0]<0||(ptyp==pawn||ptyp==bpawn)&&s>0&&(d>0||Stboard[nunmap[po]]!=pawn)))
                            {
                              break;
                            }
                          else
                            {
                              dest[d][s]=nunmap[p0];
                            }
                          s++;
                        }
                    }
                  else
                    {
                      s=0;
                    }
                  steps[d]=s;
                  di=d;
                  while((s>0&&di>0))
                    {
                      if((steps[sorted[di-1]]<s))
                        {
                          sorted[di]=sorted[di-1];
                        }
                      else
                        {
                          break;
                        }
                      di--;
                    }
                  sorted[di]=d;
                  d++;
                }
              p0=nunmap[po];
              if((ptyp==pawn||ptyp==bpawn))
                {
                  s=0;
                  while(s<steps[0])
                    {
                      ppos[p0]=(UCHAR)dest[0][s];
                      p0=dest[0][s];
                      s++;
                    }
                  p0=nunmap[po];
                  d=1;
                  while(d<3)
                    {
                      pdir[p0]=(UCHAR)dest[d][0];
                      p0=dest[d][0];
                      d++;
                    }
                }
              else
                {
                  pdir[p0]=(UCHAR)dest[sorted[0]][0];
                  d=0;
                  while(d<8)
                    {
                      s=0;
                      while(s<steps[sorted[d]])
                        {
                          ppos[p0]=(UCHAR)dest[sorted[d]][s];
                          p0=dest[sorted[d]][s];
                          if(d<7)
                            {
                              pdir[p0]=(UCHAR)dest[sorted[d+1]][0];
                            }
                          s++;
                        }
                      d++;
                    }
                }
            }
          po++;
        }
      ptyp++;
    }
}


int init_main (HWND hWnd)
{
  int  ahead=TRUE;
  int  hash=TRUE;
  hHistory=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(8192*sizeof(char)));
  if(hHistory==NULL)
    {
      return 1;
    }
  history=(UCHAR*)GlobalLock(hHistory);
  hnextdir=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(64*64*8*sizeof(char)));
  if(hnextdir==NULL)
    {
      return 1;
    }
  nextdir=(UCHAR*)GlobalLock(hnextdir);
  hnextpos=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(64*64*8*sizeof(char)));
  if(hnextpos==NULL)
    {
      return 1;
    }
  nextpos=(UCHAR*)GlobalLock(hnextpos);
  hdistdata=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(64*64*sizeof(int)));
  if(hdistdata==NULL)
    {
      return 1;
    }
  distdata=(int*)GlobalLock(hdistdata);
  htaxidata=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(64*64*sizeof(int)));
  if(htaxidata==NULL)
    {
      return 1;
    }
  taxidata=(int*)GlobalLock(htaxidata);
  hHashCode=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(2*7*64*sizeof(struct_hashval)));
  if(hHashCode==NULL)
    {
      return 1;
    }
  hashcode=(struct_hashval*)GlobalLock(hHashCode);
  hTree=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(2000*sizeof(struct_leaf)));
  if(hTree==NULL)
    {
      return 1;
    }
  Tree=(struct_leaf*)GlobalLock(hTree);
  hGameList=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(512*sizeof(struct_GameRec)));
  if(hGameList==NULL)
    {
      return 1;
    }
  GameList=(struct_GameRec*)GlobalLock(hGameList);
  hTTable=GlobalAlloc(GMEM_MOVEABLE BOR GMEM_ZEROINIT,(long)(2*ttblsz*sizeof(struct_hashentry)));
  if(hTTable==NULL)
    {
      return 1;
    }
  ttable=(struct_hashentry*)GlobalLock(hTTable);
  Level=0;
  TCflag=FALSE;
  OperatorTime=0;
  Initialize();
  Initialize_dist();
  Initialize_moves();
  NewGame(hWnd);
  GetOpenings(hWnd);
  flag.easy=ahead;
  flag.hash=hash;
  hashfile=NULL;
  return (0);
}


void FreeChessGlobals (void)
{
  if(hHistory)
    {
      GlobalUnlock(hHistory);
      GlobalFree(hHistory);
    }
  if(hnextdir)
    {
      GlobalUnlock(hnextdir);
      GlobalFree(hnextdir);
    }
  if(hGameList)
    {
      GlobalUnlock(hGameList);
      GlobalFree(hGameList);
    }
  if(hTTable)
    {
      GlobalUnlock(hTTable);
      GlobalFree(hTTable);
    }
  if(hTree)
    {
      GlobalUnlock(hTree);
      GlobalFree(hTree);
    }
  if(hHashCode)
    {
      GlobalUnlock(hHashCode);
      GlobalFree(hHashCode);
    }
  if(htaxidata)
    {
      GlobalUnlock(htaxidata);
      GlobalFree(htaxidata);
    }
  if(hdistdata)
    {
      GlobalUnlock(hdistdata);
      GlobalFree(hdistdata);
    }
  if(hnextpos)
    {
      GlobalUnlock(hnextpos);
      GlobalFree(hnextpos);
    }
}


void NewGame (HWND hWnd)
{
  int  l;
  int  c;
  int  p;
  stage=stage2=-1;
  if(flag.post)
    {
      SendMessage(hStats,(UINT)WM_SYSCOMMAND,(WPARAM)SC_CLOSE,(LPARAM)0);
      flag.post=FALSE;
    }
  flag.mate=flag.quit=flag.reverse=flag.bothsides=FALSE;
  flag.force=FALSE;
  flag.hash=flag.easy=flag.beep=flag.rcptr=TRUE;
  NodeCnt=et0=epsquare=0;
  dither=0;
  Awindow=90;
  Bwindow=90;
  xwndw=90;
  MaxSearchDepth=29;
  contempt=0;
  GameCnt=0;
  Game50=1;
  hint=0x0C14;
  ZeroRPT();
  Developed[white]=Developed[black]=FALSE;
  castld[white]=castld[black]=FALSE;
  PawnThreat[0]=CptrFlag[0]=FALSE;
  Pscore[0]=12000;
  Tscore[0]=12000;
  opponent=white;
  computer=black;
  l=0;
  while(l<2000)
    {
      (Tree+l)->f=(Tree+l)->t=0;
      l++;
    }
  rehash=6;
  ZeroTTable();
  srand((UINT)1);
  c=white;
  while(c<=black)
    {
      p=pawn;
      while(p<=king)
        {
          l=0;
          while(l<64)
            {
              (hashcode+c*7*64+p*64+l)->key=(((ULONG)urand()));
              (hashcode+c*7*64+p*64+l)->key+=(((ULONG)urand())<<16);
              (hashcode+c*7*64+p*64+l)->bd=(((ULONG)urand()));
              (hashcode+c*7*64+p*64+l)->bd+=(((ULONG)urand())<<16);
              l++;
            }
          p++;
        }
      c++;
    }
  l=0;
  while(l<64)
    {
      board[l]=Stboard[l];
      cColor[l]=Stcolor[l];
      Mvboard[l]=0;
      l++;
    }
  if(TCflag)
    {
      SetTimeControl();
    }
  else if(Level==0)
    {
      OperatorTime=1;
      TCmoves=60;
      TCminutes=5;
      TCflag=(TCmoves>1);
      SetTimeControl();
    }
  InitializeStats();
  time0=time((ULONG*)0);
  ElapsedTime(1);
  UpdateDisplay(hWnd,0,0,1,0);
}


void Init_Menus (HWND hWnd, UINT wParam, long lParam)
{
  WORD  Status;
  UNREFERENCED_PARAMETER(hWnd);
  if(lParam==MENU_ID_EDIT)
    {
 EnableMenuItem ((HMENU ) wParam, MSG_CHESS_REVIEW, (GameCnt>0 ? MF_ENABLED : MF_GRAYED));
 EnableMenuItem ((HMENU ) wParam, MSG_CHESS_UNDO, (GameCnt>0 ? MF_ENABLED : MF_GRAYED));
 EnableMenuItem ((HMENU ) wParam, MSG_CHESS_REMOVE, (GameCnt>1 ? MF_ENABLED : MF_GRAYED));
    }
  else if(lParam==MENU_ID_OPTIONS)
    {
      if(flag.hash==FALSE)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_HASH,Status);
      if(coords==FALSE)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_COORD,Status);
      if(flag.beep==FALSE)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_BEEP,Status);
      if(flag.bothsides==FALSE)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_BOTH,Status);
      if(Book==NULL)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_BOOK,Status);
      if(flag.post==FALSE)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_POST,Status);
    }
  else if(lParam==MENU_ID_SKILL)
    {
      if(dither==0)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_RANDOM,Status);
      if(flag.easy==FALSE)
        {
          Status=MF_CHECKED;
        }
      else
        {
          Status=MF_UNCHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_EASY,Status);
    }
  else if(lParam==MENU_ID_SIDE)
    {
      if(flag.reverse==FALSE)
        {
          Status=MF_UNCHECKED;
        }
      else
        {
          Status=MF_CHECKED;
        }
      CheckMenuItem((HMENU)wParam,MSG_CHESS_REVERSE,Status);
      if(computer==black)
        {
          CheckMenuItem((HMENU)wParam,MSG_CHESS_BLACK,MF_CHECKED);
          CheckMenuItem((HMENU)wParam,MSG_CHESS_WHITE,MF_UNCHECKED);
        }
      else
        {
          CheckMenuItem((HMENU)wParam,MSG_CHESS_WHITE,MF_CHECKED);
          CheckMenuItem((HMENU)wParam,MSG_CHESS_BLACK,MF_UNCHECKED);
        }
    }
}


void ShowPlayers (void)
{
 SetWindowText ( hComputerColor, (computer == black ) ? "Computer is black" : "Computer is white" ) ;
}


void ShowDepth (char ch)
{
  char  tmp[30];
  if(hStats)
    {
      wsprintf(tmp,"%d%c",Sdepth,ch);
      SetDlgItemText(hStats,DEPTHTEXT,tmp);
    }
}


void ShowScore (int score)
{
  char  tmp[30];
  if(hStats)
    {
      wsprintf(tmp,"%d",score);
      SetDlgItemText(hStats,SCORETEXT,tmp);
    }
}


void ShowMessage (HWND hWnd, char* s)
{
  MessageBox(hWnd,s,"Chess",MB_OK BOR MB_ICONEXCLAMATION BOR MB_APPLMODAL);
}


void SMessageBox (HWND hWnd, int str_num, int str1_num)
{
  char  sstr[80];
  char  str1[20];
  LoadString((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),str_num,sstr,sizeof(sstr));
  LoadString((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),str1_num,str1,sizeof(str1));
  MessageBox(hWnd,sstr,str1,MB_OK BOR MB_ICONEXCLAMATION BOR MB_APPLMODAL);
}


void ClearMessage (void)
{
}


void ShowCurrentMove (int pnt, int f, int t)
{
  char  tmp[30];
  if(hStats)
    {
      algbr(f,t,FALSE);
      wsprintf(tmp,"(%2d) %4s",pnt,(char*)mvstr[0]);
      SetDlgItemText(hStats,POSITIONTEXT,tmp);
    }
}


void ShowSidetoMove (void)
{
  char  tmp[30];
  wsprintf(tmp,"It is %s's turn",(char*)ColorStr[player]);
  SetWindowText(hWhosTurn,(LPSTR)tmp);
}


void ShowPrompt (void)
{
}


void ShowNodeCnt (long NodeCnt, long evrate)
{
  char  tmp[40];
  if(hStats)
    {
      wsprintf(tmp,"%-8ld",NodeCnt);
      SetDlgItemText(hStats,NODETEXT,tmp);
      wsprintf(tmp,"%-5ld",evrate);
      SetDlgItemText(hStats,NODESECTEXT,tmp);
    }
}


void ShowResults (int score, UINT* bstline, char ch)
{
  UCHAR  ply;
  char  str[300];
  int  s;
  if(flag.post)
    {
      ShowDepth(ch);
      ShowScore(score);
      s=0;
      ply=1;
      while(bstline[ply]>0)
        {
          algbr((int)bstline[ply]>>8,(int)bstline[ply] BAND 0xFF,FALSE);
          if(ply==5||ply==9||ply==13||ply==17)
            {
              s+=wsprintf(str+s,"\n");
            }
          s+=wsprintf(str+s,"%-5s ",(char*)mvstr[0]);
          ply++;
        }
      SetDlgItemText(hStats,BSTLINETEXT,(LPSTR)str);
    }
}


void SearchStartStuff (int side)
{
  UNREFERENCED_PARAMETER(side);
}


void OutputMove (HWND hWnd)
{
  char  tmp[30];
  UpdateDisplay(hWnd,root->f,root->t,0,(int)root->flags);
  wsprintf(tmp,"My move is %s",(char*)mvstr[0]);
  SetWindowText(hComputerMove,tmp);
  if(root->flags BAND draw)
    {
      SMessageBox(hWnd,IDS_DRAWGAME,IDS_CHESS);
    }
  else if(root->score==-9999)
    {
      SMessageBox(hWnd,IDS_YOUWIN,IDS_CHESS);
    }
  else if(root->score==9998)
    {
      SMessageBox(hWnd,IDS_COMPUTERWIN,IDS_CHESS);
    }
  else if(root->score<-9000)
    {
      SMessageBox(hWnd,IDS_MATESOON,IDS_CHESS);
    }
  else if(root->score>9000)
    {
      SMessageBox(hWnd,IDS_COMPMATE,IDS_CHESS);
    }
  if(flag.post)
    {
      ShowNodeCnt(NodeCnt,evrate);
    }
}


void UpdateClocks (void)
{
  int  m;
  int  s;
  char  tmp[20];
  m=(int)(et/60);
  s=(int)(et-60*(long)m);
  if(TCflag)
    {
      m=(int)((TimeControl.clock[player]-et)/60);
      s=(int)(TimeControl.clock[player]-et-60*(long)m);
    }
  if(m<0)
    {
      m=0;
    }
  if(s<0)
    {
      s=0;
    }
  wsprintf(tmp,"%0d:%02d",m,s);
  if(player==computer)
    {
      SetWindowText(hClockComputer,tmp);
    }
  else
    {
      SetWindowText(hClockHuman,tmp);
    }
  if(flag.post)
    {
      ShowNodeCnt(NodeCnt,evrate);
    }
}


void ShowPostnValue (int sq)
{
  UNREFERENCED_PARAMETER(sq);
}


void ShowPostnValues (void)
{
}


void DrawPiece (HWND hWnd, int f)
{
  POINT  aptl[4];
  HRGN  hRgn;
  int  x;
  int  y;
  if(flag.reverse)
    {
      x=7-(f % 8);
      y=7-(f/8);
    }
  else
    {
      x=f % 8;
      y=f/8;
    }
  QuerySqCoords(x,y,aptl+0);
  hRgn=CreatePolygonRgn(aptl,4,WINDING);
  InvalidateRgn(hWnd,hRgn,FALSE);
  DeleteObject(hRgn);
}


void UpdateDisplay (HWND hWnd, int f, int t, int redraw, int isspec)
{
  int  sq;
  sq=0;
  while(sq<64)
    {
      boarddraw[sq]=board[sq];
      colordraw[sq]=cColor[sq];
      sq++;
    }
  if(redraw)
    {
      InvalidateRect(hWnd,NULL,TRUE);
      ShowPlayers();
      UpdateWindow(hWnd);
    }
  else
    {
      DrawPiece(hWnd,f);
      DrawPiece(hWnd,t);
      if(isspec BAND cstlmask)
        {
          if(t>f)
            {
              DrawPiece(hWnd,f+3);
              DrawPiece(hWnd,t-1);
            }
          else
            {
              DrawPiece(hWnd,f-4);
              DrawPiece(hWnd,t+1);
            }
        }
      else if(isspec BAND epmask)
        {
          DrawPiece(hWnd,t-8);
          DrawPiece(hWnd,t+8);
        }
      UpdateWindow(hWnd);
    }
}


void GiveHint (HWND hWnd)
{
  char  s[40];
  algbr((int)(hint>>8),(int)(hint BAND 0xFF),FALSE);
  strcpy(s,"try ");
  strcat(s,mvstr[0]);
  ShowMessage(hWnd,s);
}


long CALLBACK NumberDlgDlgProc (HWND hDlg, UINT iMessage, UINT wParam, long lParam)
{
  int  temp;
  int  Ier;
  UNREFERENCED_PARAMETER(lParam);
  while(1)
  {
    if((iMessage)==WM_INITDIALOG)
      {
        SetDlgItemText(hDlg,IDD_CHAR,(LPSTR)NumberDlgChar);
        SetDlgItemInt(hDlg,IDD_INT,NumberDlgInt,TRUE);
        return TRUE;
      }
    if((iMessage)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDOK)
            {
              temp=GetDlgItemInt(hDlg,IDD_INT, &Ier,TRUE);
              if(Ier!=0)
                {
                  NumberDlgInt=temp;
                  EndDialog(hDlg,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDCANCEL)
            {
              EndDialog(hDlg,TRUE);
              break;
            }
            // case else
            {
              return FALSE;
            }
        }
      }
    break;
  }
  return FALSE;
}


int DoGetNumberDlg (HANDLE hInst, HWND hWnd, char* szPrompt, int def)
{
  FARPROC  lpfnNumberDlgProc;
  strcpy(NumberDlgChar,szPrompt);
  NumberDlgInt=def;
  lpfnNumberDlgProc=(FARPROC)MakeProcInstance(NumberDlgDlgProc,hInst);
  DialogBox(hInst,MAKEINTRESOURCE(NUMBERDLG),hWnd,(DLGPROC)(DLGPROC)lpfnNumberDlgProc);
  FreeProcInstance(lpfnNumberDlgProc);
  return NumberDlgInt;
}


void QuerySqCenter (int x, int y, POINT* pptl)
{
  POINT  aptl[4];
  QuerySqCoords(x,y,aptl);
  pptl->x=(aptl[0].x+aptl[1].x+aptl[2].x+aptl[3].x)/4;
  pptl->y=(aptl[0].y+aptl[2].y)/2;
}


void PieceOriginFromCenter (POINT* pptl)
{
  pptl->x-=PIECE_XAXIS/2;
  pptl->y-=PIECE_YAXIS/2;
}


void QuerySqPieceOrigin (int x, int y, POINT* pptl)
{
  QuerySqCenter(x,y,pptl);
  PieceOriginFromCenter(pptl);
}


void ShowPiece (HDC hDC, POINT* pptl, struct_PIECEBITMAP* Piece_bitmap, DWORD ccolor)
{
  HDC  hMemDC;
  HBRUSH  hBrush;
  HBRUSH  hOldBrush;
  HPEN  hOldPen;
  hOldBrush=SelectObject(hDC,GetStockObject(BLACK_BRUSH));
  hOldPen=SelectObject(hDC,GetStockObject(BLACK_PEN));
  hMemDC=CreateCompatibleDC(hDC);
  SelectObject(hMemDC,Piece_bitmap->mask);
  BitBlt(hDC,pptl->x,pptl->y,PIECE_XAXIS,PIECE_YAXIS,hMemDC,0,0,SRCAND);
  hBrush=CreateSolidBrush(ccolor);
  SelectObject(hDC,hBrush);
  SelectObject(hMemDC,Piece_bitmap->piece);
  BitBlt(hDC,pptl->x,pptl->y,PIECE_XAXIS,PIECE_YAXIS,hMemDC,0,0,0xB80746L);
  SelectObject(hDC,GetStockObject(BLACK_BRUSH));
  SelectObject(hMemDC,Piece_bitmap->outline);
  BitBlt(hDC,pptl->x,pptl->y,PIECE_XAXIS,PIECE_YAXIS,hMemDC,0,0,0xB80746L);
  SelectObject(hDC,hOldBrush);
  SelectObject(hDC,hOldPen);
  DeleteObject(hBrush);
  if(DeleteDC(hMemDC)==0)
    {
      MessageBeep(0);
    }
}


int ConvertCoordToIndex (int x, int y)
{
  return (y*8+x);
}


void DrawOnePiece (HDC hDC, int x, int y, struct_PIECEBITMAP* piece, DWORD ccolor)
{
  POINT  origin;
  QuerySqPieceOrigin(x,y, &origin);
  ShowPiece(hDC, &origin,piece,ccolor);
}


void DrawAllPieces (HDC hDC, int reverse, int* pbrd, int* ccolor, DWORD clrblack, DWORD clrwhite)
{
  int  x;
  int  y;
  int  i;
  y=0;
  while(y<8)
    {
      x=0;
      while(x<8)
        {
          i=ConvertCoordToIndex(x,y);
          if(*(ccolor+i)!=NETURAL)
            {
              if(reverse==0)
                {
 DrawOnePiece ( hDC , x , y , pieces + * ( pbrd + i ) , ( * ( ccolor + i ) == BLACK ) ? clrblack : clrwhite ) ;
                }
              else
                {
 DrawOnePiece ( hDC , 7 - x , 7 - y , pieces + * ( pbrd + i ) , ( * ( ccolor + i ) == BLACK ) ? clrblack : clrwhite ) ;
                }
            }
          x++;
        }
      y++;
    }
}


int PromoteDialog (HWND hWnd, HANDLE hInst)
{
  FARPROC  lpProcPromote;
  int  status;
  lpProcPromote=(FARPROC)MakeProcInstance(PromoteDlgProc,hInst);
  status=DialogBox(hInst,MAKEINTRESOURCE(PAWNPROMOTE),hWnd,(DLGPROC)lpProcPromote);
  FreeProcInstance(lpProcPromote);
  return status;
}


long CALLBACK PromoteDlgProc (HWND hDlg, UINT message, UINT wParam, long lParam)
{
  UNREFERENCED_PARAMETER(lParam);
  while(1)
  {
    if((message)==WM_INITDIALOG)
      {
        xstatus=5;
        CheckRadioButton(hDlg,100,103,103);
        return (TRUE);
      }
    if((message)==WM_SYSCOMMAND)
      {
        if((wParam BAND 0xfff0)==SC_CLOSE)
          {
            EndDialog(hDlg,xstatus);
            return xstatus;
          }
        break;
      }
    if((message)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDOK)
            {
              EndDialog(hDlg,xstatus);
              return TRUE;
            }
          if((LOWORD(wParam))==100||(LOWORD(wParam))==101||(LOWORD(wParam))==102||(LOWORD(wParam))==103)
            {
              xstatus=2+wParam-100;
              CheckRadioButton(hDlg,100,103,wParam);
            }
          break;
        }
      }
    break;
  }
  return (FALSE);
}


int ReviewDialog (HWND hWnd, HANDLE hInst)
{
  FARPROC  lpProcReview;
  int  status;
  lpProcReview=(FARPROC)MakeProcInstance(ReviewDlgProc,hInst);
  status=DialogBoxParam(hInst,MAKEINTRESOURCE(REVIEW),hWnd,(DLGPROC)lpProcReview,0);
  FreeProcInstance(lpProcReview);
  return status;
}


long CALLBACK ReviewDlgProc (HWND hDlg, UINT message, UINT wParam, long lParam)
{
  int  i;
  int  f;
  int  t;
  char  tmp[50];
  UNREFERENCED_PARAMETER(lParam);
  while(1)
  {
    if((message)==WM_INITDIALOG)
      {
        i=1;
        while(i<=GameCnt)
          {
            f=GameList[i].gmove>>8;
            t=(GameList[i].gmove BAND 0xFF);
            algbr(f,t,FALSE);
 wsprintf (tmp, "%4d-%c\t%5s\t%-5d\t%-2d\t%-5d", (i+1 ) /2, (i%2 ?'w':'b'), (char*) mvstr[0], GameList[i].score, GameList[i].depth, GameList[i].time);
            SendDlgItemMessage(hDlg,100,LB_ADDSTRING,0,(long)tmp);
            i++;
          }
        SendDlgItemMessage(hDlg,100,WM_SETREDRAW,TRUE,0);
        return (TRUE);
      }
    if((message)==WM_SYSCOMMAND)
      {
        if((wParam BAND 0xfff0)==SC_CLOSE)
          {
            EndDialog(hDlg,(int)NULL);
            return TRUE;
          }
        break;
      }
    if((message)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDOK)
            {
              EndDialog(hDlg,1);
              return TRUE;
            }
          break;
        }
      }
    break;
  }
  return (FALSE);
}


int DoFileOpenDlg (HANDLE hInst, HWND hWnd, char* szFileSpecIn, char* szDefExtIn, DWORD wFileAttrIn, char* szFileNameOut, POFSTRUCT pofIn)
{
  FARPROC  lpfnFileOpenProc;
  int  iReturn;
  strcpy(szFileSpec,szFileSpecIn);
  strcpy(szDefExt,szDefExtIn);
  wFileAttr=wFileAttrIn;
  pof=pofIn;
  lpfnFileOpenProc=(FARPROC)MakeProcInstance(FileOpenDlgProc,hInst);
  iReturn=DialogBox(hInst,MAKEINTRESOURCE(FILEOPEN),hWnd,(DLGPROC)lpfnFileOpenProc);
  FreeProcInstance(lpfnFileOpenProc);
  strcpy(szFileNameOut,szFileName);
  return iReturn;
}


int DoWildFileOpenDlg (HANDLE hInst, HWND hWnd, char* szFileSpecIn, char* szDefExtIn, DWORD wFileAttrIn, char* szFileNameOut, POFSTRUCT pofIn)
{
  FARPROC  lpfnFileOpenProc;
  int  iReturn;
  strcpy(szFileSpec,szFileSpecIn);
  strcpy(szDefExt,szDefExtIn);
  wFileAttr=wFileAttrIn;
  pof=pofIn;
  lpfnFileOpenProc=(FARPROC)MakeProcInstance(WildFileOpenDlgProc,hInst);
  iReturn=DialogBox(hInst,MAKEINTRESOURCE(WILDFILEOPEN),hWnd,(DLGPROC)lpfnFileOpenProc);
  FreeProcInstance(lpfnFileOpenProc);
  strcpy(szFileNameOut,szFileName);
  return iReturn;
}


int DoFileSaveDlg (HANDLE hInst, HWND hWnd, char* szFileSpecIn, char* szDefExtIn, DWORD* pwStatusOut, char* szFileNameOut, POFSTRUCT pofIn)
{
  FARPROC  lpfnFileSaveProc;
  int  iReturn;
  strcpy(szFileSpec,szFileSpecIn);
  strcpy(szDefExt,szDefExtIn);
  pof=pofIn;
  lpfnFileSaveProc=(FARPROC)MakeProcInstance(FileSaveDlgProc,hInst);
  iReturn=DialogBox(hInst,MAKEINTRESOURCE(FILESAVE),hWnd,(DLGPROC)lpfnFileSaveProc);
  FreeProcInstance(lpfnFileSaveProc);
  strcpy(szFileNameOut,szFileName);
  *pwStatusOut=wStatus;
  return iReturn;
}


long CALLBACK FileOpenDlgProc (HWND hDlg, UINT iMessage, UINT wParam, long lParam)
{
  char  cLastChar;
  int  nEditLen;
  while(1)
  {
    if((iMessage)==WM_INITDIALOG)
      {
        SendDlgItemMessage(hDlg,IDD_FNAME,EM_LIMITTEXT,80,0L);
        DlgDirList(hDlg,szFileSpec,IDD_FLIST,IDD_FPATH,wFileAttr);
        DlgDirList(hDlg,szFileSpec,IDD_DLIST,(int)NULL,0x4010|0x8000);
        SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
        return TRUE;
      }
    if((iMessage)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDD_FLIST)
            {
              while(1)
              {
                if((HIWORD(wParam))==LBN_SELCHANGE)
                  {
                    if(DlgDirSelectEx(hDlg,szFileName,sizeof(szFileName),IDD_FLIST))
                      {
                        strcat(szFileName,szFileSpec);
                      }
                    SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                    break;
                  }
                if((HIWORD(wParam))==LBN_DBLCLK)
                  {
                    if(DlgDirSelectEx(hDlg,szFileName,sizeof(szFileName),IDD_FLIST))
                      {
                        strcat(szFileName,szFileSpec);
                        DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr);
                        SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                      }
                    else
                      {
                        SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                        SendMessage(hDlg,(UINT)WM_COMMAND,(WPARAM)IDOK,(LPARAM)0L);
                      }
                  }
                break;
              }
              break;
            }
          if((LOWORD(wParam))==IDD_DLIST)
            {
              while(1)
              {
                if((HIWORD(wParam))==LBN_DBLCLK)
                  {
                    if(DlgDirSelectEx(hDlg,szFileName,sizeof(szFileName),IDD_DLIST))
                      {
                        strcat(szFileName,szFileSpec);
                        DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr);
                        DlgDirList(hDlg,szFileName,IDD_DLIST,(int)NULL,0x4010|0x8000);
                        SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                      }
                  }
                break;
              }
              break;
            }
          if((LOWORD(wParam))==IDD_FNAME)
            {
              if(HIWORD(wParam)==EN_CHANGE)
                {
                  EnableWindow(GetDlgItem(hDlg,IDOK),(BOOL)SendMessage((HWND)lParam,(UINT)WM_GETTEXTLENGTH,(WPARAM)0,(LPARAM)0L));
                }
              break;
            }
          if((LOWORD(wParam))==IDOK)
            {
              GetDlgItemText(hDlg,IDD_FNAME,szFileName,80);
              nEditLen=strlen(szFileName);
              cLastChar=*AnsiPrev(szFileName,szFileName+nEditLen);
              if(cLastChar==92||cLastChar==58)
                {
                  strcat(szFileName,szFileSpec);
                }
              if(strchr(szFileName,42)||strchr(szFileName,63))
                {
                  if(DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr))
                    {
                      strcpy(szFileSpec,szFileName);
                      SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
                    }
                  else
                    {
                      MessageBeep(0);
                      break;
                    }
                }
              strcat(strcat(szFileName,"\\"),szFileSpec);
              if(DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr))
                {
                  strcpy(szFileSpec,szFileName);
                  SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
                  break;
                }
              szFileName[nEditLen]=0;
              if(OpenFile(szFileName,pof,OF_READ|OF_EXIST)==-1)
                {
                  strcat(szFileName,szDefExt);
                  if(OpenFile(szFileName,pof,OF_READ|OF_EXIST)==-1)
                    {
                      MessageBeep(0);
                      break;
                    }
                }
              strcpy(szFileName,(PSTR)AnsiNext(strrchr(pof->szPathName,92)));
              OemToAnsi(szFileName,szFileName);
              EndDialog(hDlg,TRUE);
              break;
            }
          if((LOWORD(wParam))==IDCANCEL)
            {
              EndDialog(hDlg,FALSE);
              break;
            }
            // case else
            {
              return FALSE;
            }
        }
        break;
      }
      // case else
      {
        return FALSE;
      }
  }
  return TRUE;
}


long CALLBACK WildFileOpenDlgProc (HWND hDlg, UINT iMessage, UINT wParam, long lParam)
{
  char  cLastChar;
  int  nEditLen;
  while(1)
  {
    if((iMessage)==WM_INITDIALOG)
      {
        SendDlgItemMessage(hDlg,IDD_FNAME,EM_LIMITTEXT,80,0L);
        DlgDirList(hDlg,szFileSpec,IDD_FLIST,IDD_FPATH,wFileAttr);
        DlgDirList(hDlg,szFileSpec,IDD_DLIST,(int)NULL,0x4010|0x8000);
        SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
        return TRUE;
      }
    if((iMessage)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDD_FLIST)
            {
              while(1)
              {
                if((HIWORD(wParam))==LBN_SELCHANGE)
                  {
                    if(DlgDirSelectEx(hDlg,szFileName,sizeof(szFileName),IDD_FLIST))
                      {
                        strcat(szFileName,szFileSpec);
                      }
                    SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                    break;
                  }
                if((HIWORD(wParam))==LBN_DBLCLK)
                  {
                    if(DlgDirSelectEx(hDlg,szFileName,sizeof(szFileName),IDD_FLIST))
                      {
                        strcat(szFileName,szFileSpec);
                        DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr);
                        SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                      }
                    else
                      {
                        SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                        SendMessage(hDlg,(UINT)WM_COMMAND,(WPARAM)IDOK,(LPARAM)0L);
                      }
                  }
                break;
              }
              break;
            }
          if((LOWORD(wParam))==IDD_DLIST)
            {
              while(1)
              {
                if((HIWORD(wParam))==LBN_DBLCLK)
                  {
                    if(DlgDirSelectEx(hDlg,szFileName,sizeof(szFileName),IDD_DLIST))
                      {
                        strcat(szFileName,szFileSpec);
                        DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr);
                        DlgDirList(hDlg,szFileName,IDD_DLIST,(int)NULL,0x4010|0x8000);
                        SetDlgItemText(hDlg,IDD_FNAME,szFileName);
                      }
                  }
                break;
              }
              break;
            }
          if((LOWORD(wParam))==IDD_FNAME)
            {
              if(HIWORD(wParam)==EN_CHANGE)
                {
                  EnableWindow(GetDlgItem(hDlg,IDOK),(BOOL)SendMessage((HWND)lParam,(UINT)WM_GETTEXTLENGTH,(WPARAM)0,(LPARAM)0L));
                }
              break;
            }
          if((LOWORD(wParam))==IDD_BROWSE)
            {
              GetDlgItemText(hDlg,IDD_FNAME,szFileName,80);
              nEditLen=strlen(szFileName);
              cLastChar=*AnsiPrev(szFileName,szFileName+nEditLen);
              if(cLastChar==92||cLastChar==58)
                {
                  strcat(szFileName,szFileSpec);
                }
              if(strchr(szFileName,42)||strchr(szFileName,63))
                {
                  if(DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr))
                    {
                      strcpy(szFileSpec,szFileName);
                      SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
                    }
                  else
                    {
                      MessageBeep(0);
                      break;
                    }
                }
              strcat(strcat(szFileName,"\\"),szFileSpec);
              if(DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr))
                {
                  strcpy(szFileSpec,szFileName);
                  SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
                  break;
                }
              szFileName[nEditLen]=0;
              if(OpenFile(szFileName,pof,OF_READ|OF_EXIST)==-1)
                {
                  strcat(szFileName,szDefExt);
                  if(OpenFile(szFileName,pof,OF_READ|OF_EXIST)==-1)
                    {
                      MessageBeep(0);
                      break;
                    }
                }
              break;
            }
          if((LOWORD(wParam))==IDOK)
            {
              GetDlgItemText(hDlg,IDD_FNAME,szFileName,80);
              nEditLen=strlen(szFileName);
              cLastChar=*AnsiPrev(szFileName,szFileName+nEditLen);
              if(cLastChar==92||cLastChar==58)
                {
                  strcat(szFileName,szFileSpec);
                }
              if(strchr(szFileName,42)||strchr(szFileName,63))
                {
                  if(DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr))
                    {
                      OemToAnsi(szFileName,szFileName);
                      EndDialog(hDlg,TRUE);
                    }
                  else
                    {
                      MessageBeep(0);
                      break;
                    }
                }
              strcat(strcat(szFileName,"\\"),szFileSpec);
              if(DlgDirList(hDlg,szFileName,IDD_FLIST,IDD_FPATH,wFileAttr))
                {
                  strcpy(szFileSpec,szFileName);
                  SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
                  break;
                }
              szFileName[nEditLen]=0;
              if(OpenFile(szFileName,pof,OF_READ|OF_EXIST)==-1)
                {
                  strcat(szFileName,szDefExt);
                  if(OpenFile(szFileName,pof,OF_READ|OF_EXIST)==-1)
                    {
                      MessageBeep(0);
                      break;
                    }
                }
              strcpy(szFileName,(PSTR)AnsiNext(strrchr(pof->szPathName,92)));
              OemToAnsi(szFileName,szFileName);
              EndDialog(hDlg,TRUE);
              break;
            }
          if((LOWORD(wParam))==IDCANCEL)
            {
              EndDialog(hDlg,FALSE);
              break;
            }
            // case else
            {
              return FALSE;
            }
        }
        break;
      }
      // case else
      {
        return FALSE;
      }
  }
  return TRUE;
}


long CALLBACK FileSaveDlgProc (HWND hDlg, UINT iMessage, UINT wParam, long lParam)
{
  while(1)
  {
    if((iMessage)==WM_INITDIALOG)
      {
        SendDlgItemMessage(hDlg,IDD_FNAME,EM_LIMITTEXT,80,0L);
        DlgDirList(hDlg,szFileSpec,0,IDD_FPATH,0);
        SetDlgItemText(hDlg,IDD_FNAME,szFileSpec);
        return TRUE;
      }
    if((iMessage)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDD_FNAME)
            {
              if(HIWORD(wParam)==EN_CHANGE)
                {
                  EnableWindow(GetDlgItem(hDlg,IDOK),(BOOL)SendMessage((HWND)lParam,(UINT)WM_GETTEXTLENGTH,(WPARAM)0,(LPARAM)0L));
                }
              break;
            }
          if((LOWORD(wParam))==IDOK)
            {
              GetDlgItemText(hDlg,IDD_FNAME,szFileName,80);
              if(OpenFile(szFileName,pof,OF_PARSE)==-1)
                {
                  MessageBeep(0);
                  break;
                }
              if(!strchr((PSTR)AnsiNext(strrchr(pof->szPathName,92)),46))
                {
                  strcat(szFileName,szDefExt);
                }
              if(OpenFile(szFileName,pof,OF_WRITE|OF_EXIST)!=-1)
                {
                  wStatus=1;
                }
              else if(OpenFile(szFileName,pof,OF_CREATE|OF_EXIST)!=-1)
                {
                  wStatus=0;
                }
              else
                {
                  MessageBeep(0);
                  break;
                }
              strcpy(szFileName,(PSTR)AnsiNext(strrchr(pof->szPathName,92)));
              OemToAnsi(szFileName,szFileName);
              EndDialog(hDlg,TRUE);
              break;
            }
          if((LOWORD(wParam))==IDCANCEL)
            {
              EndDialog(hDlg,FALSE);
              break;
            }
            // case else
            {
              return FALSE;
            }
        }
        break;
      }
      // case else
      {
        return FALSE;
      }
  }
  return TRUE;
}


void pick (int p1, int p2)
{
  int  p;
  int  s;
  int  p0;
  int  s0;
  struct leaf temp;
  s0=Tree[p1].score;
  p0=p1;
  p=p1+1;
  while(p<=p2)
    {
      s=Tree[p].score;
      if(s>s0)
        {
          s0=s;
          p0=p;
        }
      p++;
    }
  if(p0!=p1)
    {
      temp=Tree[p1];
      Tree[p1]=Tree[p0];
      Tree[p0]=temp;
    }
}


void SelectMove (HWND hWnd, int side, int iop)
{
  static  int  i;
  static  int  tempb;
  static  int  tempc;
  static  int  tempsf;
  static  int  tempst;
  static  int  xside;
  static  int  rpt;
  static  int  alpha;
  static  int  beta;
  static  int  score;
  flag.timeout=FALSE;
  xside=otherside[side];
  if(iop!=2)
    {
      player=side;
    }
  if(TCflag)
    {
      if((TimeControl.moves[side]+3)!=0)
        {
          ResponseTime=(TimeControl.clock[side])/(TimeControl.moves[side]+3)-OperatorTime;
        }
      else
        {
          ResponseTime=0;
        }
      ResponseTime+=(ResponseTime*TimeControl.moves[side])/(2*TCmoves+1);
    }
  else
    {
      ResponseTime=Level;
    }
  if(iop==2)
    {
      ResponseTime=99999;
    }
  if(Sdepth>0&&root->score>Zscore-zwndw)
    {
      ResponseTime-=ft;
    }
  else if(ResponseTime<1)
    {
      ResponseTime=1;
    }
  ExtraTime=0;
  ExaminePosition();
  ScorePosition(side, &score);
  ShowSidetoMove();
  if(Sdepth==0)
    {
      SearchStartStuff(side);
      memset(history,0,8192*sizeof(char));
      FROMsquare=TOsquare=-1;
      PV=0;
      if(iop!=2)
        {
          hint=0;
        }
      i=0;
      while(i<maxdepth)
        {
          PrVar[i]=killr0[i]=killr1[i]=killr2[i]=killr3[i]=0;
          i++;
        }
      alpha=score-90;
      beta=score+90;
      rpt=0;
      TrPnt[1]=0;
      root= &Tree[0];
      MoveList(side,1);
      i=TrPnt[1];
      while(i<TrPnt[2])
        {
          pick(i,TrPnt[2]-1);
          i++;
        }
      if(Book!=NULL)
        {
          OpeningBook( &hint);
        }
      if(Book!=NULL)
        {
          flag.timeout=TRUE;
        }
      NodeCnt=ETnodes=EvalNodes=HashCnt=FHashCnt=HashCol=0;
      Zscore=0;
      zwndw=20;
    }
  while(!flag.timeout&&Sdepth<MaxSearchDepth)
    {
      Sdepth++;
      ShowDepth(32);
      score=search(side,1,Sdepth,alpha,beta,PrVar, &rpt);
      i=1;
      while(i<=Sdepth)
        {
          killr0[i]=PrVar[i];
          i++;
        }
      if(score<alpha)
        {
          ShowDepth(45);
          ExtraTime=10*ResponseTime;
          score=search(side,1,Sdepth,-9000,score,PrVar, &rpt);
        }
      if(score>beta&&!(root->flags BAND exact))
        {
          ShowDepth(43);
          ExtraTime=0;
          score=search(side,1,Sdepth,score,9000,PrVar, &rpt);
        }
      score=root->score;
      if(!flag.timeout)
        {
          i=TrPnt[1]+1;
          while(i<TrPnt[2])
            {
              pick(i,TrPnt[2]-1);
              i++;
            }
        }
      ShowResults(score,PrVar,46);
      i=1;
      while(i<=Sdepth)
        {
          killr0[i]=PrVar[i];
          i++;
        }
      if(score>Zscore-zwndw&&score>Tree[1].score+250)
        {
          ExtraTime=0;
        }
      else if(score>Zscore-3*zwndw)
        {
          ExtraTime=ResponseTime;
        }
      else
        {
          ExtraTime=3*ResponseTime;
        }
      if(root->flags BAND exact)
        {
          flag.timeout=TRUE;
        }
      if(Tree[1].score<-9000)
        {
          flag.timeout=TRUE;
        }
      if(4*et>2*ResponseTime+ExtraTime)
        {
          flag.timeout=TRUE;
        }
      if(!flag.timeout)
        {
          Tscore[0]=score;
          if(Zscore==0)
            {
              Zscore=score;
            }
          else
            {
              Zscore=(Zscore+score)/2;
            }
        }
      zwndw=20+Abs(Zscore/12);
      beta=score+Bwindow;
      if(Zscore<score)
        {
          alpha=Zscore-Awindow-zwndw;
        }
      else
        {
          alpha=score-Awindow-zwndw;
        }
    }
  score=root->score;
  if(rpt>=2||score<-12000)
    {
      root->flags|=draw;
    }
  if(iop==2)
    {
      return;
    }
  if(Book==NULL)
    {
      hint=PrVar[2];
    }
  ElapsedTime(1);
  if(score>-9999&&rpt<=2)
    {
      MakeMove(side,root, &tempb, &tempc, &tempsf, &tempst, &INCscore);
      algbr(root->f,root->t,(int)root->flags);
    }
  else
    {
      algbr(0,0,0);
    }
  OutputMove(hWnd);
  if(score==-9999||score==9998)
    {
      flag.mate=TRUE;
    }
  if(flag.mate)
    {
      hint=0;
    }
  if((board[root->t]==pawn)||(root->flags BAND capture)||(root->flags BAND cstlmask))
    {
      Game50=GameCnt;
      ZeroRPT();
    }
  GameList[GameCnt].score=score;
  GameList[GameCnt].nodes=NodeCnt;
  GameList[GameCnt].time=(int)et;
  GameList[GameCnt].depth=Sdepth;
  if(TCflag)
    {
      TimeControl.clock[side]-=(et+OperatorTime);
      if(--TimeControl.moves[side]==0)
        {
          SetTimeControl();
        }
    }
  if((root->flags BAND draw)&&flag.bothsides)
    {
      flag.mate=TRUE;
    }
  if(GameCnt>470)
    {
      flag.mate=TRUE;
    }
  player=xside;
  Sdepth=0;
}


int search (int side, int ply, int depth, int alpha, int beta, UINT* bstline, int* rpt)
{
  int  j;
  int  pnt;
  int  best;
  int  tempb;
  int  tempc;
  int  tempsf;
  int  tempst;
  int  xside;
  int  pbst;
  int  d;
  int  e;
  int  cf;
  int  score;
  int  rcnt;
  int  slk;
  int  InChk;
  UINT  mv;
  UINT  nxtline[maxdepth];
  struct_leaf*  node;
  struct_leaf  tmp;
  NodeCnt++;
  xside=otherside[side];
  if((ply<=Sdepth+3)&&rpthash[side][hashkey BAND 0xFF]>0)
    {
      repetition(rpt);
    }
  else
    {
      *rpt=0;
    }
  if(*rpt==1&&ply>1)
    {
      return (0);
    }
  score=evaluate(side,ply,alpha,beta,INCscore, &slk, &InChk);
  if(score>9000)
    {
      bstline[ply]=0;
      return (score);
    }
  if(depth>0)
    {
      if(InChk)
        {
 depth = ( depth < 2 ) ? 2 : depth ;
        }
      else if(PawnThreat[ply-1]||ReCapture)
        {
          ++depth;
        }
    }
  else
    {
      if(score>=alpha&&(InChk||PawnThreat[ply-1]||Parry))
        {
          depth=1;
        }
      else if(score<=beta&&MateThreat)
        {
          depth=1;
        }
    }
  if(depth>0&&flag.hash&&ply>1)
    {
      if(ProbeTTable(side,depth, &alpha, &beta, &score)==FALSE)
        {
          bstline[ply]=PV;
        }
      bstline[ply+1]=0;
      if(beta==-20000)
        {
          return (score);
        }
      if(alpha>beta)
        {
          return (alpha);
        }
    }
  if(Sdepth==1)
    {
      d=7;
    }
  else
    {
      d=11;
    }
  if(ply>Sdepth+d||(depth<1&&score>beta))
    {
      return (score);
    }
  if(ply>1)
    {
      if(depth>0)
        {
          MoveList(side,ply);
        }
      else
        {
          CaptureList(side,ply);
        }
    }
  if((TrPnt[ply]==TrPnt[ply+1]))
    {
      return (score);
    }
  cf = (depth < 1 && ply > Sdepth + 1 && !ChkFlag[ply - 2] && !slk);
  if(depth>0)
    {
      best=-12000;
    }
  else
    {
      best=score;
    }
  if(best>alpha)
    {
      alpha=best;
    }
  pnt=pbst=TrPnt[ply];
  while(pnt<TrPnt[ply+1]&&best<=beta)
    {
      MSG  msg;
      if(!flag.timeout&&PeekMessage( &msg,NULL,(UINT)NULL,(UINT)NULL,PM_REMOVE))
        {
          TranslateMessage( &msg);
          DispatchMessage( &msg);
        }
      if(Running==FALSE)
        {
          fflush(stdout);
          ExitProcess(0);
        }
      if(ply>1)
        {
          pick(pnt,TrPnt[ply+1]-1);
        }
      node= &Tree[pnt];
      mv=(node->f<<8) BOR node->t;
      nxtline[ply+1]=0;
      if(prune)
        {
          break;
        }
      if(ply==1)
        {
          UpdateSearchStatus;
        }
      if(!(node->flags BAND exact))
        {
          MakeMove(side,node, &tempb, &tempc, &tempsf, &tempst, &INCscore);
          CptrFlag[ply]=(node->flags BAND capture);
          PawnThreat[ply]=(node->flags BAND pwnthrt);
          Tscore[ply]=node->score;
          PV=node->reply;
 node->score = -search (xside, ply + 1, (depth > 0 ) ? depth - 1 : 0, -beta, -alpha, nxtline, &rcnt ) ;
          if(Abs(node->score)>9000)
            {
              node->flags|=exact;
            }
          else if(rcnt==1)
            {
              node->score/=2;
            }
          if(rcnt>=2||GameCnt-Game50>99||(node->score==9999-ply&&!ChkFlag[ply]))
            {
              node->flags|=draw;
              node->flags|=exact;
              if(side==computer)
                {
                  node->score=contempt;
                }
              else
                {
                  node->score=-contempt;
                }
            }
          node->reply=nxtline[ply+1];
          UnmakeMove(side,node, &tempb, &tempc, &tempsf, &tempst);
        }
      if(node->score>best&&!flag.timeout)
        {
          if(depth>0)
            {
              if(node->score>alpha&&!(node->flags BAND exact))
                {
                  node->score+=depth;
                }
            }
          best=node->score;
          pbst=pnt;
          if(best>alpha)
            {
              alpha=best;
            }
          j=ply+1;
          while(nxtline[j]>0)
            {
              bstline[j]=nxtline[j];
              j++;
            }
          bstline[j]=0;
          bstline[ply]=mv;
          if(ply==1)
            {
              if(best>root->score)
                {
                  tmp=Tree[pnt];
                  j=pnt-1;
                  while(j>=0)
                    {
                      Tree[j+1]=Tree[j];
                      j--;
                    }
                  Tree[0]=tmp;
                  pbst=0;
                }
              if(Sdepth>2)
                {
                  if(best>beta)
                    {
                      ShowResults(best,bstline,43);
                    }
                  else if(best<alpha)
                    {
                      ShowResults(best,bstline,45);
                    }
                  else
                    {
                      ShowResults(best,bstline,38);
                    }
                }
            }
        }
      if(NodeCnt>ETnodes)
        {
          ElapsedTime(0);
        }
      if(flag.timeout)
        {
          return (-Tscore[ply-1]);
        }
      pnt++;
    }
  node= &Tree[pbst];
  mv=(node->f<<8) BOR node->t;
  if(flag.hash&&ply<=Sdepth&&*rpt==0&&best==alpha)
    {
      PutInTTable(side,best,depth,alpha,beta,mv);
    }
  if(depth>0)
    {
      j=(node->f<<6) BOR node->t;
      if(side==black)
        {
          j|=0x1000;
        }
      if(*(history+j)<150)
        {
          *(history+j)+=(UCHAR)2*depth;
        }
      if(node->t!=(int)(GameList[GameCnt].gmove BAND 0xFF))
        {
          if(best<=beta)
            {
              killr3[ply]=mv;
            }
          else if(mv!=killr1[ply])
            {
              killr2[ply]=killr1[ply];
              killr1[ply]=mv;
            }
        }
      if(best>9000)
        {
          killr0[ply]=mv;
        }
      else
        {
          killr0[ply]=0;
        }
    }
  return (best);
}


int ProbeTTable (int side, int depth, int* alpha, int* beta, int* score)
{
  struct_hashentry*  ptbl;
  UINT  i;
  ptbl=ttable+side*2+(hashkey BAND (ttblsz-1));
  i=1;
  while((ptbl->hashbd==hashbd)&&((INT)i<=rehash))
    {
      ptbl=ttable+side*2+((hashkey+i)&(ttblsz-1));
      i++;
    }
  if((int)ptbl->depth>=depth&&ptbl->hashbd==hashbd)
    {
      HashCnt++;
      PV=ptbl->mv;
      if(ptbl->flags BAND truescore)
        {
          *score=ptbl->score;
          *beta=-20000;
        }
      else if(ptbl->flags BAND lowerbound)
        {
          if(ptbl->score>*alpha)
            {
              *alpha=ptbl->score-1;
            }
        }
      return (TRUE);
    }
  return (FALSE);
}


void PutInTTable (int side, int score, int depth, int alpha, int beta, UINT mv)
{
  struct_hashentry*  ptbl;
  UINT  i;
  ptbl=ttable+side*2+(hashkey BAND (ttblsz-1));
  i=1;
  while((depth<(INT)ptbl->depth)&&(ptbl->hashbd==hashbd)&&((INT)i<=rehash))
    {
      ptbl=ttable+side*2+((hashkey+i)&(ttblsz-1));
      i++;
    }
  if((depth>=(int)ptbl->depth)||(ptbl->hashbd!=hashbd))
    {
      ptbl->hashbd=hashbd;
      ptbl->depth=(UCHAR)depth;
      ptbl->score=score;
      ptbl->mv=mv;
      ptbl->flags=0;
      if(score<alpha)
        {
          ptbl->flags|=upperbound;
        }
      else if(score>beta)
        {
          ptbl->flags|=lowerbound;
        }
      else
        {
          ptbl->flags|=truescore;
        }
    }
}


void ZeroTTable (void)
{
  int  side;
  int  i;
  if(flag.hash)
    {
      side=white;
      while(side<=black)
        {
          i=0;
          while(i<ttblsz)
            {
              (ttable+side*2+i)->depth=0;
              i++;
            }
          side++;
        }
    }
}


void ZeroRPT (void)
{
  int  side;
  int  i;
  side=white;
  while(side<=black)
    {
      i=0;
      while(i<256)
        {
          rpthash[side][i]=0;
          i++;
        }
      side++;
    }
}


void LinkMove (int ply, int f, int t, int flag, int xside)
{
  int  s;
  int  z;
  UINT  mv;
  struct_leaf*  node;
  node= &Tree[TrPnt[ply+1]];
  mv=(f<<8) BOR t;
  s=0;
  if(mv==Swag0)
    {
      s=2000;
    }
  else if(mv==Swag1)
    {
      s=60;
    }
  else if(mv==Swag2)
    {
      s=50;
    }
  else if(mv==Swag3)
    {
      s=40;
    }
  else if(mv==Swag4)
    {
      s=30;
    }
  z=(f<<6) BOR t;
  if(xside==white)
    {
      z|=0x1000;
    }
  s+=*(history+z);
  if(cColor[t]!=neutral)
    {
      if(t==TOsquare)
        {
          s+=500;
        }
      s+=value[board[t]]-board[f];
    }
  if(board[f]==pawn)
    {
      if(row(t)==0||row(t)==7)
        {
          flag|=promote;
          s+=800;
          Link(f,t,flag BOR queen,s-20000);
          s-=200;
          Link(f,t,flag BOR knight,s-20000);
          s-=50;
          Link(f,t,flag BOR rook,s-20000);
          flag|=bishop;
          s-=50;
        }
      else if(row(t)==1||row(t)==6)
        {
          flag|=pwnthrt;
          s+=600;
        }
    }
  Link(f,t,flag,s-20000);
}


void GenMoves (int ply, int sq, int side, int xside)
{
  int  u;
  int  piece;
  UCHAR*  ppos;
  UCHAR*  pdir;
  piece=board[sq];
  ppos=nextpos+ptype[side][piece]*64*64+sq*64;
  pdir=nextdir+ptype[side][piece]*64*64+sq*64;
  if(piece==pawn)
    {
      u=ppos[sq];
      if(cColor[u]==neutral)
        {
          LinkMove(ply,sq,u,0,xside);
          u=ppos[u];
          if(cColor[u]==neutral)
            {
              LinkMove(ply,sq,u,0,xside);
            }
        }
      u=pdir[sq];
      if(cColor[u]==xside)
        {
          LinkMove(ply,sq,u,capture,xside);
        }
      else if(u==epsquare)
        {
          LinkMove(ply,sq,u,capture BOR epmask,xside);
        }
      u=pdir[u];
      if(cColor[u]==xside)
        {
          LinkMove(ply,sq,u,capture,xside);
        }
      else if(u==epsquare)
        {
          LinkMove(ply,sq,u,capture BOR epmask,xside);
        }
    }
  else
    {
      u=ppos[sq];
      while(1)
        {
          if(cColor[u]==neutral)
            {
              LinkMove(ply,sq,u,0,xside);
              u=ppos[u];
            }
          else
            {
              if(cColor[u]==xside)
                {
                  LinkMove(ply,sq,u,capture,xside);
                }
              u=pdir[u];
            }
          if(!(u!=sq))
            {
              break;
            }
        }
    }
}


void MoveList (int side, int ply)
{
  int  i;
  int  xside;
  int  f;
  xside=otherside[side];
  TrPnt[ply+1]=TrPnt[ply];
  if(PV==0)
    {
      Swag0=killr0[ply];
    }
  else
    {
      Swag0=PV;
    }
  Swag1=killr1[ply];
  Swag2=killr2[ply];
  Swag3=killr3[ply];
  if(ply>2)
    {
      Swag4=killr1[ply-2];
    }
  else
    {
      Swag4=0;
    }
  i=PieceCnt[side];
  while(i>=0)
    {
      GenMoves(ply,PieceList[side][i],side,xside);
      i--;
    }
  if(!castld[side])
    {
      f=PieceList[side][0];
      if(castle(side,f,f+2,0))
        {
          LinkMove(ply,f,f+2,cstlmask,xside);
        }
      if(castle(side,f,f-2,0))
        {
          LinkMove(ply,f,f-2,cstlmask,xside);
        }
    }
}


void CaptureList (int side, int ply)
{
  int  u;
  int  sq;
  int  xside;
  struct_leaf*  node;
  UCHAR*  ppos;
  UCHAR*  pdir;
  int  i;
  int  piece;
  int*  PL;
  int  r7;
  xside=otherside[side];
  TrPnt[ply+1]=TrPnt[ply];
  node= &Tree[TrPnt[ply]];
  r7=rank7[side];
  PL=PieceList[side];
  i=0;
  while(i<=PieceCnt[side])
    {
      sq=PL[i];
      piece=board[sq];
      if(sweep[piece])
        {
          ppos=nextpos+piece*64*64+sq*64;
          pdir=nextdir+piece*64*64+sq*64;
          u=ppos[sq];
          while(1)
            {
              if(cColor[u]==neutral)
                {
                  u=ppos[u];
                }
              else
                {
                  if(cColor[u]==xside)
                    {
                      Link(sq,u,capture,value[board[u]]+svalue[board[u]]-piece);
                    }
                  u=pdir[u];
                }
              if(!(u!=sq))
                {
                  break;
                }
            }
        }
      else
        {
          pdir=nextdir+ptype[side][piece]*64*64+sq*64;
          if(piece==pawn&&row(sq)==r7)
            {
              u=pdir[sq];
              if(cColor[u]==xside)
                {
                  Link(sq,u,capture BOR promote BOR queen,valueQ);
                }
              u=pdir[u];
              if(cColor[u]==xside)
                {
                  Link(sq,u,capture BOR promote BOR queen,valueQ);
                }
              ppos=nextpos+ptype[side][piece]*64*64+sq*64;
              u=ppos[sq];
              if(cColor[u]==neutral)
                {
                  Link(sq,u,promote BOR queen,valueQ);
                }
            }
          else
            {
              u=pdir[sq];
              while(1)
                {
                  if(cColor[u]==xside)
                    {
                      Link(sq,u,capture,value[board[u]]+svalue[board[u]]-piece);
                    }
                  u=pdir[u];
                  if(!(u!=sq))
                    {
                      break;
                    }
                }
            }
        }
      i++;
    }
}


int castle (int side, int kf, int kt, int iop)
{
  int  rf;
  int  rt;
  int  t0;
  int  xside;
  xside=otherside[side];
  if(kt>kf)
    {
      rf=kf+3;
      rt=kt-1;
    }
  else
    {
      rf=kf-4;
      rt=kt+1;
    }
  if(iop==0)
    {
      if(kf!=kingP[side]||board[kf]!=king||board[rf]!=rook||Mvboard[kf]!=0||Mvboard[rf]!=0||cColor[kt]!=neutral||cColor[rt]!=neutral||cColor[kt-1]!=neutral||SqAtakd(kf,xside)||SqAtakd(kt,xside)||SqAtakd(rt,xside))
        {
          return (FALSE);
        }
    }
  else
    {
      if(iop==1)
        {
          castld[side]=TRUE;
          Mvboard[kf]++;
          Mvboard[rf]++;
        }
      else
        {
          castld[side]=FALSE;
          Mvboard[kf]--;
          Mvboard[rf]--;
          t0=kt;
          kt=kf;
          kf=t0;
          t0=rt;
          rt=rf;
          rf=t0;
        }
      board[kt]=king;
      cColor[kt]=side;
      Pindex[kt]=0;
      board[kf]=no_piece;
      cColor[kf]=neutral;
      board[rt]=rook;
      cColor[rt]=side;
      Pindex[rt]=Pindex[rf];
      board[rf]=no_piece;
      cColor[rf]=neutral;
      PieceList[side][Pindex[kt]]=kt;
      PieceList[side][Pindex[rt]]=rt;
      UpdateHashbd(side,king,kf,kt);
      UpdateHashbd(side,rook,rf,rt);
    }
  return (TRUE);
}


void EnPassant (int xside, int f, int t, int iop)
{
  int  l;
  if(t>f)
    {
      l=t-8;
    }
  else
    {
      l=t+8;
    }
  if(iop==1)
    {
      board[l]=no_piece;
      cColor[l]=neutral;
    }
  else
    {
      board[l]=pawn;
      cColor[l]=xside;
    }
  InitializeStats();
}


void UpdatePieceList (int side, int sq, int iop)
{
  int  i;
  if(iop==1)
    {
      PieceCnt[side]--;
      i=Pindex[sq];
      while(i<=PieceCnt[side])
        {
          PieceList[side][i]=PieceList[side][i+1];
          Pindex[PieceList[side][i]]=i;
          i++;
        }
    }
  else
    {
      PieceCnt[side]++;
      PieceList[side][PieceCnt[side]]=sq;
      Pindex[sq]=PieceCnt[side];
    }
}


void MakeMove (int side, struct_leaf* node, int* tempb, int* tempc, int* tempsf, int* tempst, int* INCscore)
{
  int  f;
  int  t;
  int  xside;
  int  ct;
  int  cf;
  xside=otherside[side];
  GameCnt++;
  f=node->f;
  t=node->t;
  epsquare=-1;
  FROMsquare=f;
  TOsquare=t;
  *INCscore=0;
  GameList[GameCnt].gmove=(f<<8) BOR t;
  if(node->flags BAND cstlmask)
    {
      GameList[GameCnt].piece=no_piece;
      GameList[GameCnt].ccolor=side;
      (void)castle(side,f,t,1);
    }
  else
    {
      *tempc=cColor[t];
      *tempb=board[t];
      *tempsf=svalue[f];
      *tempst=svalue[t];
      GameList[GameCnt].piece=*tempb;
      GameList[GameCnt].ccolor=*tempc;
      if(*tempc!=neutral)
        {
          UpdatePieceList(*tempc,t,1);
          if(*tempb==pawn)
            {
              --PawnCnt[*tempc][column(t)];
            }
          if(board[f]==pawn)
            {
              --PawnCnt[side][column(f)];
              ++PawnCnt[side][column(t)];
              cf=column(f);
              ct=column(t);
              if(PawnCnt[side][ct]>1+PawnCnt[side][cf])
                {
                  *INCscore-=15;
                }
              else if(PawnCnt[side][ct]<1+PawnCnt[side][cf])
                {
                  *INCscore+=15;
                }
              else if(ct==0||ct==7||PawnCnt[side][ct+ct-cf]==0)
                {
                  *INCscore-=15;
                }
            }
          mtl[xside]-=value[*tempb];
          if(*tempb==pawn)
            {
              pmtl[xside]-=valueP;
            }
          UpdateHashbd(xside,*tempb,-1,t);
          *INCscore+=*tempst;
          Mvboard[t]++;
        }
      cColor[t]=cColor[f];
      board[t]=board[f];
      svalue[t]=svalue[f];
      Pindex[t]=Pindex[f];
      PieceList[side][Pindex[t]]=t;
      cColor[f]=neutral;
      board[f]=no_piece;
      if(board[t]==pawn)
        {
          if(t-f==16)
            {
              epsquare=f+8;
            }
          else if(f-t==16)
            {
              epsquare=f-8;
            }
        }
      if((node->flags BAND promote))
        {
          board[t]=node->flags BAND pmask;
          if(board[t]==queen)
            {
              HasQueen[side]++;
            }
          else if(board[t]==rook)
            {
              HasRook[side]++;
            }
          else if(board[t]==bishop)
            {
              HasBishop[side]++;
            }
          else if(board[t]==knight)
            {
              HasKnight[side]++;
            }
          --PawnCnt[side][column(t)];
          mtl[side]+=value[board[t]]-valueP;
          pmtl[side]-=valueP;
          UpdateHashbd(side,pawn,f,-1);
          UpdateHashbd(side,board[t],f,-1);
          *INCscore-=*tempsf;
        }
      if(node->flags BAND epmask)
        {
          EnPassant(xside,f,t,1);
        }
      else
        {
          UpdateHashbd(side,board[t],f,t);
        }
      Mvboard[f]++;
    }
}


void UnmakeMove (int side, struct_leaf* node, int* tempb, int* tempc, int* tempsf, int* tempst)
{
  int  f;
  int  t;
  int  xside;
  xside=otherside[side];
  f=node->f;
  t=node->t;
  epsquare=-1;
  GameCnt--;
  if(node->flags BAND cstlmask)
    {
      (void)castle(side,f,t,2);
    }
  else
    {
      cColor[f]=cColor[t];
      board[f]=board[t];
      svalue[f]=*tempsf;
      Pindex[f]=Pindex[t];
      PieceList[side][Pindex[f]]=f;
      cColor[t]=*tempc;
      board[t]=*tempb;
      svalue[t]=*tempst;
      if(node->flags BAND promote)
        {
          board[f]=pawn;
          ++PawnCnt[side][column(t)];
          mtl[side]+=valueP-value[node->flags BAND pmask];
          pmtl[side]+=valueP;
          UpdateHashbd(side,(int)node->flags BAND pmask,-1,t);
          UpdateHashbd(side,pawn,-1,t);
        }
      if(*tempc!=neutral)
        {
          UpdatePieceList(*tempc,t,2);
          if(*tempb==pawn)
            {
              ++PawnCnt[*tempc][column(t)];
            }
          if(board[f]==pawn)
            {
              --PawnCnt[side][column(t)];
              ++PawnCnt[side][column(f)];
            }
          mtl[xside]+=value[*tempb];
          if(*tempb==pawn)
            {
              pmtl[xside]+=valueP;
            }
          UpdateHashbd(xside,*tempb,-1,t);
          Mvboard[t]--;
        }
      if(node->flags BAND epmask)
        {
          EnPassant(xside,f,t,2);
        }
      else
        {
          UpdateHashbd(side,board[f],f,t);
        }
      Mvboard[f]--;
      if(!(node->flags BAND capture)&&(board[f]!=pawn))
        {
          rpthash[side][hashkey BAND 0xFF]--;
        }
    }
}


void InitializeStats (void)
{
  int  i;
  int  sq;
  epsquare=-1;
  i=0;
  while(i<8)
    {
      PawnCnt[white][i]=PawnCnt[black][i]=0;
      i++;
    }
  mtl[white]=mtl[black]=pmtl[white]=pmtl[black]=0;
  PieceCnt[white]=PieceCnt[black]=0;
  hashbd=hashkey=0;
  sq=0;
  while(sq<64)
    {
      if(cColor[sq]!=neutral)
        {
          mtl[cColor[sq]]+=value[board[sq]];
          if(board[sq]==pawn)
            {
              pmtl[cColor[sq]]+=valueP;
              ++PawnCnt[cColor[sq]][column(sq)];
            }
          if(board[sq]==king)
            {
              Pindex[sq]=0;
            }
          else
            {
              Pindex[sq]=++PieceCnt[cColor[sq]];
            }
          PieceList[cColor[sq]][Pindex[sq]]=sq;
          hashbd=hashbd^(hashcode+cColor[sq]*7*64+board[sq]*64+sq)->bd;
          hashkey=hashkey^(hashcode+cColor[sq]*7*64+board[sq]*64+sq)->key;
        }
      sq++;
    }
}


int SqAtakd (int sq, int side)
{
  int  u;
  UCHAR*  ppos;
  UCHAR*  pdir;
  int  xside;
  xside=otherside[side];
  pdir=nextdir+ptype[xside][pawn]*64*64+sq*64;
  u=pdir[sq];
  if(u!=sq)
    {
      if(board[u]==pawn&&cColor[u]==side)
        {
          return (TRUE);
        }
      u=pdir[u];
      if(u!=sq&&board[u]==pawn&&cColor[u]==side)
        {
          return (TRUE);
        }
    }
  if(distance(sq,PieceList[side][0])==1)
    {
      return (TRUE);
    }
  ppos=nextpos+bishop*64*64+sq*64;
  pdir=nextdir+bishop*64*64+sq*64;
  u=ppos[sq];
  while(1)
    {
      if(cColor[u]==neutral)
        {
          u=ppos[u];
        }
      else
        {
          if(cColor[u]==side&&(board[u]==queen||board[u]==bishop))
            {
              return (TRUE);
            }
          u=pdir[u];
        }
      if(!(u!=sq))
        {
          break;
        }
    }
  ppos=nextpos+rook*64*64+sq*64;
  pdir=nextdir+rook*64*64+sq*64;
  u=ppos[sq];
  while(1)
    {
      if(cColor[u]==neutral)
        {
          u=ppos[u];
        }
      else
        {
          if(cColor[u]==side&&(board[u]==queen||board[u]==rook))
            {
              return (TRUE);
            }
          u=pdir[u];
        }
      if(!(u!=sq))
        {
          break;
        }
    }
  pdir=nextdir+knight*64*64+sq*64;
  u=pdir[sq];
  while(1)
    {
      if(cColor[u]==side&&board[u]==knight)
        {
          return (TRUE);
        }
      u=pdir[u];
      if(!(u!=sq))
        {
          break;
        }
    }
  return (FALSE);
}


void ataks (int side, int* a)
{
  int  u;
  int  c;
  int  sq;
  UCHAR*  ppos;
  UCHAR*  pdir;
  int  i;
  int  piece;
  int*  PL;
  memset((char*)a,0,64*sizeof(a[0]));
  PL=PieceList[side];
  i=PieceCnt[side];
  while(i>=0)
    {
      sq=PL[i];
      piece=board[sq];
      c=ccontrol[piece];
      if(sweep[piece])
        {
          ppos=nextpos+piece*64*64+sq*64;
          pdir=nextdir+piece*64*64+sq*64;
          u=ppos[sq];
          while(1)
            {
              a[u]=++a[u] BOR c;
 u = (cColor[u] == neutral ) ? ppos[u] : pdir[u] ;
              if(!(u!=sq))
                {
                  break;
                }
            }
        }
      else
        {
          pdir=nextdir+ptype[side][piece]*64*64+sq*64;
          u=pdir[sq];
          while(1)
            {
              a[u]=++a[u] BOR c;
              u=pdir[u];
              if(!(u!=sq))
                {
                  break;
                }
            }
        }
      i--;
    }
}


int parse (FILE* fd, UINT* mv, int side)
{
  int  c;
  int  i;
  int  r1;
  int  r2;
  int  c1;
  int  c2;
  char  s[100];
  c=getc(fd);
  while(c==32)
    {
      c=getc(fd);
    }
  i=0;
  s[0]=(char)c;
  while(c!=32&&c!=10&&c!=CEOF)
    {
      s[++i]=(char)(c=getc(fd));
    }
  s[++i]=0;
  if(c==CEOF)
    {
      return (-1);
    }
  if(s[0]==33||s[0]==59||i<3)
    {
      while(c!=10&&c!=CEOF)
        {
          c=getc(fd);
        }
      return (0);
    }
  if(s[4]==111)
    {
      if(side==black)
        {
          *mv=0x3C3A;
        }
      else
        {
          *mv=0x0402;
        }
    }
  else if((s[0]==111))
    {
      if((side==black))
        {
          *mv=0x3C3E;
        }
      else
        {
          *mv=0x0406;
        }
    }
  else
    {
      c1=s[0]-97;
      r1=s[1]-49;
      c2=s[2]-97;
      r2=s[3]-49;
      *mv=(locn(r1,c1)<<8) BOR locn(r2,c2);
    }
  return (1);
}


void repetition (int* cnt)
{
  int     i;
  int     c;
  int     f;
  int     t;
  int  b[64];
  UINT  m;
  *cnt=c=0;
  if(GameCnt>Game50+3)
    {
      memset((char*)b,0,sizeof(b));;
      i=GameCnt;
      while(i>Game50)
        {
          m=GameList[i].gmove;;
          f=m>>8;;
          t=m&0xFF;;
          if(++b[f]==0)
            {
              c--;
            }
          else
            {
              c++;
            }
          if(--b[t]==0)
            {
              c--;
            }
          else
            {
              c++;
            }
          if(c==0)
            {
              (*cnt)++;
            }
          i--;
        }
    }
}


HWND StatDialog (HWND hWnd, HANDLE hInst)
{
  FARPROC  lpProcStat;
  lpProcStat=(FARPROC)MakeProcInstance(StatDlgProc,hInst);
  hStats=CreateDialog(hInst,MAKEINTRESOURCE(STATS),hWnd,(DLGPROC)lpProcStat);
  return (hStats);
}


long CALLBACK StatDlgProc (HWND hDlg, UINT message, UINT wParam, long lParam)
{
  UNREFERENCED_PARAMETER(lParam);
  while(1)
  {
    if((message)==WM_INITDIALOG)
      {
        SetDlgItemText(hDlg,DEPTHTEXT," ");
        SetDlgItemText(hDlg,POSITIONTEXT," ");
        SetDlgItemText(hDlg,NODETEXT," ");
        SetDlgItemText(hDlg,BSTLINETEXT," ");
        SetDlgItemText(hDlg,SCORETEXT," ");
        SetDlgItemText(hDlg,NODESECTEXT," ");
        return (TRUE);
      }
    if((message)==WM_SYSCOMMAND)
      {
        if((wParam BAND 0xfff0)==SC_CLOSE)
          {
            DestroyWindow(hDlg);
            return TRUE;
          }
        break;
      }
    if((message)==WM_DESTROY)
      {
        hStats=NULL;
        flag.post=FALSE;
      }
    break;
  }
  return (FALSE);
}


int TimeControlDialog (HWND hWnd, HANDLE hInst, DWORD Param)
{
  FARPROC  lpProcTime;
  int  status;
  lpProcTime=(FARPROC)MakeProcInstance(TimeControlDlgProc,hInst);
  status=DialogBoxParam(hInst,MAKEINTRESOURCE(TIMECONTROL),hWnd,(DLGPROC)lpProcTime,Param);
  FreeProcInstance(lpProcTime);
  return status;
}


long CALLBACK TimeControlDlgProc (HWND hDlg, UINT message, UINT wParam, long lParam)
{
  UNREFERENCED_PARAMETER(lParam);
  while(1)
  {
    if((message)==WM_INITDIALOG)
      {
        CheckRadioButton(hDlg,TMDLG_1MOV,TMDLG_60MOV,TCmoves+TMDLG_MOV);
        CheckRadioButton(hDlg,TMDLG_5MIN,TMDLG_600MIN,TCminutes+TMDLG_MIN);
        tmpTCminutes=TCminutes;
        tmpTCmoves=TCmoves;
        return (TRUE);
      }
    if((message)==WM_SYSCOMMAND)
      {
        if((wParam BAND 0xfff0)==SC_CLOSE)
          {
            EndDialog(hDlg,(int)NULL);
            return TRUE;
          }
        break;
      }
    if((message)==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==IDOK)
            {
              TCminutes=tmpTCminutes;
              TCmoves=tmpTCmoves;
              EndDialog(hDlg,1);
              return TRUE;
            }
          if((LOWORD(wParam))==IDCANCEL)
            {
              EndDialog(hDlg,(int)NULL);
              return TRUE;
            }
          if((LOWORD(wParam))==TMDLG_1MOV||(LOWORD(wParam))==TMDLG_10MOV||(LOWORD(wParam))==TMDLG_20MOV||(LOWORD(wParam))==TMDLG_40MOV||(LOWORD(wParam))==TMDLG_60MOV)
            {
              tmpTCmoves=wParam-TMDLG_MOV;
              CheckRadioButton(hDlg,TMDLG_1MOV,TMDLG_60MOV,wParam);
              break;
            }
          if((LOWORD(wParam))==TMDLG_5MIN||(LOWORD(wParam))==TMDLG_15MIN||(LOWORD(wParam))==TMDLG_30MIN||(LOWORD(wParam))==TMDLG_60MIN||(LOWORD(wParam))==TMDLG_600MIN)
            {
              tmpTCminutes=wParam-TMDLG_MIN;
              CheckRadioButton(hDlg,TMDLG_5MIN,TMDLG_600MIN,wParam);
            }
          break;
        }
      }
    break;
  }
  return (FALSE);
}


int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR CmdLine, int CmdShow)
{
  HWND  hWnd;
  MSG  msg;
  POINT  pt;
  CmdLine++;
  if(!hPrev)
    {
      if(!ChessInit(hInst))
        {
          return (FALSE);
        }
    }
  ghInst=hInst;
  QueryBoardSize( &pt);
  hWnd=CreateWindow(szAppName,szAppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,(HMENU)NULL,hInst,NULL);
  if(!hWnd)
    {
      return FALSE;
    }
  ShowWindow(hWnd,CmdShow);
  if(init_main(hWnd))
    {
      SMessageBox(hWnd,IDS_INITERROR,IDS_CHESS);
      FreeChessGlobals();
      return FALSE;
    }
  UpdateWindow(hWnd);
  player=opponent;
  ShowSidetoMove();
  while(GetMessage( &msg,NULL,0,0))
    {
      TranslateMessage( &msg);
      DispatchMessage( &msg);
    }
  return (int)msg.wParam;
}


long CALLBACK ChessWndProc (HWND hWnd, UINT message, UINT wParam, long lParam)
{
  FARPROC  lpProcAbout;
  HMENU  hMenu;
  PAINTSTRUCT  ps;
  HDC  hDC;
  TEXTMETRIC  tm;
  int  i;
  POINT  point;
  OFSTRUCT  pof;
  char  FileName[256];
  char  sstr[80];
  DWORD  Status;
  HANDLE  hFile;
  while(1)
  {
    if(message==WM_CREATE)
      {
        int  xchar;
        int  ychar;
        GetStartupColors(szAppName);
        hBrushBackGround=CreateSolidBrush(clrBackGround);
        i=pawn;
        while(i<pawn+6)
          {
            pieces[i].piece=LoadBitmap(ghInst,MAKEINTRESOURCE(PAWNBASE+i));
            i++;
          }
        i=pawn;
        while(i<pawn+6)
          {
            pieces[i].mask=LoadBitmap(ghInst,MAKEINTRESOURCE(PAWNBASE+6+i));
            i++;
          }
        i=pawn;
        while(i<pawn+6)
          {
            pieces[i].outline=LoadBitmap(ghInst,MAKEINTRESOURCE(PAWNBASE+12+i));
            i++;
          }
        hDC=GetDC(hWnd);
        GetTextMetrics(hDC, &tm);
        xchar=tm.tmMaxCharWidth;
        ychar=tm.tmHeight+tm.tmExternalLeading;
        QueryBoardSize( &point);
        SetWindowPos(hWnd,hWnd,0,0,point.x+GetSystemMetrics(SM_CXFRAME)*2+50,point.y+GetSystemMetrics(SM_CYFRAME)*2+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYCAPTION)+ychar,SWP_NOMOVE BOR SWP_NOZORDER);
        ReleaseDC(hWnd,hDC);
        InitHitTest();
        Create_Children(hWnd,ghInst,xchar,ychar);
        break;
      }
    if(message==WM_DESTROY)
      {
        DeleteObject(hBrushBackGround);
        Hittest_Destructor();
        if(hBook)
          {
            FreeBook();
          }
        FreeChessGlobals();
        SaveColors(szAppName);
        Running=FALSE;
        PostQuitMessage(0);
        break;
      }
    if(message==WM_PAINT)
      {
        if(FirstSq!=-1)
          {
            POINT  pt;
            RECT  rect;
            QuerySqOrigin(FirstSq % 8,FirstSq/8, &pt);
            rect.left=pt.x;
            rect.right=pt.x+48;
            rect.top=pt.y-48;
            rect.bottom=pt.y;
            InvalidateRect(hWnd, &rect,FALSE);
          }
        hDC=BeginPaint(hWnd, &ps);
        Draw_Board(hDC,flag.reverse,clrBlackSquare,clrWhiteSquare);
        if(coords)
          {
            DrawCoords(hDC,flag.reverse,clrBackGround,clrText);
          }
        DrawAllPieces(hDC,flag.reverse,boarddraw,colordraw,clrBlackPiece,clrWhitePiece);
        EndPaint(hWnd, &ps);
        if(FirstSq!=-1)
          {
            HiliteSquare(hWnd,FirstSq);
          }
        break;
      }
    if(message==WM_CTLCOLORSTATIC)
      {
        POINT  point;
        SetBkColor((HDC)wParam,clrBackGround);
        SetBkMode((HDC)wParam,TRANSPARENT);
        SetTextColor((HDC)wParam,clrText);
        point.x=point.y=0;
        ClientToScreen(hWnd, &point);
        SetBrushOrgEx((HDC)wParam,point.x,point.y, &point);
        return ((long)hBrushBackGround);
      }
    if(message==WM_ERASEBKGND)
      {
        RECT  rect;
        GetClientRect(hWnd, &rect);
        FillRect((HDC)wParam, &rect,hBrushBackGround);
        return 1;
      }
    if(message==WM_INITMENUPOPUP)
      {
        if(User_Move)
          {
            flag.timeout=TRUE;
            flag.bothsides=FALSE;
          }
        if(!EditActive)
          {
            Init_Menus(hWnd,wParam,lParam);
          }
        break;
      }
    if(message==WM_LBUTTONDOWN)
      {
        if(User_Move)
          {
            flag.timeout=TRUE;
            flag.bothsides=FALSE;
          }
        if(!(EditActive||User_Move))
          {
            break;
          }
        point.x=LOWORD(lParam);
        point.y=HIWORD(lParam);
        int  Hit;
        Hit=HitTest(point.x,point.y);
        if(Hit==-1)
          {
            if(FirstSq!=-1)
              {
                UnHiliteSquare(hWnd,FirstSq);
                GotFirst=FALSE;
                FirstSq=-1;
              }
            break;
          }
        if(GotFirst)
          {
            UnHiliteSquare(hWnd,FirstSq);
            GotFirst=FALSE;
            if(EditActive==TRUE)
              {
                PostMessage(hWnd,MSG_EDITBOARD,((FirstSq<<8)|Hit),(long)NULL);
              }
            else if(User_Move==TRUE)
              {
                PostMessage(hWnd,MSG_USER_ENTERED_MOVE,((FirstSq<<8)|Hit),(long)NULL);
              }
            FirstSq=-1;
          }
        else
          {
            GotFirst=TRUE;
            FirstSq=Hit;
            HiliteSquare(hWnd,Hit);
          }
        break;
      }
    if(message==MSG_EDITBOARD)
      {
        int  Square;
        int  First;
        if(flag.reverse)
          {
            First=63-((wParam>>8)&0xff);
            Square=63-(wParam BAND 0xff);
          }
        else
          {
            First=(wParam>>8)&0xff;
            Square=wParam BAND 0xff;
          }
        board[Square]=board[First];
        cColor[Square]=cColor[First];
        board[First]=no_piece;
        cColor[First]=neutral;
        UpdateDisplay(hWnd,First,Square,FALSE,FALSE);
        break;
      }
    if(message==MSG_USER_MOVE)
      {
        if(flag.bothsides&&!flag.mate)
          {
            SelectMove(hWnd,opponent,1);
            if(flag.beep)
              {
                MessageBeep(0);
              }
            PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
          }
        else if(!flag.mate)
          {
            User_Move=TRUE;
            ft=0;
            player=opponent;
            ShowSidetoMove();
            int  tmp;
            UINT  mv;
            char  s[10];
            if(hint>0&&!flag.easy&&Book==NULL)
              {
                MessageBeep(-1);
                time0=time(NULL);
                algbr(hint>>8,hint BAND 0xff,FALSE);
                lstrcpy(s,mvstr[0]);
                tmp=epsquare;
                if(VerifyMove(hWnd,s,1, &mv))
                  {
                    SelectMove(hWnd,computer,2);
                    VerifyMove(hWnd,mvstr[0],2, &mv);
                    if(Sdepth>0)
                      {
                        Sdepth--;
                      }
                  }
                ft=time(NULL)-time0;
                epsquare=tmp;
              }
          }
        break;
      }
    if(message==MSG_USER_ENTERED_MOVE)
      {
        int  temp;
        UINT  mv;
        int  Square;
        int  First;
        char  s[10];
        int  algbr_flag;
        User_Move=FALSE;
        player=opponent;
        if(flag.reverse)
          {
            First=63-((wParam>>8) BAND 0xff);
            Square=63-(wParam BAND 0xff);
          }
        else
          {
            First=(wParam>>8) BAND 0xff;
            Square=wParam BAND 0xff;
          }
        if((board[First]==pawn)&&((Square<8)||(Square>55)))
          {
            algbr_flag=promote+PromoteDialog(hWnd,ghInst);
          }
        else
          {
            algbr_flag=0;
          }
        algbr(First,Square,algbr_flag);
        strcpy(s,mvstr[0]);
        temp=VerifyMove(hWnd,s,0, &mv);
        if(temp&&(mv!=hint))
          {
            Sdepth=0;
            ft=0;
            ElapsedTime(1);
            PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
          }
        else if(temp==TRUE)
          {
            ElapsedTime(1);
            PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
          }
        else
          {
            PostMessage(hWnd,MSG_USER_MOVE,(UINT)NULL,(long)NULL);
          }
        break;
      }
    if(message==MSG_COMPUTER_MOVE)
      {
        if(!(flag.quit||flag.mate||flag.force))
          {
            SelectMove(hWnd,computer,1);
            if(flag.beep)
              {
                MessageBeep(0);
              }
          }
        PostMessage(hWnd,MSG_USER_MOVE,(UINT)NULL,(long)NULL);
        break;
      }
    if(message==WM_COMMAND)
      {
        while(1)
        {
          if((LOWORD(wParam))==MSG_CHESS_QUIT)
            {
              DestroyWindow(hWnd);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_HINT)
            {
              GiveHint(hWnd);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_LIST)
            {
              if(!DoFileSaveDlg(ghInst,hWnd,"chess.lst",".lst", &Status,FileName, &pof))
                {
                  break;
                }
              if(Status==1)
                {
                  strcpy(sstr,"Replace Existing ");
                  strcat(sstr,FileName);
                  if(MessageBox(hWnd,sstr,szAppName,MB_YESNO BOR MB_ICONQUESTION BOR MB_APPLMODAL)==IDNO)
                    {
                      break;
                    }
                }
              else
                {
                  OpenFile(FileName, &pof,OF_PARSE);
                }
              ListGame(hWnd,pof.szPathName);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_SAVE)
            {
              if(!DoFileSaveDlg(ghInst,hWnd,"chess.chs",".chs", &Status,FileName, &pof))
                {
                  break;
                }
              if(Status==1)
                {
                  strcpy(sstr,"Replace Existing ");
                  strcat(sstr,FileName);
                  if(MessageBox(hWnd,sstr,szAppName,MB_YESNO BOR MB_ICONQUESTION BOR MB_APPLMODAL)==IDNO)
                    {
                      break;
                    }
                }
              else
                {
                  OpenFile(FileName, &pof,OF_PARSE);
                }
              SaveGame(hWnd,pof.szPathName);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_GET)
            {
              if(!DoFileOpenDlg(ghInst,hWnd,"*.chs",".chs",0x0,FileName, &pof))
                {
                  break;
                }
              hFile=(HANDLE)((long)OpenFile(FileName, &pof,(WORD)OF_READ BOR OF_REOPEN));
              if(hFile==((HANDLE)-1))
                {
                  strcpy(sstr,"Cannot open file: ");
                  strcat(sstr,FileName);
                  MessageBox(hWnd,sstr,szAppName,MB_OK BOR MB_APPLMODAL BOR MB_ICONQUESTION);
                  break;
                }
              CloseHandle(hFile);
              GetGame(hWnd,pof.szPathName);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_NEW)
            {
              NewGame(hWnd);
              if(hBook)
                {
                  FreeBook();
                }
              GetOpenings(hWnd);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_ABOUT)
            {
              lpProcAbout=(FARPROC)MakeProcInstance(About,ghInst);
              DialogBox(ghInst,MAKEINTRESOURCE(AboutBox),hWnd,(DLGPROC)(DLGPROC)lpProcAbout);
              FreeProcInstance(lpProcAbout);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_EDIT)
            {
              EditActive=TRUE;
              hMenu=CreateMenu();
              AppendMenu(hMenu,MF_STRING,MSG_CHESS_EDITDONE,"&Done");
              hMainMenu=GetMenu(hWnd);
              SetMenu(hWnd,hMenu);
              DrawMenuBar(hWnd);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_EDITDONE)
            {
              EditActive=FALSE;
              hMenu=GetMenu(hWnd);
              SetMenu(hWnd,hMainMenu);
              DrawMenuBar(hWnd);
              DestroyMenu(hMenu);
              GameCnt=0;
              Game50=1;
              ZeroRPT();
              Sdepth=0;
              InitializeStats();
              PostMessage(hWnd,MSG_USER_MOVE,(UINT)NULL,(long)NULL);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_REVIEW)
            {
              ReviewDialog(hWnd,ghInst);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_HASH)
            {
              flag.hash=!flag.hash;
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_BEEP)
            {
              flag.beep=!flag.beep;
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_COORD)
            {
              coords=!coords;
              UpdateDisplay(hWnd,0,0,1,0);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_BOTH)
            {
              flag.bothsides=!flag.bothsides;
              flag.easy=TRUE;
              Sdepth=0;
              PostMessage(hWnd,MSG_USER_MOVE,(UINT)NULL,(long)NULL);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_BOOK)
            {
              if(Book!=NULL)
                {
                  FreeBook();
                  Book=NULL;
                }
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_POST)
            {
              if(flag.post)
                {
                  SendMessage(hStats,(UINT)WM_SYSCOMMAND,(WPARAM)SC_CLOSE,(LPARAM)0);
                  flag.post=FALSE;
                }
              else
                {
                  StatDialog(hWnd,ghInst);
                  flag.post=TRUE;
                }
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_AWIN)
            {
              char  sstr[40];
              LoadString((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),IDS_SETAWIN,sstr,sizeof(sstr)),Awindow=DoGetNumberDlg(ghInst,hWnd,sstr,Awindow);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_BWIN)
            {
              char  sstr[40];
              LoadString((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),IDS_SETBWIN,sstr,sizeof(sstr)),Bwindow=DoGetNumberDlg(ghInst,hWnd,sstr,Bwindow);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_CONTEMP)
            {
              char  sstr[40];
              LoadString((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),IDS_SETCONTEMPT,sstr,sizeof(sstr));
              contempt=DoGetNumberDlg(ghInst,hWnd,sstr,contempt);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_UNDO)
            {
              if(GameCnt>0)
                {
                  Undo(hWnd);
                }
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_REMOVE)
            {
              if(GameCnt>1)
                {
                  Undo(hWnd);
                  Undo(hWnd);
                }
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_FORCE)
            {
              computer=opponent;
              opponent=otherside[computer];
              ShowPlayers();
              PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_RANDOM)
            {
              if(dither==0)
                {
                  dither=6;
                }
              else
                {
                  dither=0;
                }
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_EASY)
            {
              flag.easy=!flag.easy;
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_DEPTH)
            {
              char  sstr[40];
              LoadString((HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE),IDS_MAXSEARCH,sstr,sizeof(sstr));
              MaxSearchDepth=DoGetNumberDlg(ghInst,hWnd,sstr,MaxSearchDepth);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_REVERSE)
            {
              flag.reverse=!flag.reverse;
              ShowPlayers();
              UpdateDisplay(hWnd,0,0,1,0);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_SWITCH)
            {
              computer=otherside[computer];
              opponent=otherside[opponent];
              flag.force=FALSE;
              Sdepth=0;
              ShowPlayers();
              PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_BLACK)
            {
              computer=black;
              opponent=white;
              flag.force=FALSE;
              Sdepth=0;
              ShowPlayers();
              PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_WHITE)
            {
              computer=white;
              opponent=black;
              flag.force=FALSE;
              Sdepth=0;
              ShowPlayers();
              PostMessage(hWnd,MSG_COMPUTER_MOVE,(UINT)NULL,(long)NULL);
              break;
            }
          if((LOWORD(wParam))==MSG_CHESS_ABORT)
            {
              flag.timeout=TRUE;
              flag.bothsides=FALSE;
              EnableMenuItem(GetMenu(hWnd),MENU_ID_ABORT,MF_GRAYED BOR MF_DISABLED BOR MF_BYPOSITION);
              DrawMenuBar(hWnd);
              break;
            }
          if((LOWORD(wParam))==IDM_BACKGROUND)
            {
              if(ColorDialog(hWnd,ghInst,wParam))
                {
                  InvalidateRect(hWnd,NULL,TRUE);
                  DeleteObject(hBrushBackGround);
                  hBrushBackGround=CreateSolidBrush(clrBackGround);
                  InvalidateRect(hComputerColor,NULL,TRUE);
                  InvalidateRect(hComputerMove,NULL,TRUE);
                  InvalidateRect(hWhosTurn,NULL,TRUE);
                  InvalidateRect(hClockHuman,NULL,TRUE);
                  InvalidateRect(hClockComputer,NULL,TRUE);
                  InvalidateRect(hMsgComputer,NULL,TRUE);
                  InvalidateRect(hMsgHuman,NULL,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDM_BLACKSQUARE)
            {
              if(ColorDialog(hWnd,ghInst,wParam))
                {
                  InvalidateRect(hWnd,NULL,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDM_WHITESQUARE)
            {
              if(ColorDialog(hWnd,ghInst,wParam))
                {
                  InvalidateRect(hWnd,NULL,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDM_BLACKPIECE)
            {
              if(ColorDialog(hWnd,ghInst,wParam))
                {
                  InvalidateRect(hWnd,NULL,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDM_WHITEPIECE)
            {
              if(ColorDialog(hWnd,ghInst,wParam))
                {
                  InvalidateRect(hWnd,NULL,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDM_TEXT)
            {
              if(ColorDialog(hWnd,ghInst,wParam))
                {
                  InvalidateRect(hWnd,NULL,TRUE);
                  InvalidateRect(hComputerColor,NULL,TRUE);
                  InvalidateRect(hComputerMove,NULL,TRUE);
                  InvalidateRect(hWhosTurn,NULL,TRUE);
                  InvalidateRect(hClockHuman,NULL,TRUE);
                  InvalidateRect(hClockComputer,NULL,TRUE);
                  InvalidateRect(hMsgComputer,NULL,TRUE);
                  InvalidateRect(hMsgHuman,NULL,TRUE);
                }
              break;
            }
          if((LOWORD(wParam))==IDM_DEFAULT)
            {
              SetStandardColors();
              InvalidateRect(hWnd,NULL,TRUE);
              DeleteObject(hBrushBackGround);
              hBrushBackGround=CreateSolidBrush(clrBackGround);
              InvalidateRect(hComputerColor,NULL,TRUE);
              InvalidateRect(hComputerMove,NULL,TRUE);
              InvalidateRect(hWhosTurn,NULL,TRUE);
              InvalidateRect(hClockHuman,NULL,TRUE);
              InvalidateRect(hClockComputer,NULL,TRUE);
              InvalidateRect(hMsgComputer,NULL,TRUE);
              InvalidateRect(hMsgHuman,NULL,TRUE);
              break;
            }
          if((LOWORD(wParam))==IDM_TIMECONTROL)
            {
              if(TimeControlDialog(hWnd,ghInst,wParam))
                {
                  TCflag=(TCmoves>1);
                  if(TCflag)
                    {
                    }
                  SetTimeControl();
                }
            }
          break;
        }
      }
    break;
  }
  return DefWindowProc(hWnd,message,wParam,lParam);
}


